#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>
#include <string.h>

#define MAX_LOG_ROWS    50
#define PPPOE_LOCK_FILE   "/tmp/log_web.lck"
#define PPPOE_LOG_FILE   "/tmp/log_web"

// lock file, log_file, log message
int main(int argc, char **argv)
{
 int fd_lock;
 FILE *fp_log;
 char pid[5];
 time_t t_c;
 char timebuf[26],*log_mesg;
time_t t_offset = 0;
int scroll_flag=0;
int mesg_len;

//printf("argc=%d, argv[0]=%s, argv[1]=%s , argv[2]=%s, argv[3]=%s\n",argc,argv[0],argv[1],argv[2],argv[3]);


 if ( argc < 4 )
        {
        printf("Usage: exlog   lock_file       log_file        log_message\n");
        exit(1);
        }
 // mark tien's time trick
	FILE *mfp = fopen("/tmp/time/offset", "r");
	if (mfp ) {
		fscanf(mfp,"%d\n",&t_offset);
		fclose(mfp);
	}
  mesg_len = strlen(argv[3]);
 log_mesg = malloc(mesg_len+32);
 strcpy(log_mesg, argv[3]);

 int count=0;
 while (1)
       {
        fd_lock = open(argv[1],O_WRONLY | O_CREAT | O_EXCL, 0644);
        if ( fd_lock<0 && errno==EEXIST )
           {
            printf("exlog(): Already locked!\n");
            sleep(1);
        if (count>10)
           {
            unlink(argv[1]);
            count=0;
           }
            count++;
           }
        else if ( fd_lock<0 )
                 printf("exlog(main.c): Unexpected error!\n");
        else
            {

             t_c = time(0) + t_offset; // current-time
             //printf("exlog(): %d secs\n",t_c);
             snprintf(timebuf,sizeof(timebuf),"%.24s ",ctime(&t_c));

             sprintf(pid,"%d",getpid());
             write(fd_lock,pid,strlen(pid));

             if ( row_size(argv[2]) > MAX_LOG_ROWS )     // the max. no. of rows
                        {
                        printf("exlog(): Execeed the max., begin to scroll messages!\n");
                        scroll_flag = 1;
                        }
             if ( scroll_flag == 0 )    // log directly
                {
                if (!(fp_log = fopen(argv[2], "a")))
                        {
                        printf("exlog(): Can not find /tmp/log_web\n");
                        unlink(argv[1]);
                        free(log_mesg);
                        return errno;
                        }
                fprintf(fp_log,"%s-%s\n",timebuf,log_mesg);
                printf("exlog(): Loged message(%s) into %s directly\n",log_mesg,argv[1]);
		fclose(fp_log);
                }
             else       //scroll log
                {
                 scroll_log(timebuf,log_mesg);
                }
             //printf("exlog(): %s %s\n",timebuf,argv[3]);
             close(fd_lock);
             unlink(argv[1]);
             //printf("exlog(): Loged message(%s) into %s!\n",argv[3],argv[2]);
             break;
            }
       }//Wait for log file
 exit(0);
}


// check log file's row size
int row_size(char *file)
{
 int rows=0;
 char time[32],mesg[100];
 FILE *fp = fopen(file, "r");
//printf("row_size():begin\n");
 if (fp )
        {
	while ( fscanf(fp,"%63[^-] - %191[^\n]\n",time,mesg) != EOF )
                {
                rows++;
                //printf("row_size(): %s\n",mesg);
                }
        fclose(fp);

        printf("row_size(): rows = %d\n",rows);
        return (rows);
	}
 else
        {
        printf("row_size(): Can't open %s\n",file);
        return 0;
        }

}

void scroll_log(char *timebuf, char *log_mesg)
{
 int fd,first_line=0,len;
 char ch, *buf;
 struct stat statbuf;
 FILE   *fp_log;


 if ( (fd=open(PPPOE_LOG_FILE,O_RDWR,0644)) < 0 )
     {
      printf("scroll_log(): open error!\n");
      return -1;
     }
 while ( read(fd,&ch,1) > 0 )
        {
         //printf("%c\n",ch);
         if ( ch == '\n' )
            {
             printf("scroll_log(): the first line have %d characters\n",first_line);
             break;
            }
         else
             first_line++;
        }
 first_line++;
 if ( lstat(PPPOE_LOG_FILE,&statbuf) )
        {
         printf("scroll_log(): Can't lstat\n");
        }
 buf = malloc(statbuf.st_size);
 lseek(fd,first_line,SEEK_SET);
 len = read(fd,buf,statbuf.st_size);
 //printf("scroll_log(): Current log: %s, %d bytes\n",buf,len);
 ftruncate(fd,0);
 lseek(fd,0,SEEK_SET);
 len = write(fd,buf,len);
 close(fd);

 if (!(fp_log = fopen(PPPOE_LOG_FILE, "a")))
        {
         printf("scroll_log(): Can not find /tmp/log_web\n");
         unlink(PPPOE_LOCK_FILE);
         free(log_mesg);
         fclose(fp_log);
         return errno;
        }
 fprintf(fp_log,"%s-%s\n",timebuf,log_mesg);
 printf("scroll_log(): Loged message(%s) into /tmp/log_web \n",log_mesg);
 fclose(fp_log);

}
