#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>
#include <wait.h>
//#include <error.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/un.h>
//#include <sys/types.h>
//#include <sys/stat.h>
#include <sys/select.h>
//#include <syslog.h>
#include <bcmnvram.h>

#define MAXLINE 16384	// kernel log buffer len since 2.1.113
#define LOG_LIMIT 32
#define PROTO_NULL 0
#define IPPROTO_ICMP 1
#define IPPROTO_TCP 6
#define IPPROTO_UDP 17
#define QUELEN 4
#define WEB_STRING 1
#define TFTP_STRING 0
#define SA struct sockaddr
#define max(x, y) ((x > y) ? x : y)

extern int errno;

typedef struct _log_list {
	char time[26];
	char cat[9];
	char macsrc[26];
	char macdst[26];
	char src[50];
	char dst[50];
	char proto[16];
	char spt[10];
	char dpt[10];
	int dirty;
} log_list;

typedef struct _log_data {
	short curr_pos;
	short roundup;
	log_list loglist[LOG_LIMIT];
} log_data;

char kmsgdev[] = "/proc/kmsg";
char log_pref[] = "rt190w";
char log_websock[] = "/tmp/log_websock";
time_t t_offset = 0;

//char logfile_strings[(sizeof(log_list)+10)*LOG_LIMIT];

int update_logdata(log_data *logdata, char *buf, char *timebuf);
int send_log(log_data *logdata);
char* get_tftp_filename();
int prepare_weblog_strings(log_data *logdata, char *ppstr);
int prepare_filelog_strings(log_data *logdata, char *ppstr);
int check_sendfile_cond(int *newitem_num);
int tftp_log();
char* get_tftp_server();
int send_web_strings(int connfd, log_data *logdata);
int delete_web_strings(int connfd, log_data *plogdata, int *pnewitem_num);

int
main(int argc, char **argv)
{
//	const int MAXLINE=810;	//ipt_LOG.c shows the max log string len is 807
	char buf[MAXLINE+1], buf1[MAXLINE+1], lastbuf[300];
	char timebuf[26], webfdchar;
	char *tmpbuf, *tmpbuf0, *tmpbuf1;
	int fp, fp0=0, fp1=0, maxfd=0, sockfd, connfd, flag=1;
	int rlen, accu_len, lendiff, maxline;
	fd_set rset;
	log_data logdata;
	time_t ticks, pre_ticks = 0;
	int newitem_num;
	struct sockaddr_un seraddr, cliaddr;
	int seralen, clialen;
	int i;
/*
	int ask_priority=0;
	char *pt = "This is a test";
*/

/*
	ask_priority = LOG_USER | LOG_NOTICE;
	printf("prio=%d\n",ask_priority);
	syslog(ask_priority,pt);
*/
        //gmluong, 08/31/02, it seems open() got a fd=0 here
        //try to avoid that
	fp0=fp1=open("/dev/null",O_RDONLY);
        while(fp1 < 2) {
                fp1 = open("/dev/null",O_RDONLY);
                if (fp1 < 0) {
                        perror("open");
                        exit(1);
                }
        }

	fp = open(kmsgdev,O_RDONLY);
	if (fp < 0) {
		printf("Can't open %s: %s\n",kmsgdev,strerror(errno));
		exit (1);
	}
	maxfd = max(maxfd, fp) + 1;
	sockfd = socket(AF_LOCAL, SOCK_STREAM, 0);
	if (sockfd < 0) {
		printf("Failed to open unix domain socket to web\n");
		exit (1);
	}
        if (setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &flag, sizeof(flag)) < 0) {
                printf("Failed to set sockopt on unix domain socket\n");
                exit (1);
        }
        for (i=fp0; i<=fp1; i++) close(i);

	memset(&seraddr, 0, sizeof(seraddr));
	unlink(log_websock);
	seraddr.sun_family = AF_LOCAL;
	strncpy(seraddr.sun_path, log_websock, sizeof(seraddr.sun_path) - 1);
	bind(sockfd, (SA *) &seraddr, sizeof(seraddr));
	listen(sockfd, QUELEN);
	maxfd = max(maxfd, sockfd) + 1;
	seralen = sizeof(seraddr);
	clialen = sizeof(cliaddr);
	FD_ZERO(&rset);
	maxline = MAXLINE;
	logdata.curr_pos = 0;
	logdata.roundup = 0;
	newitem_num = 0;
	lendiff = 0;
	rlen = 0;
	memset(buf, 0, sizeof(buf));
	memset(lastbuf, 0, sizeof(lastbuf));
	// gmluong, 08/22/02, mark tien's time trick
	{
	FILE *mfp = fopen("/tmp/time/offset", "r");
	if (mfp ) {
		fscanf(mfp,"%d\n",&t_offset);
		fclose(mfp);
	}
	}
	for ( ; ; ) {
		FD_SET(fp, &rset);
		FD_SET(sockfd, &rset);
		select(maxfd, &rset, NULL, NULL, NULL);
		if (FD_ISSET(fp, &rset)) {
//			printf("maxline=%d, maxfd=%d\n",maxline,maxfd);
			tmpbuf = buf + lendiff;
			rlen = read(fp, tmpbuf, maxline);
			if (rlen < 0) continue;
                        if (!(tmpbuf0 = strstr(buf,"\n"))) continue;
                        if ((tmpbuf0 - buf) > (rlen+lendiff)) continue;   // over limit
			accu_len = 0;
			tmpbuf = buf;
			do {
				*tmpbuf0++ = '\0';
				if (!(tmpbuf1 = strstr(tmpbuf, log_pref))) {
					accu_len += (strlen(tmpbuf) + 1);
					tmpbuf = tmpbuf0;
					continue;
				}
				ticks = time(NULL) + t_offset;
				if (ticks > pre_ticks) {
					pre_ticks = ticks;
					snprintf(timebuf,sizeof(timebuf),"%.24s ",ctime(&ticks));
				} else {
                                        if(!strcmp(lastbuf, tmpbuf1)) {
                                                accu_len += (strlen(tmpbuf) + 1);
                                                tmpbuf = tmpbuf0;
                                                continue;
                                        }
				}
				strcpy(lastbuf, tmpbuf1);
				accu_len += (strlen(tmpbuf) + 1);
				if (update_logdata(&logdata, tmpbuf, timebuf)) {
					fprintf(stderr,"update_logdata() RETURN ERROR!!!\n");
					printf("%s, %d, %d, tmpbuf=%s\n",logdata.loglist[logdata.curr_pos].time,rlen,accu_len,tmpbuf);
					tmpbuf = tmpbuf0;
					continue;
				}
//				printf("%s%s %s %s %s %s %s %s %s\n",logdata.loglist[logdata.curr_pos].time, logdata.loglist[logdata.curr_pos].cat, logdata.loglist[logdata.curr_pos].macsrc, logdata.loglist[logdata.curr_pos].macdst, logdata.loglist[logdata.curr_pos].src,logdata.loglist[logdata.curr_pos].dst,logdata.loglist[logdata.curr_pos].proto,logdata.loglist[logdata.curr_pos].spt,logdata.loglist[logdata.curr_pos].dpt);
				newitem_num++;
				if (check_sendfile_cond(&newitem_num)) {
					if (tftp_log()) {
						if (send_log(&logdata)) {
							printf("Failed to tftp file to outside\n");
						}
						
					}
				} 
//				printf("%s, %d, %d, tmpbuf=%s\n",logdata.loglist[logdata.curr_pos].time,rlen,accu_len,tmpbuf);
//				printf("pbuf=%ld, ptmpbuf=%ld\n",(void *)buf,(void *)tmpbuf);
//				printf("len(buf)=%d, buf=%s\n",rlen,buf);
				tmpbuf = tmpbuf0;
			} while ((tmpbuf0 = strstr(tmpbuf0,"\n")));
			if ((lendiff = (rlen + lendiff - accu_len)) > 0) {	
				tmpbuf = buf + accu_len;
				memset(buf1, 0, lendiff+1);
				memcpy(buf1, tmpbuf, lendiff);
				memcpy(buf, buf1, lendiff);
				maxline = MAXLINE - lendiff;
			} else {
				maxline = MAXLINE;
				lendiff = 0;
			}
		}
		if (FD_ISSET(sockfd, &rset)) {
			if ((connfd = accept(sockfd, (SA *)&cliaddr, &clialen)) < 0 ) {
				perror("accept");
				continue;
			}
			read(connfd, &webfdchar, 1);
			switch(webfdchar) {
			case '1':
				send_web_strings(connfd, &logdata);
			break;
			case 'd':
				delete_web_strings(connfd, &logdata, &newitem_num);
			break;
			case 't':
			// gmluong, 08/22/02, mark tien's time trick
			{
        			FILE *mfp = fopen("/tmp/time/offset", "r");
        			if (mfp ) {
                  			fscanf(mfp,"%d\n",&t_offset);
                  			fclose(mfp);
        			}
			}
			break;
			default:
			break;
			}
			close(connfd);
		}
	}
	exit (0);
}

int 
update_logdata(log_data *logdata, char *buf, char *timebuf)
{
	char *tok;
	short proto, curr;
	int record_done = 0, ip_rec_done = 0;
	
	curr = logdata->curr_pos;
	memset(&logdata->loglist[curr],0,sizeof(log_list));
	memcpy(&logdata->loglist[curr].time, timebuf, strlen(timebuf));
//	printf("curr=%d\n",curr);
	tok = strtok(buf, " \t");
	proto = PROTO_NULL;
	do {
		switch(proto) {
			case PROTO_NULL:
				if (strstr(tok,"CAT")) {
					memcpy(&logdata->loglist[curr].cat, tok, strlen(tok));
				} else if (strstr(tok, "MAC")) {
					memcpy(&logdata->loglist[curr].macdst,"MACDST=",7);
					if ((*(tok+4)) != '\0') {
						memcpy((char *)(logdata->loglist[curr].macdst+7), (char *)(tok+4), 17);
						memcpy(&logdata->loglist[curr].macsrc,"MACSRC=",7);
						memcpy((char *)(logdata->loglist[curr].macsrc+7), (char *)(tok+22), 17);
					} else {
						memcpy(&logdata->loglist[curr].macsrc,"MACSRC=",7);
					}
					
				} else if (strstr(tok,"SRC")) {
					memcpy(&logdata->loglist[curr].src, tok, strlen(tok));
				} else if (strstr(tok, "DST")) {
					memcpy(&logdata->loglist[curr].dst, tok, strlen(tok));
				} else if (strstr(tok, "PROTO")) {
					memcpy(&logdata->loglist[curr].proto, tok, strlen(tok));
					if ((strstr(tok, "ICMP")) || (strstr(tok, "ICMPv6"))) proto=IPPROTO_ICMP;
					else if (strstr(tok, "TCP")) proto=IPPROTO_TCP;
					else if (strstr(tok, "UDP")) proto=IPPROTO_UDP;
					ip_rec_done = 1;
				}
			break;
			case IPPROTO_ICMP:
				if (strstr(tok, "TYPE")) {
					memcpy(&logdata->loglist[curr].spt, tok, strlen(tok));
				} else if (strstr(tok, "CODE")) {
					memcpy(&logdata->loglist[curr].dpt, tok, strlen(tok));
					record_done = 1;
				}
			break;
			case IPPROTO_TCP:
			case IPPROTO_UDP:
				if (strstr(tok, "SPT")) {
					memcpy(&logdata->loglist[curr].spt, tok, strlen(tok));
				} else if (strstr(tok, "DPT")) {
					memcpy(&logdata->loglist[curr].dpt, tok, strlen(tok));
					record_done = 1;
				}
			break;
			default:
				if (record_done) break;
				continue;
		}
		if (record_done) break;		
	} while ((tok = strtok(NULL," \t")));
	logdata->curr_pos++;
	if (logdata->curr_pos >= LOG_LIMIT) {
		logdata->curr_pos = 0;
		logdata->roundup = 1;
	}
// gmluong, 08/06/02, it's possible no ICMP, TCP, UDP content for fragment,
// IP with zero length etc. So needs to add ip_rec_done at these cases
	if (record_done || ip_rec_done) return 0;
	else return -1;
}

int 
send_log(log_data *logdata)
{
	int fp,slen;
	int pid, status;
	char *argv[8] = { };
	static char ptftp_file[35];
	static char hostfile[60];
	char *ptftp_filename, log_strings[(sizeof(log_list)+8)*LOG_LIMIT];
	char *envp[] = {
		"TERM=linux",
		"HOME=/",
		"PATH=/usr/bin:/bin:/usr/sbin:/sbin",
		"SHELL=" "bin/sh",
		"USER=root",
		NULL
	};

	signal(SIGCHLD, SIG_IGN);
	ptftp_filename = get_tftp_filename();
	if (strlen(ptftp_filename) < 31) {
		memset(ptftp_file, 0, sizeof(ptftp_file));
		sprintf(ptftp_file,"/tmp/%s",ptftp_filename);
	} else {
		printf("filename of tftp is too long\n");
		return -1;
	}

//	printf("ptftp_filename=%s, ptftp_file=%s\n",ptftp_filename,ptftp_file);
	memset(log_strings, 0, sizeof(log_strings));
	slen = prepare_filelog_strings(logdata, log_strings);
//	printf("slen=%d, log_strings=%s\n",slen,log_strings);
	memset(hostfile, 0, sizeof(hostfile));
	sprintf(hostfile,"%s:%s",get_tftp_server(),ptftp_filename);
//	printf("hostfile=%s\n",hostfile);
	fp = open(ptftp_file,O_WRONLY|O_CREAT|O_TRUNC);
	if (!fp) {
		printf("Failed to create %s: %s\n",ptftp_file,strerror(errno));
		return -1;
	}
	if (write(fp, log_strings, slen) != slen) {
		printf("Failed to write %s\n",ptftp_file);
		close(fp);
		return -1;
	}
	close(fp);
	switch (fork()) {
		case -1:
			perror("send_log fork");
			return -1;
		case 0:
			signal(SIGCHLD, SIG_DFL);
			switch (pid=fork()) {
				case -1:
					perror("send_log child-1 fork");
					exit (-1);
				case 0:
					argv[0] = "tftp";
					argv[1] = "put";
					argv[2] = ptftp_file;
					argv[3] = hostfile;
					argv[4] = NULL;
					execve("/bin/busybox",argv,envp);
/*
			argv[0] = ptftp_file;
			argv[1] = NULL;
			execve("./tf /home/gmluong/log_utils/test1.c",argv,envp);
*/
					perror("tftp");
					exit(errno);
				default:
					if (wait(&status) != pid)
						perror("child-1 wait");
					argv[0] = "rm";
					argv[1] = "-f";
					argv[2] = ptftp_file;
					argv[3] = NULL;
					execve("/bin/busybox",argv,envp);
					exit (0);
			}
		default:
//			if (wait(&status) != pid)
//				perror("wait");
			return 0;
	}
}

char* 
get_tftp_filename()
{
	static unsigned short index;
	static time_t prev_ticks;
	static char tftp_file_pref[31];
	char tmpbuf[22];
	time_t ticks;

	memset(tftp_file_pref, 0, sizeof(tftp_file_pref));
	memset(tmpbuf, 0, sizeof(tmpbuf));
	ticks = time(NULL) + t_offset;
	if (ticks != prev_ticks) {
		index = 0;
		prev_ticks = ticks;
	} else {
		index++;
	}
	strftime(tmpbuf,sizeof(tmpbuf),"%b-%d-%Y-%H%M%S",localtime(&ticks));
	if (index)
		sprintf(tftp_file_pref,"%s-%d.log",tmpbuf,index);
	else
		sprintf(tftp_file_pref,"%s.log",tmpbuf);
	return tftp_file_pref;
}

#if 0
int 
prepare_weblog_strings(log_data *logdata, char *ppstr)
{
	char *ptmp;
	int i,j,slen,tot_num,token_len;

	ptmp = ppstr;
	slen = 0;
	if (logdata->roundup) {
		j = logdata->curr_pos;	
		tot_num = LOG_LIMIT;
	} else {
		j = 0;
		tot_num = logdata->curr_pos;
	}
	for(i=0; i<tot_num; i++) {
		sprintf(ptmp,"%s",logdata->loglist[j].time);
		token_len = strlen(logdata->loglist[j].time);
		ptmp += token_len;
		slen += token_len;
		sprintf(ptmp,"%s ",logdata->loglist[j].cat);
		token_len = strlen(logdata->loglist[j].cat);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		if (logdata->loglist[j].macsrc)
			sprintf(ptmp,"%s ",logdata->loglist[j].macsrc);
		else
			sprintf(ptmp," ");
		token_len = strlen(logdata->loglist[j].macsrc);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		if (logdata->loglist[j].macdst)
			sprintf(ptmp,"%s ",logdata->loglist[j].macdst);
		else
			sprintf(ptmp," ");
		token_len = strlen(logdata->loglist[j].macdst);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s ",logdata->loglist[j].src);
		token_len = strlen(logdata->loglist[j].src);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s ",logdata->loglist[j].dst);
		token_len = strlen(logdata->loglist[j].dst);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s ",logdata->loglist[j].proto);
		token_len = strlen(logdata->loglist[j].proto);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s ",logdata->loglist[j].spt);
		token_len = strlen(logdata->loglist[j].spt);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s<p>",logdata->loglist[j].dpt);
		token_len = strlen(logdata->loglist[j].dpt);
		ptmp += (token_len + 3);
		slen += (token_len + 3);
		if (++j == LOG_LIMIT) j=0;
	}
//	*ppstr = logfile_strings;
	return slen;
}
#endif

// by gmluong, 05/16/02, adjust the output format to fit 
// the new web log format request
int 
prepare_weblog_strings(log_data *logdata, char *ppstr)
{
	char *ptmp;
	int i,j,slen,tot_num,token_len;

	ptmp = ppstr;
	slen = 0;
	if (logdata->roundup) {
		j = logdata->curr_pos;	
		tot_num = LOG_LIMIT;
	} else {
		j = 0;
		tot_num = logdata->curr_pos;
	}
	for(i=0; i<tot_num; i++) {
		sprintf(ptmp,"%s\t",logdata->loglist[j].time);
		token_len = strlen(logdata->loglist[j].time);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s\t",logdata->loglist[j].cat);
		token_len = strlen(logdata->loglist[j].cat);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		if (logdata->loglist[j].macsrc)
			sprintf(ptmp,"%s\t",logdata->loglist[j].macsrc);
		else
			sprintf(ptmp,"\t");
		token_len = strlen(logdata->loglist[j].macsrc);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		if (logdata->loglist[j].macdst)
			sprintf(ptmp,"%s\t",logdata->loglist[j].macdst);
		else
			sprintf(ptmp,"\t");
		token_len = strlen(logdata->loglist[j].macdst);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s\t",logdata->loglist[j].src);
		token_len = strlen(logdata->loglist[j].src);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s\t",logdata->loglist[j].dst);
		token_len = strlen(logdata->loglist[j].dst);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s\t",logdata->loglist[j].proto);
		token_len = strlen(logdata->loglist[j].proto);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s\t",logdata->loglist[j].spt);
		token_len = strlen(logdata->loglist[j].spt);
		ptmp += (token_len + 1);
		slen += (token_len + 1);
		sprintf(ptmp,"%s\t\n",logdata->loglist[j].dpt);
		token_len = strlen(logdata->loglist[j].dpt);
		ptmp += (token_len + 2);
		slen += (token_len + 2);
		if (++j == LOG_LIMIT) j=0;
	}
//	*ppstr = logfile_strings;
	return slen;
}

int 
prepare_filelog_strings(log_data *logdata, char *ppstr)
{
	char *ptmp;
	int i,j,slen,tot_num,token_len;

	ptmp = ppstr;
	slen = 0;
	if (logdata->roundup) {
		j = logdata->curr_pos;	
		tot_num = LOG_LIMIT;
	} else {
		j = 0;
		tot_num = logdata->curr_pos;
	}
	for(i=0; i<tot_num; i++) {
		if (!logdata->loglist[j].dirty) {
			sprintf(ptmp,"%s",logdata->loglist[j].time);
			token_len = strlen(logdata->loglist[j].time);
			ptmp += token_len;
			slen += token_len;
			sprintf(ptmp,"%s ",logdata->loglist[j].cat);
			token_len = strlen(logdata->loglist[j].cat);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			if (logdata->loglist[j].macsrc)
				sprintf(ptmp,"%s ",logdata->loglist[j].macsrc);
			else
				sprintf(ptmp," ");
			token_len = strlen(logdata->loglist[j].macsrc);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			if (logdata->loglist[j].macdst)
				sprintf(ptmp,"%s ",logdata->loglist[j].macdst);
			else
				sprintf(ptmp," ");
			token_len = strlen(logdata->loglist[j].macdst);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			sprintf(ptmp,"%s ",logdata->loglist[j].src);
			token_len = strlen(logdata->loglist[j].src);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			sprintf(ptmp,"%s ",logdata->loglist[j].dst);
			token_len = strlen(logdata->loglist[j].dst);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			sprintf(ptmp,"%s ",logdata->loglist[j].proto);
			token_len = strlen(logdata->loglist[j].proto);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			sprintf(ptmp,"%s ",logdata->loglist[j].spt);
			token_len = strlen(logdata->loglist[j].spt);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			sprintf(ptmp,"%s\n",logdata->loglist[j].dpt);
			token_len = strlen(logdata->loglist[j].dpt);
			ptmp += (token_len + 1);
			slen += (token_len + 1);
			logdata->loglist[j].dirty = 1;
		}
		if (++j == LOG_LIMIT) j=0;
	}
//	*ppstr = logfile_strings;
	return slen;
}

int 
check_sendfile_cond(int *newitem_num)
{
	int rc = 0;

	if (*newitem_num == LOG_LIMIT) {
		rc = 1;
		*newitem_num = 0;
	}
	return rc;
}

int 
tftp_log()
{
	char tftp_log_flag[2];

	memcpy(tftp_log_flag, nvram_safe_get("log_tftp"), sizeof(tftp_log_flag));
//	printf("log_tftp=%s\n",tftp_log_flag);
	if (!strcmp(tftp_log_flag,"1"))
		return 1;
	else
		return 0;
}

char*
get_tftp_server()
{
	static char tftp_server[128];

	memset(tftp_server, 0, sizeof(tftp_server));
	memcpy(tftp_server, nvram_safe_get("log_tftp_server"), sizeof(tftp_server));
//	printf("tftp_server=%s\n",tftp_server);
	return tftp_server;
}

int
send_web_strings(int connfd, log_data *logdata)
{
	int slen;
//	char rbuf[8];
	char log_strings[(sizeof(log_list)+10)*LOG_LIMIT];
	
//	read(connfd, rbuf, 1);
	slen = prepare_weblog_strings(logdata, log_strings);
	write(connfd, log_strings, slen);
//	close(connfd);
	
	return 0;
}

int
delete_web_strings(int connfd, log_data *plogdata, int *pnewitem_num)
{
	int i, curr, rc = 0;
	if (tftp_log()) {
		if (*pnewitem_num == LOG_LIMIT) *pnewitem_num = 0;
		if (send_log(plogdata)) {
			printf("Failed to send file to tftp server\n");
			rc = 1;
		}
	}
	curr = plogdata->curr_pos;
	for(i=0; i<LOG_LIMIT; i++) 
		memset(&plogdata->loglist[i],0,sizeof(log_list));
	*pnewitem_num = 0;
	plogdata->curr_pos = 0;
	plogdata->roundup = 0;

	return rc;
}
