/* net_test.c :       gcc -o ping_test ping_test.c
 *          Do the following periodically:
 *              (1) renew IP after packet > LOSS_THRESHOLD
 *              (2) ping "dhcp-server"  every PING_INTERVAL secs
 *          Log message if error occured.
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/file.h>
#include <unistd.h>
#include <getopt.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <time.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/wait.h>
#include <net/if.h>
#include <errno.h>

#include <bcmnvram.h>
#include <shutils.h>

#define eval_tofile(cmd, args...) ({ \
        char *argv[] = { cmd, ## args, NULL }; \
        _eval(argv, ">/tmp/wan_ping", 0, NULL); \
})

#define PING_INTERVAL 30
#define PING_TRIAL 3

static void set_WAN(char flag[5]);

#ifdef INCLUDE_RTPS
extern void led_write(char *status);
#else
static void led_ctl(char power,char wan);
#endif
//char  target_IP[15];
char  target_IP[64];


int main(int argc, char *argv[])

{
int pid,sig,status,uid;
int loss_count = 0;
//char dest_IP[15],stat, cmd[48], tmp[128],pid_str[7];
char dest_IP[64],stat, cmd[48], tmp[128],pid_str[7];
int loss_threshold,network_down=0;
int target; //mtyan
int all_tried;


  if ( argc < 2 )
        {
         printf("Usage: route_check gateway_IP\n");
         exit(1);
        }
 //eval("ps",">","/tmp/route_check.pid");
 if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("route_check() fork eror!\n");
 else if ( pid == 0 )
        {
         if ( execl("/bin/sh","sh","-c","ps > /tmp/route_check.pid",(char *) 0) < 0 )
              printf("route_check(): execle(led_mon) eror!\n");
        }
 if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("route_check(): wait error!\n");
 FILE *fp= fopen("/tmp/route_check.pid","r");

 if ( fp )
    {
     printf("(): open /tmp/route_check.pid  successfully\n");
     while (fgets(tmp, sizeof(tmp), fp))
        {
        //printf("route_check(): %s\n",tmp);
        if ( sscanf(tmp, "%s %d %c %s", pid_str, &uid, &stat, cmd) )
         {
          //printf("route_check():%s %d %c %s\n",pid_str, uid, stat, cmd);
          if ( strcmp(cmd,"route_check")==0 )
               {
                printf("route_check():Got non-killed route_check with pid(%s)\n",pid_str);
                if ( atoi(pid_str) == getpid() )
                        printf("route_check(): don't kill myself!\n");
                else
                        eval("kill", pid_str);
               }
         }
        }// while
     fclose(fp);
     unlink("/tmp/route_check.pid");
    }
 else
     perror("route_check:  can't open /tmp/route_check.pid\n");
 strcpy(&(dest_IP[0]),argv[1]);
 target=1; //mtyan
 all_tried=0;
 loss_threshold = PING_TRIAL ;
 for (;;)
     {
      if (loss_count == (loss_threshold-1) && target == 1)
      {
      		all_tried=0;
      }
      else if (loss_count == loss_threshold && target == 3)
      {
      		all_tried=1;
      }

      if ( loss_count == loss_threshold )
          {

           if(target==1){
                 printf("route_check(): Remote gateway is down!\n");
                 if ( argc > 2 ) strcpy(&(dest_IP[0]),argv[2]);

           }else if(target==2){
                 printf("route_check(): DNS is down!\n");
                 if ( argc > 3 ) strcpy(&(dest_IP[0]),argv[3]);
           }else if(target==3){
                 printf("route_check(): %s is down!\n",argv[3]);
                 strcpy(&(dest_IP[0]),argv[1]);
           }
          target++;
          loss_count = 0; // reset counter

           if (( network_down == 0 )&&(target == argc))
               {
                //printf("route_check(): Clear WAn status!\n");
                set_WAN("down");
                network_down = 1;
                target=1; //mtyan
                strcpy(&(dest_IP[0]),argv[1]);

               }
          }
      else     // ping test
          {
           strcpy(target_IP,dest_IP);
           if ( 1 /*inet_addr(target_IP) != INADDR_NONE*/) //mtyan
                {
                //printf("Dot-decimal IP(%s)\n",target_IP);
                }
           else //if (target_IP == NULL)
                {
                 printf("route_check(): NULL IP,the gateway IP should be a valid IP now!\n");
                 break;
                }
           switch (pid = fork())
                  {
                   case -1:        // error
                           printf("route_check():fork error\n");
                           exit(1);
                   case 0:         // child
                          /* Reset signal handlers set for parent process */
                          for (sig = 0; sig < (_NSIG-1); sig++)
                              signal(sig, SIG_DFL);
                          /* Clean up
                          close (0);
                          close (1);
                          close (2);
                          ioctl(0, TIOCNOTTY, 0);
                          close(STDIN_FILENO);    */

                          setsid();
                          // execute ping  command
                          //if ( execle("/bin/ping","ping",target_IP,(char *) 0,NULL) < 0 )
                            //     printf("route_check():execle(ping) error!\n");
                          //eval("ping", target_IP,">/tmp/ping_wan");
                          eval_tofile ("ping", target_IP);
                          return(errno);;
                   default:        // parent

                           if (target==3) {
                                sleep(3);
                                system("killall ping");

                           }
                           waitpid(pid, &status, 0);
                           FILE *mfp;
                           char buf[50];
                           mfp = fopen ("/tmp/wan_ping", "r");
                           if (mfp)
                                {
                                fscanf (mfp, "%[^\n]", buf);
                                fclose (mfp);
                                }
                           //printf("Child's status = %d\n", status);
                           //if ( status )
                           if (!strstr (buf, "alive"))
                               {
                                loss_count++;
                                printf("No reply from(%s)! loss_count(%d)\n",target_IP,loss_count);
                               }
                            else
                                {
                                 all_tried=1;
                                 loss_count = 0;
                                 strcpy(&(dest_IP[0]),argv[1]); //mtyan
                                 target=1;//mtyan
                                 //printf("Network is ok! loss_count(%d), network_down(%d)\n",loss_count,network_down);
                                 if ( network_down == 1) //network has been down, start RF now
                                        {
                                         network_down = 0;
                                         set_WAN("up");
                                         printf("route_check():Network is restarted! Start WAN now!\n");
                                         return 1;
                                        }
                                }
                            if(((loss_count==0)||(loss_count>=PING_TRIAL)) && all_tried ) sleep(PING_INTERVAL);
                   } // switch
            }
    }//for
 return 0;
}

#ifdef INCLUDE_RTPS
static void set_WAN(char flag[5])
{
 int pid;

 printf("set_WAN(): set WAN %s\n",flag);
 if (!strcmp(flag, "down"))
    {
    	led_write("T?????????");

     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_ipaddr=0.0.0.0",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");

     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_netmask=0.0.0.0",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");
     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_gateway=",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");
     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_dns=",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");
     unlink("/tmp/wan_connect");

     if(!strcmp(nvram_safe_get("wan_proto"),"dhcp"))
     {
     	eval("killall", "udhcpc");

	        int wan_mac[6];
		char *wan_ifname = nvram_safe_get("wan_ifname");
  		char *wan_hostname = nvram_safe_get("wan_hostname");
	        char mywan_hostname[16];

		char *dhcp_argv[] = { "udhcpc",
				      "-i", wan_ifname,
				      "-p", "/var/run/udhcpc.pid",
				      "-s", "/tmp/udhcpc",
				      //wan_hostname && *wan_hostname ? "-H" : NULL,//original
				      //wan_hostname && *wan_hostname ? wan_hostname : NULL,//original
				      "-H", //mtyan dhcp option: hostname
				      wan_hostname && *wan_hostname ? wan_hostname : mywan_hostname,//mtyan dhcp option: hostname
				      NULL
		};
                nvram_set("wan_ipaddr", "0.0.0.0");
                nvram_set("wan_netmask","0.0.0.0");
                nvram_set("wan_gateway","");
                nvram_set("wan_dns","");
                sscanf(nvram_safe_get("et1macaddr"),"%02x:%02x:%02x:%02x:%02x:%02x",\
                &wan_mac[0],&wan_mac[1],&wan_mac[2],&wan_mac[3],&wan_mac[4],&wan_mac[5]); //mtyan dhcp option: hostname
                sprintf(mywan_hostname,"%02x%02x%02x%02x%02x%02x",\
                wan_mac[0],wan_mac[1],wan_mac[2],wan_mac[3],wan_mac[4],wan_mac[5]);//mtyan dhcp option: hostname
                symlink("/sbin/rc", "/tmp/udhcpc");

		_eval(dhcp_argv, NULL, 0, &pid);

     }

    }
 else if(strcmp(nvram_safe_get("wan_proto"),"dhcp"))  // restart WAN only NON dhcp
    {
     printf("set_WAN(): execle(rc) restart...\n");
     if ( execle("/sbin/rc","rc","restart",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(rc) eror!\n");
     else
         printf("set_WAN(): execle(rc) restart...\n");
    }

}

#else
// flag: up/down
static void set_WAN(char flag[5])
{
 int pid;

 printf("set_WAN(): set WAN %s\n",flag);
 if (!strcmp(flag, "down"))
    {
     // clear WAN status
     // Reset WAN LED and start led_mon process
     led_ctl('1','0');
     //char *led_argv[] = { "led_mon","/tmp/led.lck","/tmp/led.ctl", NULL };
     //_eval(led_argv, NULL, 0, &pid); // added by Jerry Lee
     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/led_mon","led_mon","/tmp/led.lck","/tmp/led.ctl",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(led_mon) eror!\n");
        }
     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_ipaddr=0.0.0.0",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");
     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_netmask=0.0.0.0",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");
     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_gateway=",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");
     if ( (pid = fork() ) < 0 )      // Jerry Lee
        printf("set_WAN() fork eror!\n");
     else if ( pid == 0 )
        {
         if ( execle("/usr/sbin/nvram","nvram","set","wan_dns=",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(nvram) eror!\n");
        }
     if ( waitpid(pid,NULL,0) < 0 )   // Jerry Lee
        printf("set_WAN(): wait error!\n");
     unlink("/tmp/wan_connect");

     if(!strcmp(nvram_safe_get("wan_proto"),"dhcp"))
     {
     	eval("killall", "udhcpc");

	        int wan_mac[6];
		char *wan_ifname = nvram_safe_get("wan_ifname");
  		char *wan_hostname = nvram_safe_get("wan_hostname");
	        char mywan_hostname[16];

		char *dhcp_argv[] = { "udhcpc",
				      "-i", wan_ifname,
				      "-p", "/var/run/udhcpc.pid",
				      "-s", "/tmp/udhcpc",
				      //wan_hostname && *wan_hostname ? "-H" : NULL,//original
				      //wan_hostname && *wan_hostname ? wan_hostname : NULL,//original
				      "-H", //mtyan dhcp option: hostname
				      wan_hostname && *wan_hostname ? wan_hostname : mywan_hostname,//mtyan dhcp option: hostname
				      NULL
		};
                nvram_set("wan_ipaddr", "0.0.0.0");
                nvram_set("wan_netmask","0.0.0.0");
                nvram_set("wan_gateway","");
                nvram_set("wan_dns","");
                sscanf(nvram_safe_get("et1macaddr"),"%02x:%02x:%02x:%02x:%02x:%02x",\
                &wan_mac[0],&wan_mac[1],&wan_mac[2],&wan_mac[3],&wan_mac[4],&wan_mac[5]); //mtyan dhcp option: hostname
                sprintf(mywan_hostname,"%02x%02x%02x%02x%02x%02x",\
                wan_mac[0],wan_mac[1],wan_mac[2],wan_mac[3],wan_mac[4],wan_mac[5]);//mtyan dhcp option: hostname
                symlink("/sbin/rc", "/tmp/udhcpc");

		_eval(dhcp_argv, NULL, 0, &pid);

     }

    }
 else   // restart WAN
    {
     printf("set_WAN(): execle(rc) restart...\n");
     if ( execle("/sbin/rc","rc","restart",(char *) 0,NULL) < 0 )
              printf("set_WAN(): execle(rc) eror!\n");
     else
         printf("set_WAN(): execle(rc) restart...\n");
    }

}
// added by Jerry Lee for LED control
void led_ctl(char power,char wan)
{
 FILE *fp_control;
 int fd_lock;
 char status[2];

 while (1)
       {
        usleep(1000);
        fd_lock = open("/tmp/led.lck",O_WRONLY | O_CREAT | O_EXCL, 0644);
        if ( fd_lock<0 && errno==EEXIST )
           {
            printf("led_ctl(): Already locked!\n");
           }
        else if ( fd_lock<0 )
                 printf("led_ctl(): Unexpected error!\n");
        else
           {
            if (!(fp_control = fopen("/tmp/led.ctl", "w+")))
                printf("led_ctl():Can not find /tmp/led.ctl\n");
	    else
	       {
	        status[0]=power;
	        status[1]=wan;
	        fprintf(fp_control,"%s\n",status);
	        fclose(fp_control);
	       }
            close(fd_lock);
            unlink("/tmp/led.lck");
            break;
           }
        }//Wait for control file
}
#endif