 /*
  * $Id: zcsvc.c,v 1.1.1.1 2004/06/10 10:28:45 cvsadm Exp $
  */
#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <netinet/in.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <bcmnvram.h>
#include <wlutils.h>
#include <wlioctl.h>
#include <linux/if.h>

#include <sys/socket.h>     /*? For SOCK_DGRAM */
#include <linux/sockios.h>
#include <sys/ioctl.h>
#include <shutils.h>

#define ZCSVC_INTERVAL 15

static int
wl_ioctl_bcm(char *name, int cmd, void *buf, int len)
{
	struct ifreq ifr;
	wl_ioctl_t ioc;
	int ret = 0;
 	int s;
	/* open socket to kernel */
	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		exit(errno);
	}

	/* do it */
	ioc.cmd = cmd;
	ioc.buf = buf;
	ioc.len = len;
	strncpy(ifr.ifr_name, name, IFNAMSIZ);
	ifr.ifr_data = (caddr_t) &ioc;
	if ((ret = ioctl(s, SIOCDEVPRIVATE, &ifr)) < 0)
		perror(ifr.ifr_name);

	/* cleanup */
	close(s);
	return ret;
}

int
wl_get_BSSID(char *name, unsigned char *val)
{
	int ret;
	struct ether_addr buf;
	ret = wl_ioctl_bcm(name, WLC_GET_BSSID, &buf, sizeof(buf));
	if(ret)
	{
//	printf("return error while get bssid\n");
		return -1;
	}
	sprintf(val, "%02x:%02x:%02x:%02x:%02x:%02x",
         buf.octet[0],
         buf.octet[1],
         buf.octet[2],
         buf.octet[3],
         buf.octet[4],
         buf.octet[5]);
//         printf("\n get BSSID %s \n", val );
	return ret;
}

static int valid_macaddr(unsigned char *value)
{
	unsigned int hwaddr[6];
	
	if (sscanf(value, "%x:%x:%x:%x:%x:%x",
		   &hwaddr[0], &hwaddr[1], &hwaddr[2],
		   &hwaddr[3], &hwaddr[4], &hwaddr[5]) != 6 ||
	    (hwaddr[0] & 1) ||
	    (hwaddr[0] & hwaddr[1] & hwaddr[2] & hwaddr[3] & hwaddr[4] & hwaddr[5]) == 0xff ||
	    (hwaddr[0] | hwaddr[1] | hwaddr[2] | hwaddr[3] | hwaddr[4] | hwaddr[5]) == 0x00) 
	{
		printf("invalid mac addr\n");
		return 0;
	}
	return 1;
		
}
int main(int argc, char **argv)
{
	char wlifname[8];
	unsigned char assoc[32];
	int ret;
	
	strcpy(wlifname, nvram_safe_get("wl0_ifname"));

	while (1) {
		ret = wl_get_BSSID(wlifname, assoc);
		if (ret || !valid_macaddr(assoc)) {
//			printf("zcsvc wlconf\n");
			eval("wlconf", wlifname, "down");
//			sleep(1);
			eval("wlconf", wlifname, "up");		
		}
		sleep(ZCSVC_INTERVAL);		
	}

	exit(0);
}

