/* Simple version of _eval() (no timeout and wait for child termination) */
#define eval(cmd, args...) ({ \
	char *argv[] = { cmd, ## args, NULL }; \
	_eval(argv, NULL, 0, 0); \
})

extern int _eval(char *const argv[], char *path, int timeout, int nowait);

/* Debug print */
#ifdef DEBUG
#define dprintf(fmt, args...) cprintf(__FUNCTION__ ": " fmt, ## args)
#else
#define dprintf(fmt, args...)
#endif

typedef struct sntpPacket
    {
    unsigned char     leapVerMode;
    unsigned char     stratum;                 
    char              poll;
    char              precision;
    unsigned long     rootDelay;
    unsigned long     rootDispersion;
    unsigned long     referenceIdentifier;

    /* latest available time, in 64-bit NTP timestamp format */

    unsigned long     referenceTimestampSec;
    unsigned long     referenceTimestampFrac;

    /* client transmission time, in 64-bit NTP timestamp format */

    unsigned long     originateTimestampSec;
    unsigned long     originateTimestampFrac;

    /* server reception time, in 64-bit NTP timestamp format */

    unsigned long     receiveTimestampSec;
    unsigned long     receiveTimestampFrac;

    /* server transmission time, in 64-bit NTP timestamp format */

    unsigned long     transmitTimestampSec;
    unsigned long     transmitTimestampFrac;
    } SNTP_PACKET;