#ifdef BELKIN
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <dirent.h>
/*#include <linux/inet.h>*/

#include <bcmnvram.h>
#include <shutils.h>
#include <rc.h>
#include <netconf.h>

// gmluong, iptables api
#if 0
#include <libiptc/libiptc.h>
#include <iptables.h>
#include <netfilter_ipv4/ip_tables.h>
#include <netfilter_ipv4/ipt_LOG.h>
#endif

char EN[]= "1";
char NEN[]= "0";

// iptables program name
char I4[]="iptables";

// ipv4 firewall nvram variable name
char FW_EN[]="firewall_enable";
char FW_POS[]= "default_policy";		// 0 - list block, 1 - list pass
char FW_DOS_EN[]= "dos_enable";
char FW_WANPING[]= "wan_ping";
char FW_ML[]= "fm";
char FW_IL[]= "fi";
char FW_VS[]= "fwi";
char FW_DMZ[]= "dmz_ipaddr";
char MAC_FILTER_EN[]= "mac_filter";  // Jerry Lee
char FW_REMOTE_CONFIG_IP[]="remote_config_ip";

// iptables chain name
char INPUT[]= "INPUT";
char OUTPUT[]= "OUTPUT";
char FORWARD[]= "FORWARD";
char PREROUTING[]="PREROUTING";
char POSTROUTING[]= "POSTROUTING";
char i4_syn_flood[]="i4_syn_flood";
char i4_icmp_flood[]="i4_icmp_flood";
char i4_dos[]="i4_dos";
char i4_mac_filter[]="i4_mac_filter";
char i4_tcp_filter[]="i4_tcp_filter";
char i4_udp_filter[]="i4_udp_filter";
char i4_tcp_forward[]="i4_tcp_forward";
char i4_udp_forward[]="i4_udp_forward";
char i4_tcp_preroute[]="i4_tcp_preroute";
char i4_udp_preroute[]="i4_udp_preroute";
char i4_dmz_preroute[]="i4_dmz_preroute";
char i4_dmz[]="i4_dmz";

// iptables target name
char ACCEPT[]= "ACCEPT";
char DROP[]= "DROP";
char RET[]= "RETURN";
char LOG[]= "LOG";
char MASQUERADE[]="MASQUERADE";
char QUEUE[]="QUEUE";

// iptables operations, manupilations, matches, options etc.
char A[]= "-A";
char D[]= "-D";
char F[]= "-F";
char I[]="-I";;
char N[]= "-N";
char P[]= "-P";
char X[]= "-X";
char Z[]= "-Z";
char d[]= "-d";
char i[]= "-i";
char j[]= "-j";
char m[]= "-m";
char o[]= "-o";
char p[]= "-p";
char s[]= "-s";
char t[]= "-t";
char nat[]= "nat";
char NOT[]= "!";
char macsrc[]= "--mac-source";
char dport[]= "--dport";
char sport[]= "--sport";
char limit[]= "--limit";
char limit_burst[]= "--limit-burst";
char syn[]= "--syn";
char ALL[]= "ALL";
char NONE[]= "NONE";
char tcp_flags[]= "--tcp-flags";
char length[]= "length";
char leng[]= "--length";
char mlimit[]= "limit";
char multiport[]= "multiport";
char dports[]= "--dports";
char sports[]= "--sports";
char DNAT[]= "DNAT";
char TO[]= "--to";
char mtime[]="time";
char timestart[]="--timestart";
char timestop[]="--timestop";
char days[]="--days";
char mac[]= "mac";
char tcp[]= "tcp";
char udp[]= "udp";
char icmp[]= "icmp";
char icmp_type[]="--icmp-type";
char redirect[]="redirect";
char echo[]="echo";
char echo_request[]="echo-request"; // Jerry Lee
char echo_reply[]="echo-reply";
char mstate[]="state";
char state[]="--state";
char NEW_INVALID[]="NEW,INVALID";
char NEW[]= "NEW";
char RELATED_ESTABLISHED[]= "RELATED,ESTABLISHED";

// iptables LOG target related
char log_pref[]= "--log-prefix";
char log2[]= " rt190w CAT=2 ";
char wan_log[]= " rt190w CAT=1 ";
char lan_log[]= " rt190w CAT=2 ";
char CAT1_1[]= " rt190w CAT=1-1 ";
char CAT1_2[]= " rt190w CAT=1-2 ";
char CAT1_3[]= " rt190w CAT=1-3 ";
char CAT1_5[]= " rt190w CAT=1-5 ";
char CAT1_6[]= " rt190w CAT=1-6 ";
char CAT1_9[]= " rt190w CAT=1-9 ";
char CAT1_10[]= " rt190w CAT=1-10 ";
char CAT1_11[]= " rt190w CAT=1-11 ";
char CAT2_1[]= " rt190w CAT=2-1 ";
char CAT2_2[]= " rt190w CAT=2-2 ";
char CAT2_3[]= " rt190w CAT=2-3 ";
char CAT2_4[]= " rt190w CAT=2-4 ";
char CAT3_1[]= " rt190w CAT=3-1 ";

// iptables limit match related
char ten_per_sec[]="10/s";
// John Ho increase this value to pass IGDtest suite, maybe too strict to be syn[/icmp] flood
char one[]="10";

// nvram firewall variable index
#define FW_IDX_MAC 0
#define FW_IDX_IPFILTER 1
#define FW_IDX_FORWARD 2
#define FW_IDX_DMZ 3

// service port number
char HTTP_SP[]= "80";
char DNS_SP[]= "53";

// ip related variables
char allip[]="0.0.0.0";

// misc variables
char CHAR_ZERO[]="0";

// days of week
char *dayofweek[7] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};

//time of day
char *timeofday[24] = {"0:00", "1:00", "2:00", "3:00", "4:00", "5:00", "6:00",
			"7:00", "8:00", "9:00", "10:00", "11:00", "12:00",
			"13:00", "14:00", "15:00", "16:00", "17:00", "18:00",
			"19:00", "20:00", "21:00", "22:00", "23:00"};

typedef struct _ipv4_fw_para {
	char mac[18];
	char pubip[16];
	char privstartip[16];
	char privstopip[16];
	char wstartdport[6];
	char wstopdport[6];
	char lstartdport[6];
	char lstopdport[6];
	char proto[2];
	char timer_en[2];
	char daystart[4];
	char daystop[4];
	char timestart[6];
	char timestop[6];
	char rule_en[2];
} ipv4_fw_para;

char wan_ifname[8], lan_ifname[8];
char wan_ipaddr[48], lan_ipaddr[16];

#ifdef FW_TEST
static int set_nvram_value();
#endif
static int get_wan_ifname();
static int get_lan_ifname();
static int get_wan_ipaddr();
static int get_lan_ipaddr();
static int do_wan_http_management();
static int do_wan_ping();
static int do_dos();
static int extract_nv(int fw_idx, char *pbuf, ipv4_fw_para *pfw_para);
static int do_mac_list();
static int do_ipfilter_list();
static int do_forward_list();
static int do_dmz_list();
static int add_policy_accept();
static int add_policy_drop();
static int add_clamp_mss();
static int add_spi_RE_rule();
static int add_spi_NEW_rule();
static int add_masquerade();
static int add_ident_rule();
static int add_forward_chain_log();
static int add_input_chain_log();
static int do_dns_relay();
static int add_http_intercept();

static int erase_dos_rules();
void disable_firewall(void);

// share variables within this module
ipv4_fw_para fw_para;
char ip_port[28], port_range[12], day_range[8];

int rule_num=0; //Richard move from extract_nv() to here, 20040707.


#ifdef FW_TEST
int
main()
{
        int rc=0;

//	set_nvram_value();
        start_firewall();
        return rc;
}

static int
set_nvram_value()
{
        int rc=0;
	char buf[1024];

	nvram_unset(FW_ML);
	memset(buf, 0, 1024);
	sprintf(buf,"1-00:96:12:4d:1a:55 1-12:34:56:78:9a:bc");
	nvram_set(FW_ML, buf);

	nvram_unset(FW_IL);
	memset(buf, 0, 1024);
	sprintf(buf,"1-3-20-21-23-0-1-0-0-3-12 1-21-50-17-19-2-1-4-9-5-18");
	nvram_set(FW_IL, buf);

	nvram_unset(FW_VS);
	memset(buf, 0, 1024);
	sprintf(buf,"1-3-2001-65510-0-4-2001-65510 1-72-10111-23410-1-234-10111-23410");
	nvram_set(FW_VS, buf);

	nvram_unset(FW_DMZ);
	memset(buf, 0, 1024);
	sprintf(buf,"1-67.23.124.54-20 1-64.34.65.25-43");
	nvram_set(FW_DMZ, buf);

	return rc;
}
#endif

static int
get_wan_ifname()
{
        int rc=0;

	strcpy(wan_ifname,nvram_safe_get("wan_ifname"));
        if (!strlen(wan_ifname)) return rc=1;

        return rc;
}

static int
get_wan_ipaddr()
{
        int rc=0;

        strcpy(wan_ipaddr,nvram_safe_get("wan_ipaddr"));
        if (!strlen(wan_ipaddr)) return rc=1;

        return rc;
}

static int
get_lan_ifname()
{
        int rc=0;

        strcpy(lan_ifname,nvram_safe_get("lan_ifname"));
        if (!strlen(lan_ifname)) return rc=1;

        return rc;
}


static int
get_lan_ipaddr()
{
        int rc=0;

        strcpy(lan_ipaddr,nvram_safe_get("lan_ipaddr"));
        if (!strlen(lan_ipaddr)) return rc=1;

        return rc;
}

static int
enable_proc_variables()
{
        int rc=0;
	FILE *fp;

        if ((fp = fopen("/proc/sys/net/ipv4/ip_forward", "r+"))) {
                fputc('1', fp);
                fclose(fp);
        } else
                perror("/proc/sys/net/ipv4/ip_forward");

        if ((fp = fopen("/proc/sys/kernel/printk", "r+"))) {
                fputc('1', fp);
                fclose(fp);
        } else
                perror("/proc/sys/kernel/printk");

	return rc;
}

static int
do_wan_http_management()
{
	int rc=0;
	char *pconfig_ip=NULL;

	pconfig_ip=nvram_safe_get(FW_REMOTE_CONFIG_IP);
	memset(ip_port, 0 ,sizeof(ip_port));
	strncpy(ip_port, lan_ipaddr, strlen(lan_ipaddr));
	strcat(ip_port, ":80");

	if (strlen(pconfig_ip) > 0) {
		eval(I4, t, nat, I, PREROUTING, p, tcp, i, wan_ifname, d, lan_ipaddr, dport, HTTP_SP, j, DROP);
		eval(I4, t, nat, I, PREROUTING, p, tcp, i, wan_ifname, d, wan_ipaddr, dport, HTTP_SP, j, DNAT, TO, ip_port);
		eval(I4, I, INPUT, p, tcp, i, wan_ifname, d, lan_ipaddr, dport, HTTP_SP, j, ACCEPT);
        	if ( strcmp(pconfig_ip, allip) && strcmp(pconfig_ip, CHAR_ZERO)) {// particular IP,NOT "","0.0.0.0" and "0"
			eval(I4, I, INPUT, i, wan_ifname, p, tcp, NOT, s, pconfig_ip, d, lan_ipaddr, dport, HTTP_SP, j, DROP);
                	//printf("do_wan_http_management():  execute for particular IP\n");
                } else if ( !strcmp(pconfig_ip, allip) ) { // any IP ,"0.0.0.0"
            		//printf("do_wan_http_management(): not execute for any IP\n");
           	}
        } else if  (strlen(pconfig_ip)==0) { // forbid remote management
                 eval(I4, I, INPUT, i, wan_ifname, p, tcp,d, lan_ipaddr, dport, HTTP_SP, j, DROP);
                 //printf("do_wan_http_management():  execute for disalowed remote management\n");
        }
	return rc;
}

static int
do_wan_ping()
{
	int rc=0;
	int ii;
	int have_alias = 0;
	char aliasIP[15];
	char wan_alias_ifname[20];
	char tmp[200];
	char *ss, *pp;

	if(nvram_match(FW_WANPING,EN)) {
		eval(I4, t, nat, I, PREROUTING, i, wan_ifname, d, wan_ipaddr, p, icmp, icmp_type, echo_request, j, DNAT, TO, lan_ipaddr);
		eval(I4, A, INPUT, i, wan_ifname, d, lan_ipaddr, p, icmp, icmp_type, echo_request, j, ACCEPT);// Jerry Lee
	} else {
		eval(I4, A, INPUT, i, wan_ifname, d, wan_ipaddr, p, icmp, icmp_type, echo_request, j, LOG, log_pref, wan_log);// Jerry Lee
		eval(I4, A, INPUT, i, wan_ifname, d, wan_ipaddr, p, icmp, icmp_type, echo_request, j, DROP);  // Jerry Lee
	}	
	
	strcpy(tmp, nvram_get("m_wan_aliasip"));
	if(strcmp(tmp, "") == 0) return rc;
	pp = tmp;

	/* Richard for alias IPs 20040707 */
	for(ii=0;ii<5;ii++){
		int last_alias=0;
		//sprintf(wan_alias_ifname, "%s:%d", wan_ifname, ii);
		if(ss=strchr(pp, '/')){
			have_alias=1;
			*(ss++) = '\0';
			strcpy(aliasIP, pp);
			printf("alias[%d]=%s\n", ii, aliasIP);
			if(ss = strchr(ss, ' '))
				pp = ++ss;
			else
				last_alias=1;
		}
		else
			break;

		if(nvram_match(FW_WANPING,EN)){
			if(have_alias){
				eval(I4, t, nat, I, PREROUTING, i, wan_ifname, d, aliasIP, p, icmp, icmp_type, echo_request, j, DNAT, TO, lan_ipaddr);
				eval(I4, A, INPUT, i, wan_ifname, d, lan_ipaddr, p, icmp, icmp_type, echo_request, j, ACCEPT);
			}
		} 
		else {
			if(have_alias){
				eval(I4, A, INPUT, i, wan_ifname, d, aliasIP, p, icmp, icmp_type, echo_request, j, LOG, log_pref, wan_log);
				eval(I4, A, INPUT, i, wan_ifname, d, aliasIP, p, icmp, icmp_type, echo_request, j, DROP); 
			}
		}
		
		if(last_alias)
			break;
	}

	return rc;
}

static int
do_dos()
{
	int rc=0;
	char lan_ipmask[32];

	eval(I4, t, nat, N, i4_syn_flood);
	eval(I4, t, nat, N, i4_icmp_flood);
	eval(I4, t, nat, N, i4_dos);

	// icmp redirect
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, icmp, icmp_type, redirect, j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, icmp, icmp_type, redirect, j, DROP);

	// tcp null scan
	eval(I4, t, nat, A, i4_dos, p, tcp, tcp_flags, ALL, NONE, j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, p, tcp, tcp_flags, ALL, NONE, j, DROP);

	// IP spoof
	memset(lan_ipmask, 0, sizeof(lan_ipmask));
	strcpy(lan_ipmask,lan_ipaddr);
	strcat(lan_ipmask,"/");
	strcat(lan_ipmask,nvram_safe_get("lan_netmask"));
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, s, lan_ipmask, j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, s, lan_ipmask, j, DROP);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, s, "240.0.0.0/5", j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, s, "240.0.0.0/5", j, DROP);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, s, "127.0.0.0/8", j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, s, "127.0.0.0/8", j, DROP);

	// Smurf attack
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, icmp, icmp_type, echo_reply, m, mstate, state, NEW_INVALID, j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, icmp, icmp_type, echo_reply, m, mstate, state, NEW_INVALID, j, DROP);

	// RIP detect
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, udp, dport, "520", j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, udp, dport, "520", j, DROP);

	// udp flood
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, udp, sport, "19", dport, "17", j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_dos, i, wan_ifname, p, udp, sport, "19", dport, "17", j, DROP);

	// syn flood
	eval(I4, t, nat, A, i4_syn_flood, i, wan_ifname, p, tcp, syn, m, mlimit, limit, ten_per_sec, limit_burst, one, j, RET);
	// John Ho set LOG limit_burst to "1", be more sensitivity.
	eval(I4, t, nat, A, i4_syn_flood, i, wan_ifname, p, tcp, syn, m, mlimit, limit, ten_per_sec, limit_burst, "1", j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_syn_flood, i, wan_ifname, j, DROP);

	// icmp flood
	eval(I4, t, nat, A, i4_icmp_flood, i, wan_ifname, p, icmp, m, mlimit, limit, ten_per_sec, limit_burst, one, j, RET);
	// John Ho set LOG limit_burst to "1", be more sensitivity.
	eval(I4, t, nat, A, i4_icmp_flood, i, wan_ifname, p, icmp, m, mlimit, limit, ten_per_sec, limit_burst, "1", j, LOG, log_pref, wan_log);
	eval(I4, t, nat, A, i4_icmp_flood, i, wan_ifname, j, DROP);

	eval(I4, t, nat, A, PREROUTING, p, icmp, j, i4_icmp_flood);
	eval(I4, t, nat, A, PREROUTING, p, tcp, j, i4_syn_flood);
	eval(I4, t, nat, A, PREROUTING, j, i4_dos);

	return rc;
}

static int
erase_dos_rules()
{
	int rc=0;

	eval(I4, t, nat, F, i4_syn_flood);
	eval(I4, t, nat, F, i4_icmp_flood);
	eval(I4, t, nat, F, i4_dos);
	eval(I4, t, nat, D, PREROUTING, p, tcp, j, i4_syn_flood);
	eval(I4, t, nat, D, PREROUTING, p, icmp, j, i4_icmp_flood);
	eval(I4, t, nat, D, PREROUTING, j, i4_dos);
	eval(I4, t, nat, X, i4_syn_flood);
	eval(I4, t, nat, X, i4_icmp_flood);
	eval(I4, t, nat, X, i4_dos);

	return rc;
}

static int
do_mac_list()
{
	char *fn="do_mac_list";
	int rc=0, len;
	char *nv_buf=NULL, *ptr1, *ptr2;

	if ((len=strlen(nvram_safe_get(FW_ML)))) {
		eval(I4, N, i4_mac_filter);

		nv_buf = (char *)malloc(len+2);
		if (!nv_buf) {
			printf("%s: Failed to allocate memory\n",fn);
			rc=1;
			goto end;
		}
		memset(nv_buf, 32, (len+2));
		strncpy(nv_buf, nvram_safe_get(FW_ML), len);
		ptr1 = nv_buf;
		while ((ptr2 = strchr(ptr1, ' '))) {
			*ptr2++ = '\0';
//printf("ptr1=%s\n",ptr1);
			memset(&fw_para, 0 ,sizeof(ipv4_fw_para));
			rc = extract_nv(FW_IDX_MAC, ptr1, &fw_para);
printf("fw_para.rule_en=%s\n",fw_para.rule_en);
printf("fw_para.mac=%s\n",fw_para.mac);
			if (!rc) {
                                /*  modified as the below
				if (fw_para.rule_en[0] == '1') {
					eval(I4, A, i4_mac_filter, i, lan_ifname, m, mac, macsrc, fw_para.mac, j, LOG, log_pref, lan_log);
					eval(I4, A, i4_mac_filter, i, lan_ifname, m, mac, macsrc, fw_para.mac, j, DROP);
				}  */
                                if (fw_para.rule_en[0] == '0') { // forward this , modified by Jerry Lee
					eval(I4, A, i4_mac_filter, i, lan_ifname, m, mac, macsrc, fw_para.mac, j, RET);
//					eval(I4, A, i4_mac_filter, i, lan_ifname, m, mac, macsrc, fw_para.mac, j, ACCEPT);
				}
				if (*ptr2 == ' ') break;
				ptr1 = ptr2;
			} else {
				printf("%s: extract_nv() failed\n",fn);
				break;
			}
		}
		free (nv_buf);
		eval(I4, A,i4_mac_filter , i, lan_ifname, j, DROP);//added by Jerry Lee
		eval(I4, A, FORWARD, i, lan_ifname, j, i4_mac_filter);
		eval(I4, A, INPUT, i, lan_ifname, j, i4_mac_filter);
	}
end:
	return rc;
}

static int
do_ipfilter_list()
{
	char *fn="do_ipfilter_list";
	int rc=0, len, numi, has_tcp_item=0, has_udp_item=0;
	char *nv_buf=NULL, *ptr1, *ptr2;
	struct in_addr privstartip, privstopip, addr;
// gmluong iptables api
#if 0
        iptc_handle_t handle = NULL;
        struct ipt_entry *pentry, *log_entry[512], *drop_entry[512];
        char *chain;
        struct ipt_entry_target *target;
        size_t log_target_size = 0, drop_target_size = 0;
        struct ipt_log_info log;
#endif

	if ((len=strlen(nvram_safe_get(FW_IL)))) {
		eval(I4, N, i4_tcp_filter);
		eval(I4, N, i4_udp_filter);

// gmluong iptables api
#if 0
		for(numi=0; numi<512; numi++) {
			log_entry[numi] = NULL;
			drop_entry[numi] = NULL;
		}
		/* Set miscellaneous log parameters */
		memset(&log, 0, sizeof(log));
		log.level = LOG_INFO;
		//log.logflags = 0xf;
        	/* Log packet */
        	strncpy(log.prefix, lan_log, sizeof(log.prefix));

		/* Allocate LOG target */
		log_target_size += IPT_ALIGN(sizeof(struct ipt_entry_target));
		log_target_size += IPT_ALIGN(sizeof(log));
		drop_target_size += IPT_ALIGN(sizeof(struct ipt_entry_target));
		drop_target_size += IPT_ALIGN(sizeof(int));
#endif

		nv_buf = (char *)malloc(len+2);
		if (!nv_buf) {
			printf("%s: Failed to allocate memory\n",fn);
			rc=1;
			goto err;
		}
		memset(nv_buf, 32, (len+2));
		strncpy(nv_buf, nvram_safe_get(FW_IL), len);
		ptr1 = nv_buf;
		while ((ptr2 = strchr(ptr1, ' '))) {
			*ptr2++ = '\0';
			memset(&fw_para, 0 ,sizeof(ipv4_fw_para));
			rc = extract_nv(FW_IDX_IPFILTER, ptr1, &fw_para);
printf("rc=%d, fw_para.rule_en=%s\n",rc,fw_para.rule_en);
printf("fw_para.privstartip=%s\n",fw_para.privstartip);
printf("fw_para.proto[0]=%c\n",fw_para.proto[0]);
printf("fw_para.timer_en[0]=%c\n",fw_para.timer_en[0]);
			if (!rc) {
				if (fw_para.rule_en[0] == '1') {
					inet_aton(fw_para.privstartip, &privstartip);
					inet_aton(fw_para.privstopip, &privstopip);
					memset(port_range, 0, sizeof(port_range));
					strcpy(port_range, fw_para.lstartdport);
					strcat(port_range,":");
					strcat(port_range, fw_para.lstopdport);
					memset(day_range, 0, sizeof(day_range));
					strcpy(day_range, fw_para.daystart);
					strcat(day_range,",");
					strcat(day_range, fw_para.daystop);
printf("port_range=%s, day_range=%s\n",port_range,day_range);
// gmluong, iptables api
#if 0
					if (!(handle = iptc_init("filter"))) {
						printf("%s: iptc_init: %s\n",fn,iptc_strerror(errno));
						rc = 1;
						goto err;
					}
#endif
					numi=0;
					for (addr.s_addr = privstartip.s_addr;
                     			ntohl(addr.s_addr) <= ntohl(privstopip.s_addr);
                     			addr.s_addr = htonl(ntohl(addr.s_addr) + 1)) {
						switch(fw_para.proto[0]) {
							case '1':	//tcp
								if(fw_para.timer_en[0] == '1') {
printf("inet_ntoa(addr)=%s, fw_para.timestart=%s, fw_para.timestop=%s\n",inet_ntoa(addr),fw_para.timestart,fw_para.timestop);
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, DROP);
								} else {
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, j, DROP);
								}
								has_tcp_item=1;
							break;
							case '2':
								if(fw_para.timer_en[0] == '1') {
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, DROP);
								} else {
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, j, DROP);
								}
								has_udp_item=1;
							break;
							case '3':
								if(fw_para.timer_en[0] == '1') {
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, DROP);
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, m, mtime, timestart, fw_para.timestart, timestop, fw_para.timestop, days, day_range, j, DROP);
								} else {
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_tcp_filter, i, lan_ifname, p, tcp, s, inet_ntoa(addr), dport, port_range, j, DROP);
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, j, LOG, log_pref, lan_log);
									eval(I4, A, i4_udp_filter, i, lan_ifname, p, udp, s, inet_ntoa(addr), dport, port_range, j, DROP);
								}
								has_tcp_item=1;
								has_udp_item=1;
							break;
						}
// gmluong, following is iptables api, will use it later
#if 0
						/* Allocate entry */
//printf("TEST neg 6\n");
						if (!(log_entry[numi] = calloc(1, sizeof(struct ipt_entry)))) {
							perror("calloc");
							rc = 1;
							goto err;
						}
//printf("TEST neg 7\n");
						if (!(drop_entry[numi] = calloc(1, sizeof(struct ipt_entry)))) {
							perror("calloc");
							rc = 1;
							goto err;
						}
//printf("TEST neg 8\n");

        					/* Initialize entry parameters */
        					log_entry[numi]->nfcache |= NFC_UNKNOWN;
						log_entry[numi]->next_offset = log_entry[i]->target_offset = sizeof(struct ipt_entry);
						drop_entry[numi]->nfcache |= NFC_UNKNOWN;
						drop_entry[numi]->next_offset = drop_entry[i]->target_offset = sizeof(struct ipt_entry);
						if ((fw_para.proto[0] == '3')) {
        						log_entry[numi+1]->nfcache |= NFC_UNKNOWN;
							log_entry[numi+1]->next_offset = log_entry[i]->target_offset = sizeof(struct ipt_entry);
							drop_entry[numi+1]->nfcache |= NFC_UNKNOWN;
							drop_entry[numi+1]->next_offset = drop_entry[i]->target_offset = sizeof(struct ipt_entry);
						}

						/* Match by IP address(es) */
						log_entry[numi]->ip.src.s_addr = addr.s_addr;
						log_entry[numi]->ip.smsk.s_addr = htonl(0xffffffff);
						log_entry[numi]->nfcache |= NFC_IP_SRC;
						log_entry[numi]->ip.proto = 0;
						log_entry[numi]->nfcache |= NFC_IP_PROTO;
						drop_entry[numi]->ip.src.s_addr = addr.s_addr;
						drop_entry[numi]->ip.smsk.s_addr = htonl(0xffffffff);
						drop_entry[numi]->nfcache |= NFC_IP_SRC;
						drop_entry[numi]->ip.proto = 0;
						drop_entry[numi]->nfcache |= NFC_IP_PROTO;
						if ((fw_para.proto[0] == '3')) {
							log_entry[numi+1]->ip.src.s_addr = addr.s_addr;
							log_entry[numi+1]->ip.smsk.s_addr = htonl(0xffffffff);
							log_entry[numi+1]->nfcache |= NFC_IP_SRC;
							log_entry[numi+1]->ip.proto = 0;
							log_entry[numi+1]->nfcache |= NFC_IP_PROTO;
							drop_entry[numi+1]->ip.src.s_addr = addr.s_addr;
							drop_entry[numi+1]->ip.smsk.s_addr = htonl(0xffffffff);
							drop_entry[numi+1]->nfcache |= NFC_IP_SRC;
							drop_entry[numi+1]->ip.proto = 0;
							drop_entry[numi+1]->nfcache |= NFC_IP_PROTO;
						}
						/* Match by inbound or outbound interface name */
						strncpy(log_entry[numi]->ip.iniface, lan_ifname, IFNAMSIZ)
						memset(log_entry[numi]->ip.iniface_mask, 0, IFNAMSIZ);
						memset(log_entry[numi]->ip.iniface_mask, 0xff, strlen(lan_ifname) + 1);
						log_entry[numi]->nfcache |= NFC_IP_IF_IN;
						strncpy(drop_entry[numi]->ip.iniface, lan_ifname, IFNAMSIZ)
						memset(drop_entry[numi]->ip.iniface_mask, 0, IFNAMSIZ);
						memset(drop_entry[numi]->ip.iniface_mask, 0xff, strlen(lan_ifname) + 1);
						drop_entry[numi]->nfcache |= NFC_IP_IF_IN;
						if ((fw_para.proto[0] == '3')) {
							strncpy(log_entry[numi+i]->ip.iniface, lan_ifname, IFNAMSIZ)
							memset(log_entry[numi+i]->ip.iniface_mask, 0, IFNAMSIZ);
							memset(log_entry[numi+i]->ip.iniface_mask, 0xff, strlen(lan_ifname) + 1);
							log_entry[numi+i]->nfcache |= NFC_IP_IF_IN;
							strncpy(drop_entry[numi+i]->ip.iniface, lan_ifname, IFNAMSIZ)
							memset(drop_entry[numi+i]->ip.iniface_mask, 0, IFNAMSIZ);
							memset(drop_entry[numi+i]->ip.iniface_mask, 0xff, strlen(lan_ifname) + 1);
							drop_entry[numi+i]->nfcache |= NFC_IP_IF_IN;
						}

						/* Match by TCP port(s) */
						struct ipt_tcp *tcp;
						if (!(match = netconf_append_match(&entry, "tcp", sizeof(struct ipt_tcp)))) {
							rc = 1;
							goto err;
						}
						tcp = (struct ipt_tcp *) &match->data[0];
						log_entry[numi]->ip.proto = IPPROTO_TCP;
						log_entry[numi]->nfcache |= NFC_IP_PROTO;
						drop_entry[numi]->ip.proto = IPPROTO_TCP;
						drop_entry[numi]->nfcache |= NFC_IP_PROTO;

#if 0
						/* Match ports stored in host order for some stupid reason */
						tcp->spts[0] = ntohs(fw->match.src.ports[0]);
						tcp->spts[1] = ntohs(fw->match.src.ports[1]);
						tcp->invflags |= (fw->match.flags & NETCONF_INV_SRCPT) ? IPT_TCP_INV_SRCPT : 0;
						entry->nfcache |= (tcp->spts[0] != 0 || tcp->spts[1] != 0xffff) ? NFC_IP_SRC_PT : 0;
#endif

						/* Match ports stored in host order for some stupid reason */
						tcp->dpts[0] = ntohs(atoi(fw_para.lstartdport));
						tcp->dpts[1] = ntohs(atoi(fw_para.lstopdport));
						tcp->invflags |= 0;
						log_entry[numi]->nfcache |= (tcp->dpts[0] != 0 || tcp->dpts[1] != 0xffff) ? NFC_IP_DST_PT : 0;
						drop_entry[numi]->nfcache |= (tcp->dpts[0] != 0 || tcp->dpts[1] != 0xffff) ? NFC_IP_DST_PT : 0;

						/* Match by UDP port(s) */
                				struct ipt_udp *udp;

                				if (!(match = netconf_append_match(&entry, "udp", sizeof(struct ipt_udp)))) {
							rc = 1;
                        				goto err;
						}
                				udp = (struct ipt_udp *) &match->data[0];

#if 0
                				/* Match ports stored in host order for some stupid reason */
                				udp->spts[0] = ntohs(fw->match.src.ports[0]);
                				udp->spts[1] = ntohs(fw->match.src.ports[1]);
                				udp->invflags |= (fw->match.flags & NETCONF_INV_SRCPT) ? IPT_UDP_INV_SRCPT : 0;
                				entry->nfcache |= (udp->spts[0] != 0 || udp->spts[1] != 0xffff) ? NFC_IP_SRC_PT : 0;
#endif

                				/* Match ports stored in host order for some stupid reason */
                				udp->dpts[0] = ntohs(atoi(fw_para.lstartdport));
                				udp->dpts[1] = ntohs(atoi(fw_para.lstopdport));
                				udp->invflags |= 0;
						if ((fw_para.proto[0] == '3')) {
                					log_entry[numi+1]->ip.proto = IPPROTO_UDP;
                					log_entry[numi+1]->nfcache |= NFC_IP_PROTO;
							log_entry[numi+1]->nfcache |= (udp->dpts[0] != 0 || udp->dpts[1] != 0xffff) ? NFC_IP_DST_PT : 0;
                					drop_entry[numi+1]->ip.proto = IPPROTO_UDP;
                					drop_entry[numi+1]->nfcache |= NFC_IP_PROTO;
							drop_entry[numi+1]->nfcache |= (udp->dpts[0] != 0 || udp->dpts[1] != 0xffff) ? NFC_IP_DST_PT : 0;
						} else {
                					log_entry[numi]->ip.proto = IPPROTO_UDP;
                					log_entry[numi]->nfcache |= NFC_IP_PROTO;
							log_entry[numi]->nfcache |= (udp->dpts[0] != 0 || udp->dpts[1] != 0xffff) ? NFC_IP_DST_PT : 0;
                					drop_entry[numi]->ip.proto = IPPROTO_UDP;
                					drop_entry[numi]->nfcache |= NFC_IP_PROTO;
							drop_entry[numi]->nfcache |= (udp->dpts[0] != 0 || udp->dpts[1] != 0xffff) ? NFC_IP_DST_PT : 0;
						}

						if (!(pentry = realloc(log_entry[numi], log_entry[numi]->next_offset + log_target_size))) {
                					perror("realloc");
							rc = 1;
                					goto err;
        					}
						target = (struct ipt_entry_target *) ((int) pentry + pentry->next_offset);
        					pentry->next_offset += log_target_size;
        					memset(target, 0, log_target_size);
        					strncpy(target->u.user.name, LOG, IPT_FUNCTION_MAXNAMELEN);
        					target->u.target_size = log_target_size;
        					memcpy(&target->data[0], &log, sizeof(log));
        					log_entry[numi] = pentry;

					        if (!(pentry = realloc(drop_entry[numi], drop_entry[numi]->next_offset + drop_target_size))) {
                					perror("realloc");
							rc = 1;
                					goto err;
        					}
        					pentry->next_offset += drop_target_size;
        					memset(target, 0, drop_target_size);
        					strncpy(target->u.user.name, DROP, IPT_FUNCTION_MAXNAMELEN);
        					target->u.target_size = drop_target_size;
        					drop_entry[numi] = pentry;

						if ((fw_para.proto[0] == '3')) {
						if (!(pentry = realloc(log_entry[numi+1], log_entry[numi+1]->next_offset + log_target_size))) {
                					perror("realloc");
							rc = 1;
                					goto err;
        					}
						target = (struct ipt_entry_target *) ((int) pentry + pentry->next_offset);
        					pentry->next_offset += log_target_size;
        					memset(target, 0, log_target_size);
        					strncpy(target->u.user.name, LOG, IPT_FUNCTION_MAXNAMELEN);
        					target->u.target_size = log_target_size;
        					memcpy(&target->data[0], &log, sizeof(log));
        					log_entry[numi+1] = pentry;

					        if (!(pentry = realloc(drop_entry[numi+1], drop_entry[numi+1]->next_offset + drop_target_size))) {
                					perror("realloc");
							rc = 1;
                					goto err;
        					}
        					pentry->next_offset += drop_target_size;
        					memset(target, 0, drop_target_size);
        					strncpy(target->u.user.name, DROP, IPT_FUNCTION_MAXNAMELEN);
        					target->u.target_size = drop_target_size;
        					drop_entry[numi+1] = pentry;
						}
        					if (!iptc_append_entry(i4_ip_filter, log_entry[numi], &handle))
                					printf("iptc_append_entry: %s\n", iptc_strerror(errno));
        					if(!iptc_append_entry(i4_ip_filter, drop_entry[numi], &handle))
                					printf("iptc_append_entry-2: %s\n", iptc_strerror(errno));
						if ((fw_para.proto[0] == '3')) {
        					if (!iptc_append_entry(i4_ip_filter, log_entry[numi+1], &handle))
                					printf("iptc_append_entry: %s\n", iptc_strerror(errno));
        					if(!iptc_append_entry(i4_ip_filter, drop_entry[numi+1], &handle))
                					printf("iptc_append_entry-2: %s\n", iptc_strerror(errno));
						}
						if ((fw_para.proto[0] == '3')) numi += 2;
						else numi++;
#endif
					}
				}
// gmluong, iptables api
#if 0
        			if (!iptc_commit(&handle)) {
                			printf("iptc_commit: %s\n", iptc_strerror(errno));
					rc = 1;
                			goto err;
        			}
#endif
				if (*ptr2 == ' ') break;
				ptr1 = ptr2;
			} else {
                                printf("%s: extract_nv() failed\n",fn);
                                break;
			}
		}
		free(nv_buf);
		if (has_tcp_item)
			eval(I4, A, FORWARD, i, lan_ifname, p, tcp, j, i4_tcp_filter);
		if (has_udp_item)
			eval(I4, A, FORWARD, i, lan_ifname, p, udp, j, i4_udp_filter);
	}
err:
// gmluong, iptables api
#if 0
	for(numi=0; numi<512; numi++) {
		if (log_entry[numi]) free(log_entry[numi]);
		if (drop_entry[numi]) free(drop_entry[numi]);
	}
#endif
	return rc;
}

static int
do_forward_list()
{
	char *fn="do_forward_list";
	int rc=0, len, has_tcp_item=0, has_udp_item=0;
	char *nv_buf=NULL, *ptr1, *ptr2;
	char privport[12];

	if ((len=strlen(nvram_safe_get(FW_VS)))) {
		eval(I4, t, nat, N, i4_tcp_preroute);
		eval(I4, t, nat, N, i4_udp_preroute);
		eval(I4, N, i4_tcp_forward);
		eval(I4, N, i4_udp_forward);

		nv_buf = (char *)malloc(len+2);
		if (!nv_buf) {
			printf("%s: Failed to allocate memory\n",fn);
			rc=1;
			goto end;
		}
		memset(nv_buf, 32, (len+2));
		strncpy(nv_buf, nvram_safe_get(FW_VS), len);
		ptr1 = nv_buf;
		while ((ptr2 = strchr(ptr1, ' '))) {
			*ptr2++ = '\0';
//printf("ptr1=%s\n",ptr1);
			memset(&fw_para, 0 ,sizeof(ipv4_fw_para));
			rc = extract_nv(FW_IDX_FORWARD, ptr1, &fw_para);
printf("rc=%d, fw_para.rule_en=%s\n",rc,fw_para.rule_en);
printf("fw_para.privstartip=%s\n",fw_para.privstartip);
			if (!rc) {
				if (fw_para.rule_en[0] == '1') {
					memset(port_range, 0, sizeof(port_range));
					strcpy(port_range, fw_para.wstartdport);
					strcat(port_range,":");
					strcat(port_range, fw_para.wstopdport);
					memset(ip_port, 0, sizeof(ip_port));
					strcpy(ip_port, fw_para.privstartip);
					strcat(ip_port, ":");
					strcat(ip_port, fw_para.lstartdport);
					strcat(ip_port, "-");
					strcat(ip_port, fw_para.lstopdport);
					memset(privport, 0, sizeof(privport));
					strcpy(privport, fw_para.lstartdport);
					strcat(privport, ":");
					strcat(privport, fw_para.lstopdport);
					switch(fw_para.proto[0]) {
						case '1':
							eval(I4, t, nat, A, i4_tcp_preroute, i, wan_ifname, d, wan_ipaddr, p, tcp, dport, port_range, j, DNAT, TO, ip_port);
							eval(I4, A, i4_tcp_forward, i, wan_ifname, d, fw_para.privstartip, p, tcp, dport, privport, j, ACCEPT);
							has_tcp_item=1;
						break;
						case '2':
							eval(I4, t, nat, A, i4_udp_preroute, i, wan_ifname, d, wan_ipaddr, p, udp, dport, port_range, j, DNAT, TO, ip_port);
							eval(I4, A, i4_udp_forward, i, wan_ifname, d, fw_para.privstartip, p, udp, dport, privport, j, ACCEPT);
							has_udp_item=1;
						break;
					}
				}
				if (*ptr2 == ' ') break;
				ptr1 = ptr2;
			} else {
				printf("%s: extract_nv() failed\n",fn);
				break;
			}
		}
		free (nv_buf);
		if (has_tcp_item) {
			eval(I4, t, nat, I, PREROUTING, i, wan_ifname, p, tcp, j, i4_tcp_preroute);
			eval(I4, A, FORWARD, i, wan_ifname, p, tcp, j, i4_tcp_forward);
		}
		if (has_udp_item) {
			eval(I4, t, nat, I, PREROUTING, i, wan_ifname, p, udp, j, i4_udp_preroute);
			eval(I4, A, FORWARD, i, wan_ifname, p, udp, j, i4_udp_forward);
		}
	}
end:
	return rc;
}

static int
do_dmz_list()
{
	char *fn="do_dmz_list";
	int rc=0, len, has_item=0;
	char *nv_buf=NULL, *ptr1, *ptr2;

	if ((len=strlen(nvram_safe_get(FW_DMZ)))) {
		eval(I4, t, nat, N, i4_dmz_preroute);
		eval(I4, N, i4_dmz);

		nv_buf = (char *)malloc(len+2);
		if (!nv_buf) {
			printf("%s: Failed to allocate memory\n",fn);
			rc=1;
			goto end;
		}
		memset(nv_buf, 32, (len+2));
		strncpy(nv_buf, nvram_safe_get(FW_DMZ), len);
		ptr1 = nv_buf;
		while ((ptr2 = strchr(ptr1, ' '))) {
			*ptr2++ = '\0';
//printf("ptr1=%s\n",ptr1);
			memset(&fw_para, 0 ,sizeof(ipv4_fw_para));
			rc = extract_nv(FW_IDX_DMZ, ptr1, &fw_para);
printf("fw_para.rule_en=%s\n",fw_para.rule_en);
printf("fw_para.pubip=%s\n",fw_para.pubip);
			if (!rc) {
				if (fw_para.rule_en[0] == '1') {
					eval(I4, t, nat, A, i4_dmz_preroute, i, wan_ifname, d, fw_para.pubip, j, DNAT, TO, fw_para.privstartip);
					eval(I4, A, i4_dmz, i, wan_ifname, d, fw_para.privstartip, j, ACCEPT);
					has_item=1;
				}
				if (*ptr2 == ' ') break;
				ptr1 = ptr2;
			} else {
				printf("%s: extract_nv() failed\n",fn);
				break;
			}
		}
		free (nv_buf);
		if (has_item) {
			eval(I4, t, nat, I, PREROUTING, i, wan_ifname, j, i4_dmz_preroute);
			eval(I4, A, FORWARD, i, wan_ifname, j, i4_dmz);
		}
	}
end:
	return rc;
}

static int
extract_nv(int fw_idx, char *pbuf, ipv4_fw_para *pfw_para)
{
	char *fn="extract_nv";
	int rc=0, len, item_num;
	char *item_buf=NULL, *ptr1, *ptr2;

	len = strlen(pbuf);
	item_buf = (char *)malloc(len+2);
	if (!item_buf) {
		printf("%s: Failed to allocate memory\n", fn);
		rc = 1;
		goto end;
	}
	memset(item_buf, '-', (len+2));
	strncpy(item_buf, pbuf, len);
	switch(fw_idx) {
		case FW_IDX_MAC:
			// item of nvram var fm format en-xx:xx:xx:xx:xx:xx
			ptr1 = item_buf;
printf("extract_nv: ptr1=%s\n",ptr1);
			item_num = 0;
			while ((ptr2 = strchr(ptr1, '-'))) {
				*ptr2++ = '\0';
printf("extract_nv 2: ptr1=%s\n",ptr1);
				switch(item_num) {
					case 0:
						strncpy(pfw_para->rule_en, ptr1, strlen(ptr1));
printf("pfw_para->rule_en=%s\n",pfw_para->rule_en);
					break;
					case 1:
						strncpy(pfw_para->mac, ptr1, strlen(ptr1));
printf("pfw_para->mac=%s\n",pfw_para->mac);
					break;
					case 2:
						//do nothing, PC name
					break;
					default:
						printf("%s: Error!!! Shouldn't reach here\n",fn);
						rc = 1;
				}
				if (*ptr2 == '-') break;
				ptr1 = ptr2;
				item_num++;
			}
		break;
		case FW_IDX_IPFILTER:
			// item of nvram var fi format
			// en-startip-stopip-startport-stopport-type-block-daystart-timestart-daystop-timestop
			ptr1 = item_buf;
printf("extract_nv: ptr1=%s\n",ptr1);
			item_num = 0;
			while ((ptr2 = strchr(ptr1, '-'))) {
				*ptr2++ = '\0';
printf("extract_nv 2: ptr1=%s\n",ptr1);
				switch(item_num) {
					struct in_addr lannet;

					case 0:
						strncpy(pfw_para->rule_en, ptr1, strlen(ptr1));
					break;
					case 1:
//						lannet.s_addr=(inet_addr(lan_ipaddr) & inet_addr(nvram_safe_get("lan_netmask")));
						lannet.s_addr=(inet_addr(lan_ipaddr) & inet_addr("255.255.255.0"));
						lannet.s_addr = lannet.s_addr | htonl(atoi(ptr1));
						strcpy(pfw_para->privstartip, inet_ntoa(lannet));
printf("privstartip=%s\n",pfw_para->privstartip);
					break;
					case 2:
//						lannet.s_addr=(inet_addr(lan_ipaddr) & inet_addr(nvram_safe_get("lan_netmask")));
						lannet.s_addr=(inet_addr(lan_ipaddr) & inet_addr("255.255.255.0"));
						lannet.s_addr = lannet.s_addr | htonl(atoi(ptr1));
						strcpy(pfw_para->privstopip, inet_ntoa(lannet));
printf("privstopip=%s\n",pfw_para->privstopip);
					break;
					case 3:
						strcpy(pfw_para->lstartdport, ptr1);
					break;
					case 4:
						strcpy(pfw_para->lstopdport, ptr1);
					break;
					case 5:
						strcpy(pfw_para->proto, ptr1);
					break;
					case 6:
						strcpy(pfw_para->timer_en, ptr1);
					break;
					case 7:
						strcpy(pfw_para->daystart, dayofweek[atoi(ptr1)]);
					break;
					case 8:
						strcpy(pfw_para->timestart, timeofday[atoi(ptr1)]);
					break;
					case 9:
						strcpy(pfw_para->daystop, dayofweek[atoi(ptr1)]);
					break;
					case 10:
						strcpy(pfw_para->timestop, timeofday[atoi(ptr1)]);
					break;
					default:
						printf("%s: Error!!! Shouldn't reach here\n",fn);
						rc = 1;
				}
				if (*ptr2 == '-') break;
				ptr1 = ptr2;
				item_num++;
			}
		break;
		case FW_IDX_FORWARD:
			// item of nvram var fwi format
			// en-description-startindport-stopindport-type-privip-startprivdport-stopprivdport
			ptr1 = item_buf;
printf("extract_nv: ptr1=%s\n",ptr1);
			item_num = 0;
			while ((ptr2 = strchr(ptr1, '-'))) {
				*ptr2++ = '\0';
printf("extract_nv 2: ptr1=%s\n",ptr1);
				switch(item_num) {
					struct in_addr lannet;

					case 0:
						strncpy(pfw_para->rule_en, ptr1, strlen(ptr1));
					break;
					case 1:
						// description, no business here
					break;
					case 2:
						strncpy(pfw_para->wstartdport, ptr1, strlen(ptr1));
					break;
					case 3:
						strncpy(pfw_para->wstopdport, ptr1, strlen(ptr1));
					break;
					case 4:
						strncpy(pfw_para->proto, ptr1, strlen(ptr1));
					break;
					case 5:
//						lannet.s_addr=(inet_addr(lan_ipaddr) & inet_addr(nvram_safe_get("lan_netmask")));
						lannet.s_addr=(inet_addr(lan_ipaddr) & 0xffffff);
						lannet.s_addr = lannet.s_addr | htonl(atoi(ptr1));
						strcpy(pfw_para->privstartip, inet_ntoa(lannet));
					break;
					case 6:
						strncpy(pfw_para->lstartdport, ptr1, strlen(ptr1));
					break;
					case 7:
						strncpy(pfw_para->lstopdport, ptr1, strlen(ptr1));
					break;
					default:
						printf("%s: Error!!! Shouldn't reach here\n",fn);
						rc = 1;
				}
				if (*ptr2 == '-') break;
				ptr1 = ptr2;
				item_num++;
			}
		break;
		case FW_IDX_DMZ:
			// item of nvram var dmz_ipaddr format en-statip-privip
			ptr1 = item_buf;
printf("extract_nv: ptr1=%s\n",ptr1);
			item_num = 0;
			//int rule_num=0; //Richard comment it, 20040707.
			while ((ptr2 = strchr(ptr1, '-'))) {
				*ptr2++ = '\0';
printf("extract_nv 2: ptr1=%s\n",ptr1);
				switch(item_num) {
					struct in_addr lannet;

					case 0:
						strncpy(pfw_para->rule_en, ptr1, strlen(ptr1));
printf("pfw_para->rule_en=%s\n",pfw_para->rule_en);
					break;
					case 1:
						if(!rule_num)
						{
							char *wan_pubip;
							wan_pubip=nvram_safe_get("wan_ipaddr");
printf("pubip=%s\n", wan_pubip);
							strncpy(pfw_para->pubip, wan_pubip, strlen(wan_pubip));
						}
						else
						strncpy(pfw_para->pubip, ptr1, strlen(ptr1));
						rule_num++;
					break;
					case 2:
						lannet.s_addr=(inet_addr(lan_ipaddr) & 0xffffff);
						lannet.s_addr = lannet.s_addr | htonl(atoi(ptr1));
						strcpy(pfw_para->privstartip, inet_ntoa(lannet));
					break;
					default:
						printf("%s: Error!!! Shouldn't reach here\n",fn);
						rc = 1;
				}
				if (*ptr2 == '-') break;
				ptr1 = ptr2;
				item_num++;
			}
		break;
		default:
			printf("%s: nvram firewall variable index %d is not supported\n", fn, fw_idx);
			rc = 1;
	}

	free(item_buf);
end:
	return rc;
}

static int
add_policy_accept()
{
        int rc=0;

        eval(I4,P,INPUT,ACCEPT);
        eval(I4,P,FORWARD,ACCEPT);
        eval(I4,P,OUTPUT,ACCEPT);
        eval(I4,t,nat,P,PREROUTING,ACCEPT);
        eval(I4,t,nat,P,POSTROUTING,ACCEPT);
        eval(I4,t,nat,P,OUTPUT,ACCEPT);

        return rc;
}

static int
add_policy_drop()
{
        int rc=0;

        eval(I4,P,INPUT,DROP);
        eval(I4,P,FORWARD,DROP);

        return rc;
}

static int
add_clamp_mss()
{
        int rc=0;

	eval(I4, I, FORWARD, p, tcp, tcp_flags, "SYN,RST", "SYN", j, "TCPMSS", "--clamp-mss-to-pmtu");

	return rc;
}

static int
add_spi_RE_rule()
{
        int rc=0;

	eval(I4, A, FORWARD, m, mstate, state, RELATED_ESTABLISHED, j, ACCEPT);
	eval(I4, A, INPUT, m, mstate, state, RELATED_ESTABLISHED, j, ACCEPT);

	return rc;
}

static int
add_spi_NEW_rule()
{
        int rc=0;

//	eval(I4, A, FORWARD, m, mstate, state, NEW, j, ACCEPT);
	eval(I4, A, FORWARD, i, lan_ifname, m, mstate, state, NEW, j, ACCEPT);
	eval(I4, A, INPUT, i, lan_ifname, m, mstate, state, NEW, j, ACCEPT);

	return rc;
}

static int
add_masquerade()
{
        int rc=0;

	eval(I4, t, nat, A, POSTROUTING, o, wan_ifname, j, MASQUERADE);

	return rc;
}

static int
add_ident_rule()
{
        int rc=0;

	eval(I4, A, INPUT, i, wan_ifname, p, tcp, dport, "113", j, ACCEPT);

	return rc;
}

static int
add_if_lo_rule()
{
        int rc=0;

	eval(I4, A, INPUT, i, "lo", j, ACCEPT);

	return rc;
}

static int
add_forward_chain_log()
{
	int rc=0;

	eval(I4, A, FORWARD, i, wan_ifname, j, LOG, log_pref, wan_log);
	return rc;
}

static int
add_input_chain_log()
{
	int rc=0;

	eval(I4, A, INPUT, i, wan_ifname, j, LOG, log_pref, wan_log);
	return rc;
}

static int
add_http_intercept()
{
	int rc=0;

	eval(I4, A, FORWARD, i, lan_ifname, p, tcp, dport, HTTP_SP, j, QUEUE);
	return rc;
}

// Michael, 07/06/2004, for l2tp/ipsec pass through
static int
do_l2tp_ipsec_pass_through()
{
	int rc = 0;
	//for l2tp pass through
	eval(I4, A, FORWARD, p, udp, dport, "1701", sport, "1701", j, ACCEPT);
	//for ipsec pass through
	eval(I4, A, FORWARD, p, udp, dport, "500", sport, "500", j, ACCEPT);
	//esp
	eval(I4, A, FORWARD, p, "50", j, ACCEPT);
	//ah
	eval(I4, A, FORWARD, p, "51", j, ACCEPT);

	return rc;
}

static int
do_dns_relay()
{
	int rc=0, ii;
	char dns_relay[50], *tmp_dns;

	if ((ii=strlen(nvram_safe_get("wan_dns")))) {
		memset(dns_relay, 32, ii+1);
		strncpy(dns_relay,nvram_safe_get("wan_dns"),ii);
		tmp_dns = strchr(dns_relay,' ');
		*tmp_dns = '\0';
		if (strcmp(dns_relay,allip)) {
			eval(I4, t, nat, A, PREROUTING, i, lan_ifname, d, lan_ipaddr, p, udp, dport, DNS_SP, j, DNAT, TO, dns_relay);
			eval(I4, t, nat, A, PREROUTING, i, lan_ifname, d, lan_ipaddr, p, tcp, dport, DNS_SP, j, DNAT, TO, dns_relay);
		}
	}

	return rc;
}

int
start_firewall(void)
{
	int rc=0;

	//enable_proc_variables();

        if ((rc = get_wan_ifname())) return rc;
        if ((rc = get_lan_ifname())) return rc;
        if ((rc = get_lan_ipaddr())) return rc;
        if ((rc = get_wan_ipaddr())) return rc;

	eval(I4,Z);
	eval(I4, F);
	eval(I4, t, nat, F);

	add_policy_accept();
	add_policy_drop();

        if (nvram_match(FW_DOS_EN, EN)) {
		do_dos();
	}

	add_ident_rule();

	/*Hank, for some reason we don't know, BRCM WDS with wpa-psk has to
	 *have this rule in order to work properly. 2004-05-18
	*/
	add_if_lo_rule();

        if  (nvram_match(MAC_FILTER_EN, EN)) {// Jerry Lee
	        do_mac_list();
        }
	do_ipfilter_list();

	add_http_intercept();

	add_spi_RE_rule();

	add_spi_NEW_rule();

	// Belkin says dmz hosts do not get dos protection
	// so rules must set before the dos rules in the PREROUTING chain
	do_dmz_list();
	do_forward_list();
	
	// 07/06/2004, michael
	do_l2tp_ipsec_pass_through();
	
	do_wan_ping();

	do_wan_http_management();

	add_forward_chain_log();
	add_input_chain_log();

	//do_dns_relay();

        add_masquerade();

	add_clamp_mss();
	
	enable_proc_variables();
        
        start_phase_monitor(2);//mtyan

	return rc;
}

int
stop_firewall(void)
{

	FILE *fp;

        if ((fp = fopen("/proc/sys/net/ipv4/ip_forward", "r+"))) {
                fputc('0', fp);
                fclose(fp);
        } else
                perror("/proc/sys/net/ipv4/ip_forward");

        if ((fp = fopen("/proc/sys/kernel/printk", "r+"))) {
                fputc('0', fp);
                fclose(fp);
        } else
                perror("/proc/sys/kernel/printk");

	eval(I4, F);
	eval(I4, t, nat, F);
        // the following added by Jerry Lee , begin
        eval("iptables","-P","INPUT","ACCEPT");
        eval("iptables","-P","FORWARD","ACCEPT");
        eval("iptables","-P","OUTPUT","ACCEPT");
        eval("iptables","-t","nat","-P","PREROUTING","ACCEPT");
        eval("iptables","-t","nat","-P","POSTROUTING","ACCEPT");
        eval("iptables","-t","nat","-P","OUTPUT","ACCEPT");
        //Jerry Lee , begin
	dprintf("done\n");
	return 0;
}

void
disable_firewall(void)
{
	erase_dos_rules();
}

#else

/*

 * Firewall services
 *
 * Copyright 2001, Askey International
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Askey International.
 * Author: Peter S
 * $Id: firewall.c,v 1.6 2004/09/02 21:42:16 hank Exp $
 */


/*This module is almost totally rewriten by Peter S for replacing netconfig by IPTABLES in firewall functions*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <dirent.h>
/*#include <linux/inet.h>*/

#include <bcmnvram.h>
#include <shutils.h>
#include <rc.h>
#include <netconf.h>

extern int netconf_clamp_mss_to_pmtu(void);

char *strrep_p(char *dst,const char *src);
void rule_reset(void);

/* Combination PREROUTING DNAT and <dir> ACCEPT */
static void
parse_port_forward_brcm(int ipproto, int dir, char *wordlist)
{
        netconf_nat_t nat;
        netconf_filter_t filter;
        char var[256], *next;
        char *wan_port0, *wan_port1, *lan_ipaddr, *lan_port0, *lan_port1;

        /* Parse wan_port0-wan_port1>lan_ipaddr:lan_port0-lan_port1 ... */
        foreach(var, wordlist, next) {
                lan_ipaddr = var;
                wan_port0 = strsep(&lan_ipaddr, ">");
                if (!wan_port0 || !lan_ipaddr)
                        continue;
                wan_port1 = wan_port0;
                wan_port0 = strsep(&wan_port1, "-");
                if (!wan_port0 || !wan_port1)
                        continue;
                lan_port0 = lan_ipaddr;
                lan_ipaddr = strsep(&lan_port0, ":");
                if (!lan_ipaddr || !lan_port0)
                        continue;
                lan_port1 = lan_port0;
                lan_port0 = strsep(&lan_port1, "-");
                if (!lan_port0 || !lan_port1)
                        continue;
                /* Set up WAN side match */
                memset(&nat, 0, sizeof(nat));
                nat.match.ipproto = ipproto;
                nat.match.src.ports[1] = htons(0xffff);
                nat.match.dst.ports[0] = htons(atoi(wan_port0));
                nat.match.dst.ports[1] = htons(atoi(wan_port1));
                strncpy(nat.match.in.name, nvram_safe_get("wan_ifname"), IFNAMSIZ);

                /* Set up DNAT to LAN */
                nat.target = NETCONF_DNAT;
                inet_aton(lan_ipaddr, &nat.ipaddr);
                nat.ports[0] = htons(atoi(lan_port0));
                nat.ports[1] = htons(atoi(lan_port1));

                /* Set up LAN side match */
                memset(&filter, 0, sizeof(filter));
                filter.match.ipproto = ipproto;
                filter.match.src.ports[1] = htons(0xffff);
                filter.match.dst.ipaddr.s_addr = nat.ipaddr.s_addr;
                filter.match.dst.netmask.s_addr = htonl(0xffffffff);
                filter.match.dst.ports[0] = nat.ports[0];
                filter.match.dst.ports[1] = nat.ports[1];

                /* Accept connection */
                filter.target = NETCONF_ACCEPT;
                filter.dir = dir;

                /* Do it */
                netconf_add_nat(&nat);
                netconf_add_filter(&filter);
        }
}




static void
parse_port_forward(char *ipproto, char *dir, char *wordlist)
{
        char var[256], *next;
        char *wan_port0, *wan_port1, *lan_ipaddr, *lan_port0, *lan_port1;
        char *port_range;
        char ip_port[256]="";
        char *port_log[16];

        /* Parse wan_port0-wan_port1>lan_ipaddr:lan_port0-lan_port1 ... */
        foreach(var, wordlist, next) {
                lan_ipaddr = var;
                wan_port0 = strsep(&lan_ipaddr, ">");
                if (!wan_port0 || !lan_ipaddr)
                        continue;
              /*  printf("wan_port0 is: %s\n",wan_port0);*/
                port_range=strrep_p(wan_port0,":");
             /*   printf("The port_range is: %s\n",port_range); */
                lan_port0 = lan_ipaddr;
                strcpy(ip_port,lan_port0);
                lan_ipaddr = strsep(&lan_port0, ":");
                if (!lan_ipaddr || !lan_port0)
                        continue;
              lan_port0=strrep_p(lan_port0,":");
        /*      printf("The destaination lan_port0 is : %s\n",lan_port0);
              printf("The destaination ip_port is : %s\n",ip_port);*/
             /*   printf("The lan_ipaddr is : %s\n",lan_ipaddr);*/

                /* Do it */


eval("iptables","-t","nat","-A","PREROUTING","-p",ipproto,"-i",nvram_safe_get("wan_ifname"),"-d","0/0","--dport",port_range,"-j","DNAT","--to-destination",ip_port);


if(!strncmp(ipproto,"TCP",3))
  {
/*eval("iptables","-A",dir,"-p",ipproto,"-d",lan_ipaddr,"--dport",port_range,"-i",nvram_safe_get("wan_ifname"),"-j","allowed");
*/

eval("iptables","-A",dir,"-p",ipproto,"-d",lan_ipaddr,"--dport",lan_port0,"-i",nvram_safe_get("wan_ifname"),"-j","allowed");
 }
 else {
/*
eval("iptables","-A",dir,"-p",ipproto,"-d",lan_ipaddr,"--dport",port_range,"-i",nvram_safe_get("wan_ifname"),"-j","ACCEPT");
*/

eval("iptables","-A",dir,"-p",ipproto,"-d",lan_ipaddr,"--dport",lan_port0,"-i",nvram_safe_get("wan_ifname"),"-j","ACCEPT");
  }

        }

if(nvram_invmatch("http_wanport","80"))
{
eval("iptables","-A","tcp_packets_input","-p","TCP","-d",nvram_safe_get("wan_ipaddr"),"--dport","80","-i",nvram_safe_get("wan_ifname"),"-j","DROP");
}

if(nvram_match("firewall_enable","1"))
 {
if(nvram_match("dmz_ipaddr","")) {
 if (ipproto=="TCP")
  {

eval("iptables","-A","tcp_packets_input","-p",ipproto,"-d",nvram_safe_get("wan_ipaddr"),"-i",nvram_safe_get("wan_ifname"),"-j","LOG","--log-prefix"," rt190w CAT=1 ");
  }
else {
eval("iptables","-A","udp_packets_input","-p",ipproto,"-d",nvram_safe_get("wan_ipaddr"),"-i",nvram_safe_get("wan_ifname"),"-j","LOG","--log-prefix"," rt190w CAT=1 ");
}
}
}


}




static void wan_access(void)
{
        DIR *dir;
        struct dirent *file;
        FILE *fp;
        char name[NAME_MAX];
        netconf_nat_t nat;
        netconf_filter_t filter;
        int inbound[] = { NETCONF_IN, NETCONF_FORWARD, -1 };
        int i;
        char var[256], *next;

        char ip_port[23];
        /* Enable remote management */
if(nvram_match("wan_ping","1"))
{
eval("iptables","-A","icmp_packets_input","-p","ICMP","-i",nvram_safe_get("wan_ifname"),"-s","0/0","-d",nvram_safe_get("wan_ipaddr"),"-j","ACCEPT");

}

else {
eval("iptables","-A","icmp_packets_input","-p","ICMP","-i",nvram_safe_get("wan_ifname"),"-s","0/0","-d",nvram_safe_get("wan_ipaddr"),"-j","LOG","--log-prefix"," rt190w CAT=1 ");

}

	// gmluong, 07/10/02, for iapp port (2044)
	if(nvram_match("aip_finder_en","1")) {
		eval("iptables","-I","INPUT","1","-p","udp","--dport","2044","-j","ACCEPT");
	}

	// gmluong, 07/20/02, add ident (113) for old ftp server
	eval("iptables","-A","INPUT","-i",nvram_safe_get("wan_ifname"),"-p","tcp","--dport","113","-j","ACCEPT");

	// gmluong, 07/22/02, for ipv6 tunneling (type 41)
	eval("iptables","-I","INPUT","2","-i",nvram_safe_get("wan_ifname"),"-p","41","-j","ACCEPT");

if(nvram_invmatch("http_wanport","") && nvram_match("http_wan_enable","1"))
{

memset(ip_port, 0, sizeof(ip_port));
strncpy(ip_port,nvram_safe_get("lan_ipaddr"),strlen(nvram_safe_get("lan_ipaddr")));
strcat(ip_port,":80");
eval("iptables","-t","nat","-I","PREROUTING","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-d",nvram_safe_get("lan_ipaddr"),"--dport",nvram_safe_get("http_wanport"),"-j","DROP");
eval("iptables","-t","nat","-I","PREROUTING","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-d",nvram_safe_get("lan_ipaddr"),"--dport","80","-j","DROP");
eval("iptables","-t","nat","-I","PREROUTING","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-d",nvram_safe_get("wan_ipaddr"),"--dport",nvram_safe_get("http_wanport"),"-j","DNAT","--to",ip_port);
eval("iptables","-I","INPUT","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-d",nvram_safe_get("lan_ipaddr"),"--dport","80","-j","ACCEPT");

/*
eval("iptables","-A","tcp_packets_input","-p","TCP","-d","0/0","--dport","80","-i",nvram_safe_get("wan_ifname"),"-j","allowed");
eval("iptables","-A","tcp_packets_input","-p","TCP","-d","0/0","--dport",nvram_safe_get("http_wanport"),"-i",nvram_safe_get("wan_ifname"),"-j","allowed");

eval("iptables","-A","tcp_packets_forward","-p","TCP","-d","0/0","--dport",nvram_safe_get("http_wanport"),"-i",nvram_safe_get("wan_ifname"),"-j","allowed");

eval("iptables","-A","tcp_packets_input","-p","TCP","-d",nvram_safe_get("lan_ipaddr"),"--dport","0:65535","-i",nvram_safe_get("wan_ifname"),"-j","allowed");
*/

//gmluong, 08/08/02, get rid of this for http port management
#if 0
        /* Enable remote management */
        if (nvram_invmatch("http_wanport", "")) {
                snprintf(name, sizeof(name), "%d-%d>%s:%d-%d",
                         atoi(nvram_safe_get("http_wanport")),
                         atoi(nvram_safe_get("http_wanport")),
                         nvram_safe_get("lan_ipaddr"),
                         atoi(nvram_safe_get("http_lanport")),
                         atoi(nvram_safe_get("http_lanport")));
                parse_port_forward_brcm(IPPROTO_TCP, NETCONF_IN, name);
        }
#endif

}

else {

eval("iptables","-A","tcp_packets_input","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-s","0/0","-d",nvram_safe_get("wan_ipaddr"),"-j","LOG","--log-prefix"," rt190w CAT=1 ");

eval("iptables","-A","tcp_packets_input","-p","TCP","-d",nvram_safe_get("wan_ipaddr"),"--dport","80","-i",nvram_safe_get("wan_ifname"),"-j","DROP");

}



}




static void n_tcp_rule(void)
{
        char var[256], *next;
        char *lan_ipaddr, *lan_port0, *lan_port1;
        char *port_range;
        /* Set up LAN side match */

/*eval("iptables","-N","tcp_packets_forward");*/

if(nvram_match("tcp_filter","1"))
{
        /* Parse [lan_ipaddr|*]:lan_port0-lan_port1 ... */
        foreach(var, nvram_safe_get("ft"), next) {
                lan_port0 = var;
                lan_ipaddr = strsep(&lan_port0, ":");
                if (!lan_ipaddr || !lan_port0)
                        continue;
                lan_port1 = lan_port0;
               port_range=strrep_p(lan_port1,":");
               /* printf("the  port range is: %s\n",port_range);
               printf("the  lan ip address is: %s\n",lan_ipaddr); */

                /* Finish LAN side match */
                if (*lan_ipaddr == '*') {
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s","0/0","--dport",port_range,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s","0/0","--dport",port_range,"-j","DROP");
                } else {
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s",lan_ipaddr,"--dport",port_range,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s",lan_ipaddr,"--dport",port_range,"-j","DROP");
		}
        }
}

}




static void n_udp_rule(void)
{
        char var[256], *next;
        char *lan_ipaddr, *lan_port0, *lan_port1;
        char *port_range;
        /* Set up LAN side match */

/*eval("iptables","-N","udp_packets_forward");*/

if(nvram_match("udp_filter","1"))
{
        /* Parse [lan_ipaddr|*]:lan_port0-lan_port1 ... */
        foreach(var, nvram_safe_get("fu"), next) {
                lan_port0 = var;
                lan_ipaddr = strsep(&lan_port0, ":");
                if (!lan_ipaddr || !lan_port0)
                        continue;
                lan_port1 = lan_port0;
               port_range=strrep_p(lan_port1,":");
               /*     printf("the  port range is: %s\n",port_range);
               printf("the  lan ip address is: %s\n",lan_ipaddr); */

                /* Finish LAN side match */
                if (*lan_ipaddr == '*') {
eval("iptables","-A","udp_packets_forward","-p","UDP","-s","0/0","--dport",port_range,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","udp_packets_forward","-p","UDP","-s","0/0","--dport",port_range,"-j","DROP");
                } else {
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",lan_ipaddr,"--dport",port_range,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",lan_ipaddr,"--dport",port_range,"-j","DROP");
		}
        }
}

}






void embed_rule(void)
{


eval("iptables","-A","tcp_builtin_forward","-p","TCP","-d","0/0","-m","multiport","--destination-port","137,138,139,445","-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=3-1 ");
eval("iptables","-A","tcp_builtin_forward","-p","TCP","-d","0/0","-m","multiport","--source-port","137,138,139,445","-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=3-1 ");

eval("iptables","-A","udp_builtin_forward","-p","UDP","-d","0/0","-m","multiport","--destination-port","137,138,139,445","-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=3-1 ");
eval("iptables","-A","udp_builtin_forward","-p","UDP","-d","0/0","-m","multiport","--source-port","137,138,139,445","-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=3-1 ");

if(nvram_match("default_policy","0"))
{
eval("iptables","-A","tcp_builtin_forward","-p","TCP","-d","0/0","-m","multiport","--destination-port","137,138,139,445","-j","DROP");
eval("iptables","-A","udp_builtin_forward","-p","UDP","-d","0/0","-m","multiport","--destination-port","137,138,139,445","-j","DROP");
eval("iptables","-A","tcp_builtin_forward","-p","TCP","-d","0/0","-m","multiport","--source-port","137,138,139,445","-j","DROP");
eval("iptables","-A","udp_builtin_forward","-p","UDP","-d","0/0","-m","multiport","--source-port","137,138,139,445","-j","DROP");
}

eval("iptables","-A","FORWARD","-p","TCP","-j","tcp_builtin_forward");
eval("iptables","-A","FORWARD","-p","UDP","-j","udp_builtin_forward");
eval("iptables","-A","INPUT","-p","TCP","-j","tcp_builtin_forward");
eval("iptables","-A","INPUT","-p","UDP","-j","udp_builtin_forward");


}


int
start_negative_firewall(void)
{
	DIR *dir;
	struct dirent *file;
	FILE *fp;
	char name[NAME_MAX];
	netconf_nat_t nat;
	netconf_filter_t filter;
	int inbound[] = { NETCONF_IN, NETCONF_FORWARD, -1 };
	int i;
	char var[256], *next;

	/* Reset firewall */

       /* netconf_reset_fw();*/



eval("iptables","-A","INPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
eval("iptables","-A","OUTPUT","-m","state","--state","NEW","-j","ACCEPT");


/*Here are for enable/disable wan  port icmp access*/
new_chain();


wan_access();

         if(nvram_match("internal_policy","1")) embed_rule();

eval("iptables","-A","INPUT","-p","ICMP","-j","icmp_packets_input");
eval("iptables","-A","OUTPUT","-p","ICMP","-j","icmp_packets_output");

eval("iptables","-A","INPUT","-p","TCP","-j","tcp_packets_input");
eval("iptables","-A","INPUT","-p","UDP","-j","udp_packets_input");


eval("iptables","-A","INPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
eval("iptables","-A","FORWARD","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");

        /* Enable remote management, Forward TCP and UDP connections/DMZ */
 virtual_rule();

eval("iptables","-A","FORWARD","-p","TCP","-j","tcp_packets_forward");
eval("iptables","-A","FORWARD","-p","UDP","-j","udp_packets_forward");



	/*
	 * Forward drops
	 */


if(nvram_match("ip_filter","1"))
{
	/* Filter by IP address */

	/* Parse lan_ipaddr0-lan_ipaddr1 ... */
	foreach(var, nvram_safe_get("fi"), next) {
		char *lan_ipaddr0, *lan_ipaddr1;
		struct in_addr start_addr, end_addr, addr;

		lan_ipaddr1 = var;
		lan_ipaddr0 = strsep(&lan_ipaddr1, "-");
		if (!lan_ipaddr0 || !lan_ipaddr1)
			continue;

		inet_aton(lan_ipaddr0, &start_addr);
		inet_aton(lan_ipaddr1, &end_addr);

		for (addr.s_addr = start_addr.s_addr;
		     ntohl(addr.s_addr) <= ntohl(end_addr.s_addr);
		     addr.s_addr = htonl(ntohl(addr.s_addr) + 1)) {

eval("iptables","-A","icmp_packets_forward","-p","icmp","-s",inet_ntoa(addr),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");

eval("iptables","-A","icmp_packets_forward","-p","ICMP","-s",inet_ntoa(addr),"-j","DROP");
eval("iptables","-A","esp_packets_forward","-p","esp","-s",inet_ntoa(addr),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","esp_packets_forward","-p","ESP","-s",inet_ntoa(addr),"-j","DROP");
eval("iptables","-A","ah_packets_forward","-p","ah","-s",inet_ntoa(addr),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","ah_packets_forward","-p","AH","-s",inet_ntoa(addr),"-j","DROP");
/*Set ip filter as  the general switch*/
eval("iptables","-A","udp_packets_forward","-p","udp","-s",inet_ntoa(addr),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",inet_ntoa(addr),"-j","DROP");
eval("iptables","-A","tcp_packets_forward","-p","tcp","-s",inet_ntoa(addr),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s",inet_ntoa(addr),"-j","DROP");
		}
	}
#if 0
        int rc=0;
	unsigned int i;
        char *buf, *ptr1, *ptr2, *ptr3, ptr[16];
        int len;
	in_addr_t ipb, ipe;

        len = strlen(nvram_safe_get("fi"));
        if (!len) goto end;

        buf = (char *)malloc(len + 2);
        memset(buf, 32, len+2);
        memcpy(buf,nvram_safe_get("fi"),len);
        ptr1 = buf;
        while ((ptr2 = strchr(ptr1, ' '))) {
                *ptr2++ = '\0';
		ptr3 = strchr(ptr1, '-');
		*ptr3++ = '\0';
		ipb = ntohl(inet_addr(ptr1));
		ipe = ntohl(inet_addr(ptr3));
printf("ipb=%x, ipe=%x, %d\n",ipb,ipe,ipe-ipb);
		for (i=(unsigned int)ipb; i<=(unsigned int)ipe; i++) {
			sprintf(ptr,"%u.%u.%u.%u",((i&0xff000000)>>24),((i&0xff0000)>>16),((i&0xff00)>>8),(i&0xff));
eval("iptables","-A","icmp_packets_forward","-p","icmp","-s",ptr,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","icmp_packets_forward","-p","ICMP","-s",ptr,"-j","DROP");
eval("iptables","-A","esp_packets_forward","-p","esp","-s",ptr,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","esp_packets_forward","-p","ESP","-s",ptr,"-j","DROP");
eval("iptables","-A","ah_packets_forward","-p","ah","-s",ptr,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","ah_packets_forward","-p","AH","-s",ptr,"-j","DROP");
/*Set ip filter as  the general switch*/
eval("iptables","-A","udp_packets_forward","-p","udp","-s",ptr,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",ptr,"-j","DROP");
eval("iptables","-A","tcp_packets_forward","-p","tcp","-s",ptr,"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s",ptr,"-j","DROP");
		}
                if (*ptr2 == ' ') break;
                ptr1 = ptr2;
	}
end:
#endif
}
eval("iptables","-A","FORWARD","-p","ICMP","-j","icmp_packets_forward");
eval("iptables","-A","FORWARD","-p","ESP","-j","esp_packets_forward");
eval("iptables","-A","FORWARD","-p","AH","-j","ah_packets_forward");


if(nvram_match("tcp_filter","1"))
	/* Filter by destination ports */
{
         n_tcp_rule();
/*eval("iptables","-A","FORWARD","-p","TCP","-j","tcp_packets_forward");*/
}
if(nvram_match("udp_filter","1"))
 {
       n_udp_rule();
/*eval("iptables","-A","FORWARD","-p","UDP","-j","udp_packets_forward");*/
}



   if(nvram_match("mac_filter","1"))
     {
       foreach(var, nvram_safe_get("fm"), next) {
                char *colon = var;
              /*   printf("The mac filter is :  %s",var);*/
       eval("iptables","-A","FORWARD","-m","mac","--mac-source",var,"-j","LOG","--log-pref"," rt190w CAT=2 ");
       eval("iptables","-A","FORWARD","-m","mac","--mac-source",var,"-j","DROP");
        }
     }



//gmluong, 08/10/02, move up
//         if(nvram_match("internal_policy","1")) embed_rule();


eval("iptables","-A","INPUT","-i",nvram_safe_get("lan_ifname"),"-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-i",nvram_safe_get("lan_ifname"),"-m","state","--state","NEW","-j","ACCEPT");

	/* Clamp TCP MSS to PMTU of WAN interface */
	if (strcmp(nvram_safe_get("wan_proto"), "pppoe") == 0)
		netconf_clamp_mss_to_pmtu();

	dprintf("done\n");
	return 0;
}

int
stop_firewall(void)
{
	flush_firewall();
	dprintf("done\n");
	return 0;
}



static void dos_rule(void)
{

/*bug->It seems the ip/netmask  will show error in IPTABLES when  http_wanport is not NULL in NVRAM:Just ignore it:  04/29*/
//char *lan_ipmask;
char lan_ipmask[32];

eval("iptables","-N","i4_syn_flood");
eval("iptables","-N","i4_udp_flood");
eval("iptables","-N","i4_icmp_flood");
eval("iptables","-N","dos_packets_input");
eval("iptables","-N","dos_packets_output");
eval("iptables","-N","dos_packets_forward");

// gmluong, 08/08/02, do this in IP stack
#if 0
/*Zero length log*/
eval("iptables","-A","dos_packets_input","-p","ALL","-m","length","--length","0","-j","LOG","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_output","-p","ALL","-m","length","--length","0","-j","LOG","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-p","ALL","-m","length","--length","0","-j","LOG","--log-prefix"," rt190w CAT=1 ");
#endif

// gmluong, 07/21/02, AF088
/* ip length not in 1-65535 log */
eval("iptables","-A","dos_packets_input","-p","ALL","-m","length","!","--length","1:65535","-j","LOG","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-p","ALL","-m","length","!","--length","1:65535","-j","LOG","--log-prefix"," rt190w CAT=1 ");

// gmluong, 07/21/02, add icmp redirect
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-p","icmp","--icmp-type","redirect","-j","LOG","--log-pref","rt190w CAT=1 ");

/*TCP null scan log*/
eval("iptables","-A","dos_packets_input","-p","tcp","--tcp-flags","ALL","NONE","-j","LOG","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_output","-p","tcp","--tcp-flags","ALL","NONE","-j","LOG","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-p","tcp","--tcp-flags","ALL","NONE","-j","LOG","--log-prefix"," rt190w CAT=1 ");

/*IP spoofing log*/
// gmluong, 07/21/02, add #if #endif pair
// gmluong, 07/22/02, looks linux assures no local source ip spoof is possible
// so get rid of the wan and lan ip here and do it in IP stack
memset(lan_ipmask, 0, sizeof(lan_ipmask));
strcpy(lan_ipmask,nvram_safe_get("lan_ipaddr"));
//strrep_net(lan_ipmask,"0");
strcat(lan_ipmask,"/");
strcat(lan_ipmask,nvram_safe_get("lan_netmask"));
//printf("The lan ip and netmask is: %s\n",lan_ipmask);
eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-j","LOG","--log-pref"," rt190w CAT=1 ");
#if 0
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s","10.0.0.0/8","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s","10.0.0.0/8","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s","172.16.0.0/12","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s","172.16.0.0/12","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s","192.168.0.0/16","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s","192.168.0.0/16","-j","LOG","--log-pref"," rt190w CAT=1 ");
#endif
//eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s","224.0.0.0/4","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s","240.0.0.0/5","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s","127.0.0.0/8","-j","LOG","--log-pref"," rt190w CAT=1 ");

#if 0
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s",nvram_safe_get("wan_ipaddr"),"-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s",nvram_safe_get("wan_ipaddr"),"-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_input","-s",nvram_safe_get("wan_ipaddr"),"-d",nvram_safe_get("wan_ipaddr"),"-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-s",nvram_safe_get("wan_ipaddr"),"-d",nvram_safe_get("wan_ipaddr"),"-j","LOG","--log-pref"," rt190w CAT=1 ");
if(nvram_match("http_wanport",""))
 {
lan_ipmask=nvram_safe_get("lan_ipaddr");
strrep_net(lan_ipmask,"0");
strcat(lan_ipmask,"/");
strcat(lan_ipmask,nvram_safe_get("lan_netmask"));
/*printf("The lan  ip  and netmask is: %s\n",lan_ipmask);*/
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-j","LOG","--log-pref"," rt190w CAT=1 ");
}
#endif

// gmluong, 08/08/02, do this land attack in IP stack
#if 0
//gmluong, 07/21/02, move to after IP spoof attack, want to use lan_ipmask here
// also add lan_ipaddr and lan_ipmask to list
/*Land attack log*/
eval("iptables","-A","dos_packets_input","-s",nvram_safe_get("wan_ipaddr"),"-d",nvram_safe_get("wan_ipaddr"),"-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_input","-s",nvram_safe_get("lan_ipaddr"),"-d",nvram_safe_get("lan_ipaddr"),"-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-d",lan_ipmask,"-j","LOG","--log-pref"," rt190w CAT=1 ");
#endif

/*Smurf attack log*/
eval("iptables","-A","dos_packets_input","-p","icmp","--icmp-type","echo-reply","-m","state","--state","NEW,INVALID","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-p","icmp","--icmp-type","echo-reply","-m","state","--state","NEW,INVALID","-j","LOG","--log-pref"," rt190w CAT=1 ");

//gmluong, 08/15/02, do it in IP stack
/*Ping of death log*/
#if 0
eval("iptables","-A","dos_packets_input","-p","icmp","--icmp-type","echo-request","-m","state","--state","INVALID","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-p","icmp","--icmp-type","echo-request","-m","state","--state","INVALID","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_input","-p","icmp","--icmp-type","echo-request","-m","length","--length","65535","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-p","icmp","--icmp-type","echo-request","-m","length","--length","65535","-j","LOG","--log-pref"," rt190w CAT=1 ");
#endif

//gmluong, 08/15/02, do it in IP stack
/*tear drop attack log*/
#if 0
eval("iptables","-A","dos_packets_input","-f","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-f","-j","LOG","--log-pref"," rt190w CAT=1 ");
#endif

/*RIP detect log*/
eval("iptables","-A","dos_packets_input","-p","udp","--dport","520","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-p","udp","--dport","520","-j","LOG","--log-pref"," rt190w CAT=1 ");

/*UDP flood log*/
/*eval("iptables","-A","dos_packets_input","-p","udp","-m","limit","--limit","3000/s","-j","RETURN");
eval("iptables","-A","dos_packets_forward","-p","udp","-m","limit","--limit","3000/s","-j","RETURN");
*/
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-p","udp","--sport","19","--dport","17","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-p","udp","--sport","19","--dport","17","-j","LOG","--log-pref"," rt190w CAT=1 ");
eval("iptables","-A","i4_udp_flood","-p","udp","-m","limit","--limit","40/s","--limit-burst","1","-j","RETURN");
eval("iptables","-A","i4_udp_flood","-p","udp","-m","limit","--limit","40/sec","--limit-burst","1","-j","LOG","--log-pref"," rt190w CAT=1 ");


/*SYN flood log*/
eval("iptables","-A","i4_syn_flood","-p","tcp","--syn","-m","limit","--limit","10/s","--limit-burst","1","-j","RETURN");
eval("iptables","-A","i4_syn_flood","-p","tcp","--syn","-m","limit","--limit","10/sec","--limit-burst","1","-j","LOG","--log-pref"," rt190w CAT=1 ");

/*ICMP flood log*/
eval("iptables","-A","i4_icmp_flood","-p","icmp","-m","limit","--limit","10/s","--limit-burst","1","-j","RETURN");
eval("iptables","-A","i4_icmp_flood","-p","icmp","-m","limit","--limit","10/sec","--limit-burst","1","-j","LOG","--log-pref"," rt190w CAT=1 ");

// gmluong, 07/22/02, following DROP could be combined with
// "ip length not in 1-65535 drop"
/*Zero length drop*/
//eval("iptables","-A","dos_packets_input","-p","ALL","-m","length","--length","0","-j","DROP");
//eval("iptables","-A","dos_packets_output","-p","ALL","-m","length","--length","0","-j","DROP");
//eval("iptables","-A","dos_packets_forward","-p","ALL","-m","length","--length","0","-j","DROP");

// gmluong, 07/21/02, AF088
/* ip length not in 1-65535 drop*/
eval("iptables","-A","dos_packets_input","-p","ALL","-m","length","!","--length","1:65535","-j","DROP");
eval("iptables","-A","dos_packets_forward","-p","ALL","-m","length","!","--length","1:65535","-j","DROP");

// gmluong, 07/21/02, add icmp redirect
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-p","icmp","--icmp-type","redirect","-j","DROP");

/*TCP null scan drop*/
eval("iptables","-A","dos_packets_input","-p","tcp","--tcp-flags","ALL","NONE","-j","DROP");
eval("iptables","-A","dos_packets_output","-p","tcp","--tcp-flags","ALL","NONE","-j","DROP");
eval("iptables","-A","dos_packets_forward","-p","tcp","--tcp-flags","ALL","NONE","-j","DROP");

// gmluong, 08/08/02, do this land attack in IP stack
#if 0
// gmluong, 07/02/02, lan_ipmask must be set before
// also add lan_ipaddr and lan_ipmask to list
/*Land attack drop*/
eval("iptables","-A","dos_packets_input","-s",nvram_safe_get("wan_ipaddr"),"-d",nvram_safe_get("wan_ipaddr"),"-j","DROP");
eval("iptables","-A","dos_packets_input","-s",nvram_safe_get("lan_ipaddr"),"-d",nvram_safe_get("lan_ipaddr"),"-j","DROP");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-d",lan_ipmask,"-j","DROP");
#endif

/*IP spoofing drop*/
// gmluong, 07/21/02, add #if #endif pair
// gmluong, 07/22/02, looks linux assures no local source ip spoof is possible
// so get rid of the wan and lan ip here
eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-j","DROP");
#if 0
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s","10.0.0.0/8","-j","DROP");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s","10.0.0.0/8","-j","DROP");
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s","172.16.0.0/12","-j","DROP");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s","172.16.0.0/12","-j","DROP");
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s","192.168.0.0/16","-j","DROP");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s","192.168.0.0/16","-j","DROP");
#endif
//eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s","224.0.0.0/4","-j","DROP");
eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s","240.0.0.0/5","-j","DROP");
eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-s","127.0.0.0/8","-j","DROP");

#if 0
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s",nvram_safe_get("wan_ipaddr"),"-j","DROP");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s",nvram_safe_get("wan_ipaddr"),"-j","DROP");
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s",nvram_safe_get("wan_ipaddr"),"-d",nvram_safe_get("wan_ipaddr"),"-j","DROP");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s",nvram_safe_get("wan_ipaddr"),"-d",nvram_safe_get("wan_ipaddr"),"-j","DROP");
if(nvram_match("http_wanport",""))
{
eval("iptables","-A","dos_packets_input","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-j","DROP");
eval("iptables","-A","dos_packets_forward","-i",nvram_safe_get("wan_ifname"),"-s",lan_ipmask,"-j","DROP");
}
#endif

/*Smurf attack drop*/
eval("iptables","-A","dos_packets_input","-p","icmp","--icmp-type","echo-reply","-m","state","--state","NEW,INVALID","-j","DROP");
eval("iptables","-A","dos_packets_forward","-p","icmp","--icmp-type","echo-reply","-m","state","--state","NEW,INVALID","-j","DROP");

//gmluong, 08/16/02, do this in IP stack
/*Ping of death drop*/
#if 0
eval("iptables","-A","dos_packets_input","-p","icmp","--icmp-type","echo-request","-m","state","--state","INVALID","-j","DROP");
eval("iptables","-A","dos_packets_forward","-p","icmp","--icmp-type","echo-request","-m","state","--state","INVALID","-j","DROP");
eval("iptables","-A","dos_packets_input","-p","icmp","--icmp-type","echo-request","-m","length","--length","65535","-j","DROP");
eval("iptables","-A","dos_packets_forward","-p","icmp","--icmp-type","echo-request","-m","length","--length","65535","-j","DROP");
#endif

/*tear drop attack drop*/
/*eval("iptables","-A","dos_packets_input","-f","-j","DROP");
eval("iptables","-A","dos_packets_forward","-f","-j","DROP");
*/

/*UDP flood drop*/
eval("iptables","-A","dos_packets_input","-p","udp","--sport","19","--dport","17","-j","DROP");
eval("iptables","-A","dos_packets_forward","-p","udp","--sport","19","--dport","17","-j","DROP");

/*SYN flood drop*/
eval("iptables","-A","i4_syn_flood","-j","DROP");

/*ICMP flood drop*/
eval("iptables","-A","i4_icmp_flood","-j","DROP");

/*UDP flood drop*/
eval("iptables","-A","i4_udp_flood","-j","DROP");

eval("iptables","-A","INPUT","-i",nvram_safe_get("wan_ifname"),"-p","tcp","--syn","-j","i4_syn_flood");
eval("iptables","-A","FORWARD","-i",nvram_safe_get("wan_ifname"),"-p","tcp","--syn","-j","i4_syn_flood");
eval("iptables","-A","INPUT","-i",nvram_safe_get("wan_ifname"),"-p","icmp","-j","i4_icmp_flood");
eval("iptables","-A","FORWARD","-i",nvram_safe_get("wan_ifname"),"-p","icmp","-j","i4_icmp_flood");
eval("iptables","-A","INPUT","-i",nvram_safe_get("wan_ifname"),"-p","udp","-j","i4_udp_flood");
eval("iptables","-A","FORWARD","-i",nvram_safe_get("wan_ifname"),"-p","udp","-j","i4_udp_flood");
eval("iptables","-A","INPUT","-j","dos_packets_input");
eval("iptables","-A","OUTPUT","-j","dos_packets_output");
eval("iptables","-A","FORWARD","-j","dos_packets_forward");


eval("iptables","-N","bad_tcp_packets_input");
eval("iptables","-N","bad_tcp_packets_output");
eval("iptables","-N","bad_tcp_packets_forward");


eval("iptables","-A","bad_tcp_packets_forward","-p","tcp","!","--syn","-m","state","--state","NEW","-j","LOG","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","FORWARD","-p","ALL","-m","state","--state","INVALID","-j","LOG","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","INPUT","-p","ALL","-m","state","--state","INVALID","-j","LOG","--log-prefix"," rt190w CAT=1 ");

eval("iptables","-A","INPUT","-p","TCP","-j","bad_tcp_packets_input");
eval("iptables","-A","OUTPUT","-p","TCP","-j","bad_tcp_packets_output");
eval("iptables","-A","FORWARD","-p","TCP","-j","bad_tcp_packets_forward");

eval("iptables","-A","bad_tcp_packets_forward","-p","tcp","!","--syn","-m","state","--state","NEW","-j","DROP");
eval("iptables","-A","FORWARD","-p","ALL","-m","state","--state","INVALID","-j","DROP");
eval("iptables","-A","INPUT","-p","ALL","-m","state","--state","INVALID","-j","DROP");

}




static void p_ip_rule(void)
{
        char name[NAME_MAX];
        char *tip="192.168.1.210";
        int i;
        char var[256], *next;


if(nvram_match("ip_filter","1"))
{
        /* Filter by IP address */

        /* Parse lan_ipaddr0-lan_ipaddr1 ... */
        foreach(var, nvram_safe_get("fi"), next) {
                char *lan_ipaddr0, *lan_ipaddr1;
                struct in_addr start_addr, end_addr, addr;

                lan_ipaddr1 = var;
	/*	printf("The var IP address is : %s\n", lan_ipaddr1);*/

                lan_ipaddr0 = strsep(&lan_ipaddr1,"-");
                if (!lan_ipaddr0 || !lan_ipaddr1)
                        continue;

                inet_aton(lan_ipaddr0, &start_addr);
                inet_aton(lan_ipaddr1, &end_addr);

                for (addr.s_addr = start_addr.s_addr;
                     ntohl(addr.s_addr) <= ntohl(end_addr.s_addr);
                     addr.s_addr = htonl(ntohl(addr.s_addr) + 1)) {
               tip=inet_ntoa(addr);
         /*     printf("The filter ip is: %s\n", tip); */
eval("iptables","-A","icmp_packets_forward","-p","ICMP","-s",tip,"-j","ACCEPT");
eval("iptables","-A","esp_packets_forward","-p","ESP","-s",tip,"-j","ACCEPT");
eval("iptables","-A","ah_packets_forward","-p","AH","-s",tip,"-j","ACCEPT");
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",tip,"--dport","500","-j","ACCEPT");
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",tip,"--dport","1723","-j","ACCEPT");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s",tip,"--dport","1723","-j","allowed");
eval("iptables","-A","gre_packets_forward","-p","47","-s",tip,"-m","state","--state","NEW","-j","ACCEPT");

/*Set ip filter as  the general switch*/
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",tip,"-j","ACCEPT");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s",tip,"-j","allowed");

                }
        }

}

/*else
{
eval("iptables","-A","FORWARD","-p","icmp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","icmp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");

eval("iptables","-A","FORWARD","-p","esp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","esp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");

eval("iptables","-A","FORWARD","-p","ah","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","ah","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");

eval("iptables","-A","udp_packets_forward","-p","UDP","--dport","1723","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","tcp_packets_forward","-p","TCP","--dport","1723","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","gre_packets_forward","-p","47","-m","state","--state","NEW","-j","ACCEPT");

eval("iptables","-A","udp_packets_forward","-p","UDP","--dport","500","-m","state","--state","NEW","-j","ACCEPT");

eval("iptables","-A","udp_packets_forward","-p","UDP","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-m","state","--state","NEW","-j","ACCEPT");
}
*/



eval("iptables","-A","icmp_packets_input","-p","ICMP","-i",nvram_safe_get("lan_ifname"),"-s","0/0","-j","ACCEPT");




}





static void p_tcp_rule(void)
{
        char var[256], *next;
        char *lan_ipaddr, *lan_port0, *lan_port1;
        char *port_range;
        /* Set up LAN side match */

if(nvram_match("tcp_filter","1"))
{
        /* Parse [lan_ipaddr|*]:lan_port0-lan_port1 ... */
        foreach(var, nvram_safe_get("ft"), next) {
                lan_port0 = var;
                lan_ipaddr = strsep(&lan_port0, ":");
                if (!lan_ipaddr || !lan_port0)
                        continue;
                lan_port1 = lan_port0;
               port_range=strrep_p(lan_port1,":");
                  /*    printf("the  port range is: %s\n",port_range);
               printf("the  lan ip address is: %s\n",lan_ipaddr);*/

                /* Finish LAN side match */
                if (*lan_ipaddr == '*') {
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s","0/0","--dport",port_range,"-j","ACCEPT");
                } else {
eval("iptables","-A","tcp_packets_forward","-p","TCP","-s",lan_ipaddr,"--dport",port_range,"-j","ACCEPT");
                }
        }
}
/*else
{
eval("iptables","-A","FORWARD","-p","tcp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","tcp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
}
*/

/*eval("iptables","-A","tcp_packets_input","-p","TCP","-i",nvram_safe_get("lan_ifname"),"-s","0/0","--dport","80","-j","allowed");
                 */

// gmluong, 08/08/02, seems redundant
//eval("iptables","-A","tcp_packets_input","-p","TCP","-i",nvram_safe_get("lan_ifname"),"-s","0/0","--dport","0:65535","-j","ACCEPT");

}



static void p_udp_rule(void)
{

        char var[256], *next;
        char *lan_ipaddr, *lan_port0, *lan_port1;
        char *port_range,*port_range1;
        /* Set up LAN side match */

if(nvram_match("udp_filter","1"))
{
        /* Parse [lan_ipaddr|*]:lan_port0-lan_port1 ... */
        foreach(var, nvram_safe_get("fu"), next) {
                lan_port0 = var;
                lan_ipaddr = strsep(&lan_port0, ":");
                if (!lan_ipaddr || !lan_port0)
                        continue;
                lan_port1 = lan_port0;
               port_range=strrep_p(lan_port1,":");
         /*      printf("the  port range is: %s\n",port_range);
               printf("the  lan ip address is: %s\n",lan_ipaddr);*/

                /* Finish LAN side match */
                if (*lan_ipaddr == '*') {
eval("iptables","-A","udp_packets_forward","-p","UDP","-s","0/0","--dport",port_range,"-j","ACCEPT");
/*eval("iptables","-A","udp_packet_forward","-p","udp","--dport",port_range,"-m","state","--state","NEW","-j","ACCEPT");
*/                } else {
eval("iptables","-A","udp_packets_forward","-p","UDP","-s",lan_ipaddr,"--dport",port_range,"-j","ACCEPT");
/*eval("iptables","-A","udp_packet_forward","-p","udp","--dport",port_range,"-m","state","--state","NEW","-j","ACCEPT");
*/                }
        }

eval("iptables","-A","FORWARD","-p","udp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
}
/*else
{
eval("iptables","-A","FORWARD","-p","udp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","udp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
}
*/
eval("iptables","-A","udp_packets_input","-p","udp","-i",nvram_safe_get("lan_ifname"),"-j","ACCEPT");

// gmluong, 08/08/02, seems redundant
//eval("iptables","-A","udp_packets_output","-p","udp","-m","state","--state","NEW","-j","allowed");


}





static void p_mac_rule(void)
{
        char name[NAME_MAX];
        int i;
        char var[256], *next;

// gmluong, 08/08/02, seems redundant
//eval("iptables","-A","icmp_packets_input","-p","ICMP","-i",nvram_safe_get("lan_ifname"),"-s","0/0","-j","ACCEPT");

wan_access();

// gmluong, 08/08/02, seems redundant
//eval("iptables","-A","tcp_packets_input","-p","TCP","-i",nvram_safe_get("lan_ifname"),"-s","0/0","--dport","0:65535","-j","allowed");

// gmluong, 08/08/02, seems redundant
//eval("iptables","-A","udp_packets_input","-p","udp","-i",nvram_safe_get("lan_ifname"),"-j","ACCEPT");

// gmluong, 08/08/02, seems redundant
//eval("iptables","-A","udp_packets_output","-p","udp","-m","state","--state","NEW","-j","ACCEPT");

        /* Filter by MAC address */
   if(nvram_match("mac_filter","1"))
     {
       foreach(var, nvram_safe_get("fm"), next) {
                char *colon = var;
              /*   printf("The mac filter is :  %s",var);*/
        eval("iptables","-A","FORWARD","-m","mac","--mac-source",var,"-j","ACCEPT");
        }
     }
}


static void virtual_rule(void)
{

        char name[NAME_MAX];




        /* Forward TCP and UDP connections */
                parse_port_forward("TCP", "tcp_packets_forward", nvram_safe_get("fwt"));
                parse_port_forward("UDP", "udp_packets_forward", nvram_safe_get("fwu"));

if(!nvram_match("dmz_ipaddr",""))
{
eval("iptables","-t","nat","-A","PREROUTING","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-d","0/0","--dport","0:65535","-j","DNAT","--to-destination",nvram_safe_get("dmz_ipaddr"));
eval("iptables","-A","tcp_packets_forward","-p","TCP","-d",nvram_safe_get("dmz_ipaddr"),"--dport","0:65535","-i",nvram_safe_get("wan_ifname"),"-j","ACCEPT");


eval("iptables","-t","nat","-A","PREROUTING","-p","UDP","-i",nvram_safe_get("wan_ifname"),"-d","0/0","--dport","0:65535","-j","DNAT","--to-destination",nvram_safe_get("dmz_ipaddr"));


eval("iptables","-A","udp_packets_forward","-p","UDP","-d",nvram_safe_get("dmz_ipaddr"),"--dport","0:65535","-i",nvram_safe_get("wan_ifname"),"-j","ACCEPT");
}

/*eval("iptables","-t","nat","-A","PREROUTING","-i",nvram_safe_get("wan_ifname"),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=3 ");
*/



}


static void log_rule(void)
{


/*eval("iptables","-A","icmp_packets_forward","-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=3 ");
eval("iptables","-A","icmp_packets_input","-j","LOG","--log-level","info","--log-prefix","icmp input");
eval("iptables","-A","FORWARD","-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=3 ");
eval("iptables","-A","tcp_packets_input","-j","LOG","--log-level","info","--log-prefix","tcp input");
eval("iptables","-A","tcp_packets_forward","-j","LOG","--log-level","info","--log-prefix","tcp forward");

eval("iptables","-A","bad_tcp_packets_forward","-p","tcp","!","--syn","-m","state","--state","NEW","-j","LOG","--log-level","info","--log-prefix","New not syn");
*/
;
}


void filter_disable(void)
{


eval("iptables","-A","FORWARD","-p","icmp","-i",nvram_safe_get("wan_ifname"),"-m","state","--state","NEW","-j","DROP");

eval("iptables","-A","FORWARD","-p","icmp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","icmp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");

eval("iptables","-A","FORWARD","-p","esp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","esp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");

eval("iptables","-A","FORWARD","-p","ah","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","ah","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");

eval("iptables","-A","udp_packets_forward","-p","UDP","--dport","1723","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","tcp_packets_forward","-p","TCP","--dport","1723","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","gre_packets_forward","-p","47","-m","state","--state","NEW","-j","ACCEPT");

eval("iptables","-A","udp_packets_forward","-p","UDP","--dport","500","-m","state","--state","NEW","-j","ACCEPT");

eval("iptables","-A","udp_packets_forward","-p","UDP","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","tcp_packets_forward","-p","TCP","-m","state","--state","NEW","-j","ACCEPT");



eval("iptables","-A","icmp_packets_input","-p","ICMP","-i",nvram_safe_get("lan_ifname"),"-s","0/0","-j","ACCEPT");

/*eval("iptables","-I","FORWARD","1","-p","icmp","-i",nvram_safe_get("wan_ifname"),"-s","0/0","-j","DROP");
*/

wan_access();

eval("iptables","-A","FORWARD","-p","tcp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","tcp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");


eval("iptables","-A","tcp_packets_input","-p","TCP","-i",nvram_safe_get("lan_ifname"),"-s","0/0","--dport","0:65535","-j","allowed");


eval("iptables","-A","FORWARD","-p","udp","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-p","udp","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");


eval("iptables","-A","udp_packets_input","-p","udp","-i",nvram_safe_get("lan_ifname"),"-j","ACCEPT");

eval("iptables","-A","udp_packets_output","-p","udp","-m","state","--state","NEW","-j","ACCEPT");



}



int
start_positive_firewall(void)
{
        FILE *fp;
        netconf_nat_t nat;


eval("iptables","-N","allowed");

eval("iptables","-N","gre_packets_forward");

eval("iptables","-N","icmp_packets_input");
eval("iptables","-N","icmp_packets_output");
eval("iptables","-N","icmp_packets_forward");

eval("iptables","-N","tcp_packets_input");
eval("iptables","-N","tcp_packets_output");
eval("iptables","-N","tcp_packets_forward");

eval("iptables","-N","esp_packets_forward");
eval("iptables","-N","ah_packets_forward");

eval("iptables","-N","udp_packets_input");
eval("iptables","-N","udp_packets_output");
eval("iptables","-N","udp_packets_forward");

/*allowed chain*/
eval("iptables","-A","allowed","-p","TCP","--syn","-j","ACCEPT");
eval("iptables","-A","allowed","-p","TCP","-m","state","--state","ESTABLISHED,RELATED","-j","ACCEPT");
eval("iptables","-A","allowed","-p","TCP","-j","DROP");



if(nvram_match("mac_filter","0")
   && nvram_match("ip_filter","0")
     && nvram_match("tcp_filter","0")
       && nvram_match("udp_filter","0")  )
{

filter_disable();
}
else {
p_mac_rule();
p_ip_rule();
p_tcp_rule();
p_udp_rule();
}

virtual_rule();

/*log_rule();*/


/*eval("iptables","-A","INPUT","-p","TCP","-j","bad_tcp_packets_input");
eval("iptables","-A","OUTPUT","-p","TCP","-j","bad_tcp_packets_output");
eval("iptables","-A","FORWARD","-p","TCP","-j","bad_tcp_packets_forward");
*/
eval("iptables","-A","FORWARD","-p","47","-j","gre_packets_forward");

eval("iptables","-A","INPUT","-p","ICMP","-j","icmp_packets_input");
eval("iptables","-A","OUTPUT","-p","ICMP","-j","icmp_packets_output");
eval("iptables","-A","FORWARD","-p","ICMP","-j","icmp_packets_forward");

eval("iptables","-A","FORWARD","-p","ESP","-j","esp_packets_forward");
eval("iptables","-A","FORWARD","-p","AH","-j","ah_packets_forward");

eval("iptables","-A","INPUT","-p","TCP","-j","tcp_packets_input");
eval("iptables","-A","OUTPUT","-p","TCP","-j","tcp_packets_output");
eval("iptables","-A","FORWARD","-p","TCP","-j","tcp_packets_forward");


eval("iptables","-A","INPUT","-p","UDP","-j","udp_packets_input");
eval("iptables","-A","OUTPUT","-p","UDP","-j","udp_packets_output");
eval("iptables","-A","FORWARD","-p","UDP","-j","udp_packets_forward");


eval("iptables","-A","INPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
eval("iptables","-A","INPUT","-i",nvram_safe_get("wan_ifname"),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","INPUT","-i",nvram_safe_get("lan_ifname"),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");
eval("iptables","-A","INPUT","-m","state","--state","NEW","-j","DROP");


eval("iptables","-A","FORWARD","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");


//gmluong, 08/10/02, positive list does not have fujitsu embed_rule()
//if(nvram_match("internal_policy","1")) embed_rule();

eval("iptables","-A","FORWARD","-i",nvram_safe_get("wan_ifname"),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=1 ");
eval("iptables","-A","FORWARD","-i",nvram_safe_get("lan_ifname"),"-j","LOG","--log-level","info","--log-prefix"," rt190w CAT=2 ");


eval("iptables","-A","FORWARD","-m","state","--state","NEW","-j","DROP");

}


void new_chain(void)
{
eval("iptables","-N","tcp_builtin_forward");
eval("iptables","-N","udp_builtin_forward");

eval("iptables","-N","allowed");

eval("iptables","-N","icmp_packets_input");
eval("iptables","-N","icmp_packets_output");
eval("iptables","-N","icmp_packets_forward");

eval("iptables","-N","esp_packets_forward");
eval("iptables","-N","ah_packets_forward");

eval("iptables","-N","tcp_packets_input");
eval("iptables","-N","tcp_packets_output");
eval("iptables","-N","tcp_packets_forward");

eval("iptables","-N","udp_packets_input");
eval("iptables","-N","udp_packets_output");
eval("iptables","-N","udp_packets_forward");

/*allowed chain*/
eval("iptables","-A","allowed","-p","TCP","--syn","-j","ACCEPT");
eval("iptables","-A","allowed","-p","TCP","-m","state","--state","ESTABLISHED,RELATED","-j","ACCEPT");
eval("iptables","-A","allowed","-p","TCP","-j","DROP");


}



void link_chain(void)
{
eval("iptables","-A","INPUT","-p","ICMP","-j","icmp_packets_input");
eval("iptables","-A","OUTPUT","-p","ICMP","-j","icmp_packets_output");
eval("iptables","-A","FORWARD","-p","ICMP","-j","icmp_packets_forward");


eval("iptables","-A","INPUT","-p","TCP","-j","tcp_packets_input");
eval("iptables","-A","OUTPUT","-p","TCP","-j","tcp_packets_output");
eval("iptables","-A","FORWARD","-p","TCP","-j","tcp_packets_forward");


eval("iptables","-A","INPUT","-p","UDP","-j","udpi_packets_input");
eval("iptables","-A","OUTPUT","-p","UDP","-j","udp_packets_output");
eval("iptables","-A","FORWARD","-p","UDP","-j","udp_packets_forward");


}



char *strrep_p(char *dst,const char *src)
{
char * tmp=dst;

while(*dst++ !='-');

dst--;
*dst=':';

return tmp;

}


char *strrep_net(char *dst,const char *src)
{
char * tmp=dst;

while(*dst++);

dst -=2;
*dst='0';

return tmp;

}



void flush_firewall(void)
{

eval("iptables","-F","gre_packets_forward");

eval("iptables","-F","bad_tcp_packets_input");
eval("iptables","-F","bad_tcp_packets_output");
eval("iptables","-F","bad_tcp_packets_forward");

eval("iptables","-F","tcp_builtin_forward");
eval("iptables","-F","udp_builtin_forward");

eval("iptables","-F","allowed");
eval("iptables","-F","icmp_packets_input");
eval("iptables","-F","icmp_packets_output");
eval("iptables","-F","icmp_packets_forward");

eval("iptables","-F","esp_packets_forward");
eval("iptables","-F","ah_packets_forward");

eval("iptables","-F","tcp_packets_input");
eval("iptables","-F","tcp_packets_output");
eval("iptables","-F","tcp_packets_forward");

eval("iptables","-F","udp_packets_input");
eval("iptables","-F","udp_packets_output");
eval("iptables","-F","udp_packets_forward");

eval("iptables","-F","i4_syn_flood");
eval("iptables","-F","i4_udp_flood");
eval("iptables","-F","i4_icmp_flood");
eval("iptables","-F","dos_packets_input");
eval("iptables","-F","dos_packets_output");
eval("iptables","-F","dos_packets_forward");

eval("iptables","-F","INPUT");
eval("iptables","-F","FORWARD");
eval("iptables","-F","OUTPUT");
eval("iptables","-t","nat","-F");
eval("iptables","-t","mangle","-F");
eval("iptables","-X");
eval("iptables","-t","nat","-X");
eval("iptables","-t","mangle","-X");

eval("iptables","-P","INPUT","ACCEPT");
eval("iptables","-P","FORWARD","ACCEPT");
eval("iptables","-P","OUTPUT","ACCEPT");
eval("iptables","-t","nat","-P","PREROUTING","ACCEPT");
eval("iptables","-t","nat","-P","POSTROUTING","ACCEPT");
eval("iptables","-t","nat","-P","OUTPUT","ACCEPT");

}


void rule_reset(void)
{

eval("iptables","-F","gre_packets_forward");

eval("iptables","-F","bad_tcp_packets_input");
eval("iptables","-F","bad_tcp_packets_output");
eval("iptables","-F","bad_tcp_packets_forward");

eval("iptables","-F","tcp_builtin_forward");
eval("iptables","-F","udp_builtin_forward");

eval("iptables","-F","allowed");
eval("iptables","-F","icmp_packets_input");
eval("iptables","-F","icmp_packets_output");
eval("iptables","-F","icmp_packets_forward");

eval("iptables","-F","esp_packets_forward");
eval("iptables","-F","ah_packets_forward");

eval("iptables","-F","tcp_packets_input");
eval("iptables","-F","tcp_packets_output");
eval("iptables","-F","tcp_packets_forward");

eval("iptables","-F","udp_packets_input");
eval("iptables","-F","udp_packets_output");
eval("iptables","-F","udp_packets_forward");

eval("iptables","-F","i4_syn_flood");
eval("iptables","-F","i4_udp_flood");
eval("iptables","-F","i4_icmp_flood");
eval("iptables","-F","dos_packets_input");
eval("iptables","-F","dos_packets_output");
eval("iptables","-F","dos_packets_forward");

eval("iptables","-F","INPUT");
eval("iptables","-F","FORWARD");
eval("iptables","-F","OUTPUT");
eval("iptables","-t","nat","-F");
eval("iptables","-t","mangle","-F");
eval("iptables","-X");
eval("iptables","-t","nat","-X");
eval("iptables","-t","mangle","-X");

eval("iptables","-L");


eval("iptables","-P","INPUT","DROP");
eval("iptables","-P","FORWARD","DROP");
eval("iptables","-P","OUTPUT","ACCEPT");
eval("iptables","-t","nat","-P","PREROUTING","ACCEPT");
eval("iptables","-t","nat","-P","POSTROUTING","ACCEPT");
eval("iptables","-t","nat","-P","OUTPUT","ACCEPT");

eval("iptables","-A","INPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
eval("iptables","-A","OUTPUT","-m","state","--state","NEW","-j","ACCEPT");

}




int  start_firewall(void)

{
        DIR *dir;
        struct dirent *file;
        FILE *fp;
        netconf_nat_t nat;
        char name[NAME_MAX];
	char *def_nvdata,*def_nvdata_tmp;
	unsigned short int  *cdef_nvdata;
        int i=0;

        rule_reset();

        /*
         * NAT
         */

        /* Enable IP masquerading */
        if ((fp = fopen("/proc/sys/net/ipv4/ip_forward", "r+"))) {
                fputc('1', fp);
                fclose(fp);
        } else
                perror("/proc/sys/net/ipv4/ip_forward");

        // gmluong, 07/15/02, add for DNS relay
	if ((i=strlen(nvram_safe_get("wan_dns")))) {
		memset(name, 32, i+1);
		strncpy(name,nvram_safe_get("wan_dns"),i);
		def_nvdata_tmp = strchr(name,' ');
		*def_nvdata_tmp = '\0';
		if (strcmp(name,"0.0.0.0")) {
			eval("iptables","-t","nat","-A","PREROUTING","-i","br0","-d",nvram_safe_get("lan_ipaddr"),"-p","udp","--dport","53","-j","DNAT","--to",name);
			eval("iptables","-t","nat","-A","PREROUTING","-i","br0","-d",nvram_safe_get("lan_ipaddr"),"-p","tcp","--dport","53","-j","DNAT","--to",name);
			eval("iptables","-t","nat","-A","POSTROUTING","-o","br0","-s",name,"-p","udp","--sport","53","-j","SNAT","--to",nvram_safe_get("lan_ipaddr"));
			eval("iptables","-t","nat","-A","POSTROUTING","-o","br0","-s",name,"-p","tcp","--sport","53","-j","SNAT","--to",nvram_safe_get("lan_ipaddr"));
		}
	}

 eval("iptables","-t","nat","-A","POSTROUTING","-p","ALL","-o",nvram_safe_get("wan_ifname"),"-j","MASQUERADE");

/*printf("Enable console logging\n");*/

        if ((fp = fopen("/proc/sys/kernel/printk", "r+"))) {
                fputc('5', fp);
                fclose(fp);
        } else
                perror("/proc/sys/kernel/printk");

	//gmluong, 08/21/02, to exam andalter the MSS value of TCP SYN packets
	eval("iptables","-I","FORWARD","-p","tcp","--tcp-flags","SYN,RST","SYN","-j","TCPMSS","--clamp-mss-to-pmtu");

if(nvram_match("firewall_enable","1"))
 {

eval("iptables","-N","bad_tcp_packets_input");
eval("iptables","-N","bad_tcp_packets_output");
eval("iptables","-N","bad_tcp_packets_forward");

        /* Block obviously spoofed IP addresses */
        if (!(dir = opendir("/proc/sys/net/ipv4/conf")))
                perror("/proc/sys/net/ipv4/conf");
        while (dir && (file = readdir(dir))) {
                if (strncmp(file->d_name, ".", NAME_MAX) != 0 &&
                    strncmp(file->d_name, "..", NAME_MAX) != 0) {
                        sprintf(name, "/proc/sys/net/ipv4/conf/%s/rp_filter", file->d_name);
                        if (!(fp = fopen(name, "r+"))) {
                                perror(name);
                                break;
                        }
                        fputc('1', fp);
                        fclose(fp);
                }
        }

//gmluong, 08/16/02, request to block the control channel of tftp from lan to wan
	{
		eval("iptables","-A","FORWARD","-p","udp","--dport","69","-j","DROP");
	}

eval("iptables","-A","INPUT","-i",nvram_safe_get("lan_ifname"),"-m","state","--state","NEW","-j","ACCEPT");

if(nvram_match("dos_enable","1"))
       dos_rule();

if(nvram_match("default_policy","1"))
{
 start_positive_firewall();
}
else  {
start_negative_firewall();
}
} /*end of if(nvram_match("log_console","1"))*/

else {

disable_firewall();

}


}



void  disable_firewall(void)

{

        FILE *fp;
        netconf_nat_t nat;
        char name[NAME_MAX];
        char ip_port[256];
      /* rule_reset();*/

printf("\n... The firewall is disable...\n");

eval("iptables","-L");

eval("iptables","-P","INPUT","ACCEPT");
eval("iptables","-P","FORWARD","ACCEPT");
eval("iptables","-P","OUTPUT","ACCEPT");
eval("iptables","-t","nat","-P","PREROUTING","ACCEPT");
eval("iptables","-t","nat","-P","POSTROUTING","ACCEPT");
eval("iptables","-t","nat","-P","OUTPUT","ACCEPT");

eval("iptables","-A","INPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
eval("iptables","-A","OUTPUT","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","OUTPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
eval("iptables","-A","INPUT","-m","state","--state","NEW","-j","ACCEPT");

        /*
         * NAT
         */

        /* Enable IP masquerading */
        if ((fp = fopen("/proc/sys/net/ipv4/ip_forward", "r+"))) {
                fputc('1', fp);
                fclose(fp);
        } else
                perror("/proc/sys/net/ipv4/ip_forward");


eval("iptables","-N","allowed");

eval("iptables","-N","gre_packets_forward");

eval("iptables","-N","icmp_packets_input");
eval("iptables","-N","icmp_packets_output");
eval("iptables","-N","icmp_packets_forward");

eval("iptables","-N","tcp_packets_input");
eval("iptables","-N","tcp_packets_output");
eval("iptables","-N","tcp_packets_forward");

eval("iptables","-N","esp_packets_forward");
eval("iptables","-N","ah_packets_forward");

eval("iptables","-N","udp_packets_input");
eval("iptables","-N","udp_packets_output");
eval("iptables","-N","udp_packets_forward");

/*allowed chain*/
eval("iptables","-A","allowed","-p","TCP","--syn","-j","ACCEPT");
eval("iptables","-A","allowed","-p","TCP","-m","state","--state","ESTABLISHED,RELATED","-j","ACCEPT");
eval("iptables","-A","allowed","-p","TCP","-j","DROP");

eval("iptables","-A","FORWARD","-p","icmp","-i",nvram_safe_get("wan_ifname"),"-m","state","--state","NEW","-j","DROP");

        /* Enable remote management */
eval("iptables","-A","icmp_packets_input","-p","ICMP","-i",nvram_safe_get("wan_ifname"),"-s","0/0","-d",nvram_safe_get("wan_ipaddr"),"-j","ACCEPT");


/*ip_port=nvram_safe_get("lan_ipaddr");*/

strcpy(ip_port,nvram_safe_get("lan_ipaddr"));


strcat(ip_port,":80");

/*printf("The   ip  and port is: %s\n",ip_port);
*/

eval("iptables","-t","nat","-A","PREROUTING","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-d","0/0","--dport",nvram_safe_get("http_wanport"),"-j","DNAT","--to-destination",ip_port);

/*eval("iptables","-t","nat","-A","PREROUTING","-p","TCP","-i",nvram_safe_get("wan_ifname"),"-d","0/0","--dport",nvram_safe_get("http_wanport"),"-j","DNAT","--to-destination",nvram_safe_get("lan_ipaddr"));
*/


eval("iptables","-A","tcp_packets_input","-p","TCP","-d",nvram_safe_get("lan_ipaddr"),"--dport","0:65535","-i",nvram_safe_get("wan_ifname"),"-j","allowed");


eval("iptables","-A","tcp_packets_input","-p","TCP","-d",nvram_safe_get("lan_ipaddr"),"--dport","80","-i",nvram_safe_get("wan_ifname"),"-j","allowed");


virtual_rule();


/*eval("iptables","-A","INPUT","-p","TCP","-j","bad_tcp_packets_input");
eval("iptables","-A","OUTPUT","-p","TCP","-j","bad_tcp_packets_output");
eval("iptables","-A","FORWARD","-p","TCP","-j","bad_tcp_packets_forward");
*/
eval("iptables","-A","FORWARD","-p","47","-j","gre_packets_forward");

eval("iptables","-A","INPUT","-p","ICMP","-j","icmp_packets_input");
eval("iptables","-A","OUTPUT","-p","ICMP","-j","icmp_packets_output");
eval("iptables","-A","FORWARD","-p","ICMP","-j","icmp_packets_forward");

eval("iptables","-A","FORWARD","-p","ESP","-j","esp_packets_forward");
eval("iptables","-A","FORWARD","-p","AH","-j","ah_packets_forward");

eval("iptables","-A","INPUT","-p","TCP","-j","tcp_packets_input");
eval("iptables","-A","OUTPUT","-p","TCP","-j","tcp_packets_output");
eval("iptables","-A","FORWARD","-p","TCP","-j","tcp_packets_forward");


eval("iptables","-A","INPUT","-p","UDP","-j","udp_packets_input");
eval("iptables","-A","OUTPUT","-p","UDP","-j","udp_packets_output");
eval("iptables","-A","FORWARD","-p","UDP","-j","udp_packets_forward");


/*eval("iptables","-A","INPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
*/
eval("iptables","-A","INPUT","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","FORWARD","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
eval("iptables","-A","FORWARD","-m","state","--state","NEW","-j","ACCEPT");
eval("iptables","-A","OUTPUT","-m","state","--state","RELATED,ESTABLISHED","-j","ACCEPT");
/*eval("iptables","-A","OUTPUT","-m","state","--state","NEW","-j","ACCEPT");
*/
eval("iptables","-L");
}

#endif
