/*
 * Network services
 *
 * Copyright 2004, Broadcom Corporation
 * All Rights Reserved.
 *
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: network.c,v 1.6 2004/08/12 18:21:59 hank Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <syslog.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if_arp.h>
#include <signal.h>
#include <time.h>
#include <sys/time.h>
#include <bcmnvram.h>
#include <netconf.h>
#include <shutils.h>
#include <wlutils.h>
#include <nvparse.h>
#include <rc.h>
#include <bcmutils.h>
//#include <ipv6_fw.h> //Mark for merge 10/15/2002
#include <sys/un.h>
#include <fcntl.h>
#include <errno.h>

#define pppoe_auth_err_file "/tmp/pppoe_auth_err"
#if defined(INCLUDE_PRTSVR) || defined(INCLUDE_RTPS)
extern void led_write(char *status);
#else
void led_ctl(char power,char wan);
#endif

void restart_upnp(void);
extern char wanifname[], wlifname[];

/* Askey Rogerc 08/21/02, upnp running flag*/
int upnp_running=0;

void
start_lan(void)
{
	char *lan_ifname = nvram_safe_get("lan_ifname");
	char name[80], *next;
	int s, s1; /*Added by Mark Tien for Mac setting*/

	struct ifreq ifr;
	#if 1 /*Added By Mark Tien for NAT/Bridge bring up*/
	char *lan_dhcp_client = nvram_safe_get("lan_dhcp_client");
	char date[16];/*Added by Mark Tien for NTP*/
	time_t cur_time,sys_time; //mtyan 08212002
	struct tm m_time; //mtyan 08212002
	char sebuf[8];
        char log_websock[] = "/tmp/log_websock";
        int connfd;
        struct sockaddr_un seraddr;
	char *ntp_enable = nvram_safe_get("ntp_enable");/*Added by Mark Tien for NTP*/
	pid_t pid;
	/*netconf_route_t route;*/
	char *et1macaddr = nvram_safe_get("et1macaddr"); /*Added by Mark Tien for Mac Clone*/
        char *wan_proto = nvram_safe_get("wan_proto");/*Addedd by Mark Tien for AF018*/
        #endif
	char eabuf[32];
	pid_t* pidList;
        int pid_count=0;
        char process_name[11]="ani8021x_aa";

	dprintf("%s\n", lan_ifname);
        #if 1  //mtyan dhcp 07/15/02
        nvram_set("wan_ipaddr", nvram_safe_get("m_wan_ipaddr"));
        nvram_set("wan_netmask",nvram_safe_get("m_wan_netmask"));
        nvram_set("wan_gateway",nvram_safe_get("m_wan_gateway"));
        nvram_set("wan_dns",nvram_safe_get("m_wan_dns"));
        nvram_set("wan_wins", nvram_safe_get("m_wan_wins"));
        nvram_set("wan_hostname",nvram_safe_get("m_wan_hostname"));
        nvram_set("wan_domain",nvram_safe_get("m_wan_domain"));
        #endif
        if(nvram_match("wan_ifname","")) {/*Bridge mode*//*Added By Mark Tien for NAT/Bridge bring up*/


		       //eval("/bin/busybox","ifconfig","eth1","down");
		       //eval("/bin/busybox","ifconfig","eth1","hw","ether",et0macaddr);
		       if ((s1 = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		          return;
	               strncpy(ifr.ifr_name, wanifname, IFNAMSIZ);

		       ether_atoe(nvram_safe_get("et0macaddr"), ifr.ifr_hwaddr.sa_data);
	               ifr.ifr_hwaddr.sa_family = ARPHRD_ETHER;
	               ioctl(s1, SIOCSIFHWADDR, &ifr);
		       close(s1); 	/* ASKEY denny 01/06/04' add, closed the socket */
	               eval("ifconfig", wanifname, "0.0.0.0");//mtyan bridge 07/20/2002
		        if (strcmp(lan_dhcp_client, "1") == 0) {
		             nvram_set("lan_dns",""); /*Addedd by Mark Tien for AF018*/

                        }

				/* Askey Rogerc 10/04/02, stop upnp in bridge */
				stop_upnp();

        }else{  /*Added by Mark Tien for Mac Clone*/
	        et1macaddr = nvram_safe_get("et1macaddr"); /*Get the Updated value Mark Tien*/

                if (!strcasecmp(et1macaddr,"00:00:00:00:00:00")) {
                     //nvram_set("et1macaddr", nvram_safe_get("et1defaultmac"));
                     nvram_set("et1macaddr", nvram_safe_get("def_et1macaddr"));
			//reload_action = ACTION_RESTART;
			//eval("/bin/busybox","ifconfig","eth1","down");
		        //eval("/bin/busybox","ifconfig","eth1","hw","ether",nvram_safe_get("et1defaultmac"));
		        if ((s1 = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		          return;
	                   strncpy(ifr.ifr_name, wanifname, IFNAMSIZ);

		           ether_atoe(nvram_safe_get("et1macaddr"), ifr.ifr_hwaddr.sa_data);
	                   ifr.ifr_hwaddr.sa_family = ARPHRD_ETHER;
	                   ioctl(s1, SIOCSIFHWADDR, &ifr);
			   close(s1); 	/* ASKEY denny 01/06/04' add, closed the socket */
		        //eval("/bin/busybox","ifconfig","eth1","up");

		} else if (strcasecmp(et1macaddr,nvram_safe_get("wan_hwaddr")))
		{
		        //reload_action =  ACTION_NOTHING;
		        //eval("/bin/busybox","ifconfig","eth1","down");
		        //eval("/bin/busybox","ifconfig","eth1","hw","ether",et1macaddr);
		        if ((s1 = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		          return;
	                   strncpy(ifr.ifr_name, wanifname, IFNAMSIZ);

		           ether_atoe(nvram_safe_get("et1macaddr"), ifr.ifr_hwaddr.sa_data);
	                   ifr.ifr_hwaddr.sa_family = ARPHRD_ETHER;
	                   ioctl(s1, SIOCSIFHWADDR, &ifr);
			   close(s1); 	/* ASKEY denny 01/06/04' add, closed the socket */
		        //eval("/bin/busybox","ifconfig","eth1","up");

		}

                       //eval("/bin/busybox","ifconfig","eth1","down");
		       //eval("/bin/busybox","ifconfig","eth1","hw","ether",et1macaddr);
		if ((strcmp(wan_proto, "pppoe") == 0) ||
		    (strcmp(wan_proto, "dhcp") == 0)    ) {
			if(nvram_match("pppoe_autodns","1")) /* Added by Richard 2004/5/8 for dns IP replace issue */
		       nvram_set("wan_dns",""); /*Addedd by Mark Tien for AF018*/
		}
		eval("ifconfig", wanifname, "0.0.0.0");//mtyan bridge 07/20/2002

        }



 	/* Bring up bridged interfaces */
	if (strncmp(lan_ifname, "br", 2) == 0) {
		eval("brctl", "addbr", lan_ifname);
		eval("brctl", "setfd", lan_ifname, "1");
		//if (nvram_match("lan_stp", "0")) //mtyan stp 07/18/02
			eval("brctl", "stp", lan_ifname, "dis");
		foreach(name, nvram_safe_get("lan_ifnames"), next) {
			/* Bring up interface */
			ifconfig(name, IFUP, NULL, NULL);
			/* Set the logical bridge address to that of the first interface */
			if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
				continue;
			strncpy(ifr.ifr_name, lan_ifname, IFNAMSIZ);
			if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0 &&
			    memcmp(ifr.ifr_hwaddr.sa_data, "\0\0\0\0\0\0", ETHER_ADDR_LEN) == 0) {
				strncpy(ifr.ifr_name, name, IFNAMSIZ);
				if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0) {
					strncpy(ifr.ifr_name, lan_ifname, IFNAMSIZ);
					ifr.ifr_hwaddr.sa_family = ARPHRD_ETHER;
					ioctl(s, SIOCSIFHWADDR, &ifr);
				}
			}
			close(s);
			/* If not a wl i/f then simply add it to the bridge */
			if (strcmp(name, wlifname))
			{
				eval("brctl", "addif", lan_ifname, name);
			}
			else
			{
				eval("wlconf", name, "up");
				/* get the instance number of the wl i/f */
				char wl_name[] = "wlXXXXXXXXXX_mode";
				int unit;
				wl_ioctl(name, WLC_GET_INSTANCE, &unit, sizeof(unit));
				snprintf(wl_name, sizeof(wl_name), "wl%d_mode", unit);
				/* Receive all multicast frames in WET mode */
				if (nvram_match(wl_name, "wet"))
					ifconfig(name, IFUP | IFF_ALLMULTI, "0.0.0.0", NULL);
				/* Do not attach the main wl i/f if in wds mode */
				if (nvram_invmatch(wl_name, "wds") && nvram_match("wl0_radio", "1"))
					eval("brctl", "addif", lan_ifname, name);
				if (nvram_match(wl_name, "wet")) {
					char *zcsvc_argv[] = { "zcsvc", NULL};
					_eval(zcsvc_argv, NULL, 0, &pid);
				}
			}
#if 0
			if (wlconfig(name))
				if (strcmp(name, wlifname) || nvram_match("wl0_radio", "1")) {
					/* -lg- Do not turn on WLAN LED when wireless disabled */
					//printf("===> call brctl addif %s...\n", name);
					eval("brctl", "addif", lan_ifname, name);
				} else
					;//printf("===> Don't call brctl addif %s...\n", name);
			else {
				/* get the instance number of the wl i/f */
				char wl_name[] = "wlXXXXXXXXXX_mode";
				int unit;
				wl_ioctl(name, WLC_GET_INSTANCE, &unit, sizeof(unit));
				snprintf(wl_name, sizeof(wl_name), "wl%d_mode", unit);
				/* Receive all multicast frames in WET mode */
				if (nvram_match(wl_name, "wet"))
					ifconfig(name, IFUP | IFF_ALLMULTI, "0.0.0.0", NULL);
				/* Do not attach the main wl i/f if in wds mode */
				if (nvram_invmatch(wl_name, "wds"))
					eval("brctl", "addif", lan_ifname, name);
			}
#endif
		}
	}
	/* specific non-bridged lan i/f */
	else if (strcmp(lan_ifname, "")) {
		/* Bring up interface */
		ifconfig(lan_ifname, IFUP, NULL, NULL);
		/* config wireless i/f */
		if (!eval("wlconf", lan_ifname, "up")) {
			char tmp[100], prefix[] = "wanXXXXXXXXXX_";
			int unit;
			/* get the instance number of the wl i/f */
			wl_ioctl(lan_ifname, WLC_GET_INSTANCE, &unit, sizeof(unit));
			snprintf(prefix, sizeof(prefix), "wl%d_", unit);
			/* Receive all multicast frames in WET mode */
			if (nvram_match(strcat_r(prefix, "mode", tmp), "wet"))
				ifconfig(lan_ifname, IFUP | IFF_ALLMULTI, NULL, NULL);
		}
	}

	/* Bring up and configure LAN interface */
	#if 0 /*Original Mark Tien for NAT/Bridge bring up*/
	ifconfig(lan_ifname, IFUP,
		 nvram_safe_get("lan_ipaddr"), nvram_safe_get("lan_netmask"));
        #else /*Added By Mark Tien for NAT/Bridge bring up*/
        if(nvram_match("wan_ifname","")) {/*Bridge mode*/

        /* by ASKEY Colin 17/12/02 10:34:08, force to set default IP for bridge mode*/
        /* by ASKEY Colin 12/01/03 04:05:53, */
        //nvram_set("lan_ipaddr",nvram_safe_get("default_lan_ipaddr_br"));
        //nvram_set("lan_netmask",nvram_safe_get("default_lan_netmask_br"));
        //nvram_set("nat_enable", "0");
        nvram_set("upnp_enable", "0");
        /* Askey Rogerc 03/01/03, */
         if(nvram_match("NatFlag", "1")){
	        unlink("/tmp/http.login");
	     }
           nvram_set("NatFlag","0");

	       if(nvram_match("BridgeFlag", "0")){
	       	 nvram_set("lan_dhcp_client", nvram_safe_get("default_lan_dhcp_client_br"));
	         nvram_set("lan_proto", nvram_safe_get("default_lan_proto_br"));
	         nvram_set("BridgeFlag","1");

                 //nvram_set("m_lan_ipaddr", nvram_safe_get("lan_ipaddr")); //mtyan bridge 07/15/02
                 //nvram_set("m_lan_netmask",nvram_safe_get("lan_netmask")); //mtyan bridge 07/15/02

	       }

#if defined(INCLUDE_PRTSVR) || defined(INCLUDE_RTPS)
		//printf("killall, sighup now...\n");
		system("killall -SIGHUP led_mon");
#endif /* INCLUDE_PRTSVR */

	  if (strcmp(lan_dhcp_client, "1") == 0) {

		char *dhcp_argv[] = { "udhcpc",
				      "-i", lan_ifname,
				      "-p", "/var/run/udhcpc.pid",
				      "-s", "/tmp/udhcpc",
				      "-H", nvram_safe_get("wan_hostname"),
				      NULL
		};
                stop_dhcpd();
		/* -lg- Clear the buffer */
                nvram_set("wan_ipaddr", "0.0.0.0");
                nvram_set("wan_netmask","0.0.0.0");
                nvram_set("wan_gateway","");
                nvram_set("wan_dns","");
                //nvram_set("lan_ipaddr",nvram_safe_get("m_lan_ipaddr")); //mtyan bridge 07/15/02
                //nvram_set("lan_ipaddr","");
                //nvram_set("lan_netmask",nvram_safe_get("m_lan_netmask")); //mtyan bridge 07/15/02

                nvram_set("lan_proto", "static");
                symlink("/sbin/rc", "/tmp/udhcpc");
                _eval(dhcp_argv, NULL, 0, &pid);


          } else {
          	ifconfig(lan_ifname, IFUP,
		 //nvram_safe_get("m_lan_ipaddr"), nvram_safe_get("m_lan_netmask"));//mtyan bridge  7/15/2002
		 nvram_safe_get("lan_ipaddr"), nvram_safe_get("lan_netmask"));



		if (1) {
			/* Set default gateway if specified */
			while (route_del(lan_ifname, 0, NULL, NULL, NULL) == 0);
			route_add(lan_ifname, 0, "0.0.0.0", nvram_safe_get("lan_gateway"), "0.0.0.0");

		}
                #if 1/*Added by Mark Tien for NTP*/
		if(nvram_match("ntp_enable","1")) {
                       stop_ntpclient();
                       start_ntpclient();
                }
                #endif
#ifdef INCLUDE_PRTSVR
		stop_lpd();
		start_lpd();
		led_write("??????1???");   /* stop flashing of status led */ //added by bin 10/15/2003
#elif defined(INCLUDE_RTPS)
		stop_lpd();
		start_lpd();
		led_write("?????1????");   /* stop flashing of status led */ //added by bin 10/15/2003
#endif
	  }

	} else { /*NAT Mode*/

	       nvram_set("BridgeFlag","0");

	       if(nvram_match("NatFlag", "0")){
	       	 nvram_set("lan_ipaddr",nvram_safe_get("default_lan_ipaddr")); //mtyan 07/26/02
	       	 nvram_set("lan_netmask",nvram_safe_get("default_lan_netmask"));
	       	 //nvram_set("wan_proto","dhcp"); /*Modified by Mark Tien for AF021*/
	         nvram_set("lan_dhcp_client", nvram_safe_get("default_lan_dhcp_client_nat"));
	         nvram_set("lan_proto", nvram_safe_get("default_lan_proto_nat"));
	         /* Askey Rogerc 01/01/03, force to set default dhcp_start and dhcp_end */
	         	nvram_set("dhcp_start",  "192.168.2.2");
	        	nvram_set("dhcp_end",  "192.168.2.100");
	        /* Askey Rogerc 03/01/03, */
	        unlink("/tmp/http.login");
	         nvram_set("NatFlag","1");
	       }

	       ifconfig(lan_ifname, IFUP,
		 nvram_safe_get("lan_ipaddr"), nvram_safe_get("lan_netmask"));


	}
	#endif /* Mark Tien for NAT/Bridge bring up*/
	/* Get current LAN hardware address */
	if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) > 0) {
	strncpy(ifr.ifr_name, lan_ifname, IFNAMSIZ);
	if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0) {
		char eabuf[32];
		nvram_set("lan_hwaddr", ether_etoa(ifr.ifr_hwaddr.sa_data, eabuf));
	}

	close(s);
	}

	#if 1 /*Added by Mark Tien for NTP*/

        if (strcmp(ntp_enable, "0") == 0){

            sprintf(date,"%02d%02d%02d%02d%04d.%02d",
	                     atoi(nvram_safe_get("user_time_mo")),
		             atoi(nvram_safe_get("user_time_dd")),
		             atoi(nvram_safe_get("user_time_hr")),
		             atoi(nvram_safe_get("user_time_mn")),
		             atoi(nvram_safe_get("user_time_yr")),
	                     0);

            if(nvram_match("user_time_update","1")) {//mtyan fixed 08/07/2002
	    #if 1 //mtyan 08212002
	    m_time.tm_sec=0;
	    m_time.tm_min=atoi(nvram_safe_get("user_time_mn"));
	    m_time.tm_hour=atoi(nvram_safe_get("user_time_hr"));
	    m_time.tm_mday=atoi(nvram_safe_get("user_time_dd"));
	    m_time.tm_mon=atoi(nvram_safe_get("user_time_mo"))-1;
	    m_time.tm_year=atoi(nvram_safe_get("user_time_yr"))-1900;
	    m_time.tm_isdst=0;
	    cur_time=mktime(&m_time);

	                mkdir("/tmp/time", 0777);
                        sys_time=time(0);

                        FILE *fp = fopen("/tmp/time/offset", "w+b");

                        if (fp ) {
                         fprintf(fp,"%ld\n",(cur_time - sys_time));
                         fclose(fp);
                         connfd = socket(AF_LOCAL, SOCK_STREAM, 0);
                         if (connfd >= 0) {
                            memset(&seraddr, 0, sizeof(seraddr));

                            seraddr.sun_family = AF_LOCAL;
                            strncpy(seraddr.sun_path, log_websock, sizeof(seraddr.sun_path) - 1);
                            if (connect(connfd, (struct sockaddr *) &seraddr, sizeof(seraddr)) >= 0) {
                                memcpy(sebuf, "t", 1);
                                write(connfd, sebuf, 1);
                             }

                         close(connfd);
                         }
			{
				// gmluong, 11/13/02, update the /proc/net/ipt_time_offset
				char t_data[12];
				sprintf(t_data,"%d",cur_time-sys_time);
				fp = fopen("/proc/net/ipt_time_offset", "r+");
				if (fp) {
					fputs(t_data, fp);
					fclose(fp);
				} else
					printf("Failed to open /proc/net/ipt_time_offset\n");
				}
                        }
          #endif
	     #if 1 //mtyan 08212002
	     #else
             eval("/bin/busybox","date","-s",date);
	     #endif
	     nvram_set("user_time_update","0"); //mtyan fixed 08/07/2002
	    }
        }
        #endif

   /*********************************************
   *  Gerald20030408, added to start IAPP Daemon:
   *********************************************/
   {  if (nvram_match("lan_dhcp_client", "0"))
      {  eval("killall", "iappd");
         eval("iappd");
      }
   }
#ifdef INCLUDE_RTPS
		stop_lpd();
		start_lpd();
#endif
	/* -lg-
	 * This nvram_commit call caused a nvram_set failure in dhcp client process.
	 * This call appears to be unnecessary but I might be wrong.
	 */
        /* nvram_commit(); */
        //eval("killall", "-16", "udhcpd")
	dprintf("%s %s\n",
		nvram_safe_get("lan_ipaddr"),
		nvram_safe_get("lan_netmask"));

		/* Askey Rogerc 25/11/02, add for start EZinstallAPI server*/
		start_bkserver();


	/* Bring up local host interface */
	ifconfig("lo", IFUP, "127.0.0.1", NULL);

#ifdef INCLUDE_PRTSVR
	/* Set wireless LED depending on wireless mode */
	if (nvram_match("wl0_ibss", "0"))
		eval("brctl", "setbridgeled", "br0", "16"); // Infra, green
	else
		eval("brctl", "setbridgeled", "br0", "8");  // Adhoc, yellow
#endif

   /******************************************
   *  Gerald20031031, added for Airgo Support:
   ******************************************/
   if (nvram_match("RADIO_MODULE", "airgo"))
     {	
      if ( nvram_match("wl_radio", "1"))
      	{    
       	eval("nv2cfg"); /* Generate 1x.conf and wsmDefaults from nvram */	
        pidList = jerry_find_pid_by_name( process_name, &pid_count);
        printf("start_lan(): pid_count(%d), pid(%d) ,name(%s)\n", pid_count,*pidList,process_name);
        free(pidList);
	if ( pid_count > 0 )
	   {
	    printf("main_loop(): %d ani8021x_aa processes existed\n");
	   }
	else
	   {
	    printf("start_lan(): The first time to execute wsm and ani8021x_aa \n");
            eval("ani8021x_aa"); //, "-v", "7"); //, "-d", "&");
            sleep(2);
            eval("wsm"); //, "-d", "&");
            sleep(1);
            eval("aniSdkTool", "-s", "adm", "0", "1");
	   }
	eval("aniSdkTool", "-s","cga");
	}// nvram_match("wl_radio", "1")
      else // radio is disabled
	{	
	printf("start_lan(): The radio is disabled, to kill wsm and ani8021x_aa \n");
	eval("aniSdkTool", "-s", "adm", "0", "0");
        sleep(1);
        eval("killall", "wsm");
        sleep(1);
        eval("killall", "ani8021x_aa");     
	}    

      /* Get current WLAN hardware address */
        if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) >= 0)
                {
                strncpy(ifr.ifr_name, "wlan0", IFNAMSIZ);
                if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0)
                        nvram_set("wl_hwaddr", ether_etoa(ifr.ifr_hwaddr.sa_data, eabuf));
                close(s);
                }
      }


}

void
stop_lan(void)
{
	char *lan_ifname = nvram_safe_get("lan_ifname");
	char name[80], *next;

	dprintf("%s\n", lan_ifname);

	/* Stop the syslogd daemon */
	eval("killall", "syslogd");
	eval("killall", "zcsvc");

	/* Remove static routes */
//	del_lan_routes(lan_ifname);
 if (nvram_match("RADIO_MODULE", "airgo"))
	{	
	printf("stop_lan(): To kill wsm and ani8021x_aa \n");
	eval("aniSdkTool", "-s", "adm", "0", "0");
        sleep(1);
        eval("killall", "wsm");
        sleep(1);
        eval("killall", "ani8021x_aa");   
	}
// else
	{
	/* Bring down LAN interface */
	ifconfig(lan_ifname, 0, NULL, NULL);

	/* Bring down bridged interfaces */
	if (strncmp(lan_ifname, "br", 2) == 0) {
		foreach(name, nvram_safe_get("lan_ifnames"), next) {
			eval("wlconf", name, "down");
			ifconfig(name, 0, NULL, NULL);
			eval("brctl", "delif", lan_ifname, name);
		}
		eval("brctl", "delbr", lan_ifname);
	}
	/* Bring down specific interface */
	else if (strcmp(lan_ifname, ""))
		eval("wlconf", lan_ifname, "down");
	}
	dprintf("done\n");
}
#if 0
static int
wan_prefix(char *ifname, char *prefix)
{
	int unit;

	if ((unit = wan_ifunit(ifname)) < 0)
		return -1;

	sprintf(prefix, "wan%d_", unit);
	return 0;
}

static int
add_wan_routes(char *wan_ifname)
{
	char prefix[] = "wanXXXXXXXXXX_";

	/* Figure out nvram variable name prefix for this i/f */
	if (wan_prefix(wan_ifname, prefix) < 0)
		return -1;

	return add_routes(prefix, "route", wan_ifname);
}

static int
del_wan_routes(char *wan_ifname)
{
	char prefix[] = "wanXXXXXXXXXX_";

	/* Figure out nvram variable name prefix for this i/f */
	if (wan_prefix(wan_ifname, prefix) < 0)
		return -1;

	return del_routes(prefix, "route", wan_ifname);
}

static int
wan_valid(char *ifname)
{
	char name[80], *next;

	foreach(name, nvram_safe_get("wan_ifnames"), next)
		if (ifname && !strcmp(ifname, name))
			return 1;
	return 0;
}
#endif
void
start_wan(void)
{
	char *wan_ifname = nvram_safe_get("wan_ifname");
	char *wan_proto = nvram_safe_get("wan_proto");
	char *ifname = !strncmp(wan_ifname, "ppp", 3) ? nvram_safe_get("pppoe_ifname") : wan_ifname;
	char eabuf[32];
	int s;
	struct ifreq ifr;
	pid_t pid;
	//char *lan_dhcp_client = nvram_safe_get("lan_dhcp_client");/*Added By Mark Tien for NAT/Bridge bring up*/
	//char *lan_proto = nvram_safe_get("lan_proto");/*Added By Mark Tien for NAT/Bridge bring up*/
	//char *ntp_enable = nvram_safe_get("ntp_enable");/*Added by Mark Tien for NTP*/
	//char date[16];/*Added by Mark Tien for NTP*/
	//int dhcp_option_lease_time;/*Added by Mark Tien for DHCPD lease time*/
        int wan_mac[6];//mtyan dhcp option: hostname
        char mywan_hostname[16]; //mtyan dhcp option: hostname
        //time_t t; // added by Jerry Lee for PPPoE connection time ,2002/07/22

printf("===wan_ifname=%s, ifname=%s\n", wan_ifname, ifname);
        set_nsswitch_conf();//mtyan

   /*Peter S 20020612*/    /* printf("start_wan begin\n"); */

	dprintf("%s %s\n", wan_ifname, wan_proto);

 /*Peter S 20020610*/
       if(nvram_match("pppoe_mode","1")
           && nvram_match("wan_proto","pppoe"))
          {
           printf("Set pppoe device valid\n");
           eval("nvram","set","wan_ipaddr=192.168.168.220");
           eval("nvram","set","wan_netmask=255.255.255.0");
           eval("nvram","set","wan_gateway=192.168.168.2");
          }

	if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0)
		return;

	/* Bring up enslaved WAN interface instead if PPPoE */
	strncpy(ifr.ifr_name, ifname, IFNAMSIZ);

	/* Set WAN hardware address before bringing interface up */
	#if 0
	if (!nvram_invmatch("wan_hwaddr", "") ||
	    !ether_atoe(nvram_safe_get("wan_hwaddr"), ifr.ifr_hwaddr.sa_data) ||
	    !memcmp(ifr.ifr_hwaddr.sa_data, "\0\0\0\0\0\0", ETHER_ADDR_LEN)) {
		char perm[] = "XXXXXXmacaddr";
		snprintf(perm, sizeof(perm) - 1, "%smacaddr", nvram_safe_get("wan_hwname"));
		ether_atoe(nvram_safe_get(perm), ifr.ifr_hwaddr.sa_data);
	}
	#else /*Added by Mark Tien for Mac Clone*/

	    ether_atoe(nvram_safe_get("et1macaddr"), ifr.ifr_hwaddr.sa_data);

	#endif
		/* Configure i/f only once, specially for wireless i/f shared by multiple connections */
		if (ioctl(s, SIOCGIFFLAGS, &ifr)) {
			close(s);
			//continue;
		}
		if (!(ifr.ifr_flags & IFF_UP)) {
			/* Sync connection nvram address and i/f hardware address */
			memset(ifr.ifr_hwaddr.sa_data, 0, ETHER_ADDR_LEN);
			if (!nvram_invmatch("wan_hwaddr", "") ||
			    !ether_atoe(nvram_safe_get("wan_hwaddr"), ifr.ifr_hwaddr.sa_data) ||
			    !memcmp(ifr.ifr_hwaddr.sa_data, "\0\0\0\0\0\0", ETHER_ADDR_LEN)) {
				if (ioctl(s, SIOCGIFHWADDR, &ifr)) {
					close(s);
					//continue;
				}
				nvram_set("wan_hwaddr", ether_etoa(ifr.ifr_hwaddr.sa_data, eabuf));
			}
			else {
				ifr.ifr_hwaddr.sa_family = ARPHRD_ETHER;
				ioctl(s, SIOCSIFHWADDR, &ifr);
			}

			/* Bring up i/f */
			ifconfig(wan_ifname, IFUP, NULL, NULL);

			/* do wireless specific config */
			eval("wlconf", wan_ifname, "up");
		}

		close(s);

	 /*Added By Mark Tien for NAT/Bridge bring up*/
        if(nvram_match("wan_ifname","")) {
                       printf("Bring up bridge\n");
                       eval("brctl", "addif", "br0", wanifname);

        }

	/* Askey Rogerc 14/08/02, */
	restart_upnp();
	/* Configure WAN interface */
	if (strcmp(wan_proto, "pppoe") == 0) {
		char *pppoe_argv[] = { "pppoecd",
				       nvram_safe_get("pppoe_ifname"),
				       "-u", nvram_safe_get("pppoe_username"),
				       "-p", nvram_safe_get("pppoe_passwd"),
				       "-r", nvram_safe_get("pppoe_mru"),
                                       "-S", nvram_safe_get("pppoe_servicename"),
				       "-t", nvram_safe_get("pppoe_mtu"),
				       "-i", nvram_match("pppoe_demand", "1") ? nvram_safe_get("pppoe_idletime") : "0",
				       nvram_match("pppoe_demand", "1") || nvram_match("pppoe_keepalive", "1") ? "-k" : NULL,
				       NULL
		};

		mkdir("/tmp/ppp", 0777);
		symlink("/sbin/rc", "/tmp/ppp/ip-up");
		symlink("/sbin/rc", "/tmp/ppp/ip-down");

		unlink(pppoe_auth_err_file);
                _eval(pppoe_argv, NULL, 0, &pid);

                FILE *fp = fopen("/tmp/ppp/link", "r");

        if (!fp)
             {
            printf("fill pppoe   \n");
             }

        else {
         if(nvram_match("pppoe_mode","2"))
           {
           printf("set the default route\n");
        route_add(wan_ifname, 0, "0.0.0.0", nvram_safe_get("wan_gateway"), "0.0.0.0");
           }
              fclose(fp);
        }

		/* Pretend that the WAN interface is up */
		if (nvram_match("pppoe_demand", "1")) {
			while (ifconfig(wan_ifname, IFUP,
					nvram_safe_get("wan_ipaddr"), "255.255.255.255"));

			/* Set P-t-P address if available */
			strncpy(ifr.ifr_name, wan_ifname, IFNAMSIZ);
			inet_aton(nvram_safe_get("wan_gateway"), &sin_addr(&ifr.ifr_dstaddr));
			ifr.ifr_dstaddr.sa_family = AF_INET;
			ioctl(s, SIOCSIFDSTADDR, &ifr);
			start_wan_done();
		}
	} else if (strcmp(wan_proto, "dhcp") == 0
      || strcmp(wan_proto, "telstra")==0/*Gerald20030120, added for BPA*/) {
		char *wan_hostname = nvram_safe_get("wan_hostname");
		char *dhcp_argv[] = { "udhcpc",
				      "-i", wan_ifname,
				      "-p", "/var/run/udhcpc.pid",
				      "-s", "/tmp/udhcpc",
				      //wan_hostname && *wan_hostname ? "-H" : NULL,//original
				      //wan_hostname && *wan_hostname ? wan_hostname : NULL,//original
				      "-H", //mtyan dhcp option: hostname
				      wan_hostname && *wan_hostname ? wan_hostname : mywan_hostname,//mtyan dhcp option: hostname
				      NULL
		};
                nvram_set("wan_ipaddr", "0.0.0.0");
                nvram_set("wan_netmask","0.0.0.0");
                nvram_set("wan_gateway","");
                nvram_set("wan_dns","");
                sscanf(nvram_safe_get("et1macaddr"),"%02x:%02x:%02x:%02x:%02x:%02x",\
                &wan_mac[0],&wan_mac[1],&wan_mac[2],&wan_mac[3],&wan_mac[4],&wan_mac[5]); //mtyan dhcp option: hostname
                sprintf(mywan_hostname,"%02x%02x%02x%02x%02x%02x",\
                wan_mac[0],wan_mac[1],wan_mac[2],wan_mac[3],wan_mac[4],wan_mac[5]);//mtyan dhcp option: hostname
                symlink("/sbin/rc", "/tmp/udhcpc");

		_eval(dhcp_argv, NULL, 0, &pid);
	} else if (strcmp(wan_proto, "pptp") == 0) {
        	if (nvram_match("wan_hostname",""))
			nvram_set("wan_hostname", "host");
		char *pptp_idle_interval = nvram_safe_get("pptp_idle_interval");
		char buf[24];
		char ptystr[128];
		char phonestr[64];
		char *p;
		sprintf(buf, "%d", atoi(pptp_idle_interval) * 60);
		char *wan_hostname = nvram_safe_get("wan_hostname");
#if 0
		/* create file pap-secrets */
		FILE *fp;
	        fp = fopen("/tmp/pap-secrets", "w");
                if (!fp)
			perror("Can't create /tmp/pap-secrets");
		fprintf(fp, "%s\t%s\t%s\n", nvram_safe_get("pptp_username"),
			wan_hostname, nvram_safe_get("pptp_password"));
		fclose(fp);
		chmod("/tmp/pap-secrets", 0600);

		/* create file chap-secrets */
		fp = fopen("/tmp/chap-secrets", "w");
                if (!fp)
			perror("Can't create /tmp/chap-secrets");
		fprintf(fp, "%s\t%s\t%s\n", nvram_safe_get("pptp_username"),
			wan_hostname, nvram_safe_get("pptp_password"));
		fclose(fp);
		chmod("/tmp/chap-secrets", 0600);

		FILE *fp;
		fp = fopen("/tmp/my-isp", "w");
                if (!fp)
			perror("Can't create /tmp/my-isp");
		if (nvram_match("pptp_idle_disconnect", "1"))
			fprintf(fp, "idle %s\n", buf);
		fprintf(fp, "name %s\nremotename %s\nfile /etc/ppp/options.pptp\n",
		fprintf(fp, "file /etc/ppp/options.pptp\n",
			nvram_safe_get("pptp_username"), wan_hostname);
		fclose(fp);
#endif
		if (strlen(p = nvram_safe_get("pptp_conn_id")))
			sprintf(phonestr, "--phone %s", p);
		else
			phonestr[0] = 0;

		/* create pppd pty string */
		//sprintf(ptystr, "pptp %s --nolaunchpppd %s call my-isp",
		sprintf(ptystr, "pptp %s --nolaunchpppd %s file /etc/ppp/options.pptp",
			nvram_safe_get("pptp_server_ipaddr"), phonestr);
		/* bring up Wan interface */
		printf("pptp: Bring up Wan interface(%s, %s)\n",
			nvram_safe_get("pptp_ipaddr"), nvram_safe_get("pptp_netmask"));
	//sleep(15);
		ifconfig(wanifname, IFUP,
			nvram_safe_get("pptp_ipaddr"), nvram_safe_get("pptp_netmask"));
		/* call pptp */
		char *pptp_argv[] = { "pppd",
				      //"user", nvram_safe_get("pptp_username"),
				      //"password", nvram_safe_get("pptp_password"),
				      //"call", "my-isp",
				      "pty", ptystr,
				      "mtu", "1450",
				      "mru", "1450",
				      "file", "/etc/ppp/options.pptp",
				      nvram_match("pptp_idle_disconnect", "1") ? "demand" : "persist",
				      nvram_match("pptp_idle_disconnect", "1") ? "idle" : NULL,
				      nvram_match("pptp_idle_disconnect", "1") ? buf : NULL,
				      NULL
		};
		int i;
		for (i = 0; pptp_argv[i]; i++) {
			printf ("%s ", pptp_argv[i]);
		}
		printf("\n");

		mkdir("/tmp/ppp", 0777);
		symlink("/sbin/rc", "/tmp/ppp/ip-up");
		symlink("/sbin/rc", "/tmp/ppp/ip-down");

		_eval(pptp_argv, NULL, 0, &pid);
		/* change wan_ifname to ppp0 to work with NAT */
		nvram_set("wan_ifname", "ppp0");
		if (nvram_match("pptp_idle_disconnect", "1")) {
			start_wan_done();
		}
		//start_wan_done();
        } else {
printf("start_wan(): Manual config\n");
		ifconfig(wan_ifname, IFUP,
			 nvram_safe_get("wan_ipaddr"), nvram_safe_get("wan_netmask"));
                // the following added for Multi-DMZ
                char *m_addr =  nvram_safe_get("m_wan_aliasip");
                char m_ip[15],m_mask[15];
                char ip_mask[5][32];
                char m_ifname[6];
                int i;
                sscanf(m_addr," %s %s %s %s %s %s",ip_mask[0],ip_mask[1],ip_mask[2],ip_mask[3],ip_mask[4],ip_mask[5]);
                for (i=0; i<5; i++)
                      {
                       if ( 1 == sscanf(ip_mask[i]," %20[^/ ] / %20[^\n]",m_ip,m_mask) ) // null value
                          printf("sscanf() error!\n");
                       else
                         {
                          sprintf(m_ifname,"%s:%d",wan_ifname,i);
                          eval("ifconfig",m_ifname,m_ip,"netmask", m_mask);
                          printf("Configure %s to be DMZ IP(%s)/netmaske(%s)\n",m_ifname,m_ip,m_mask);
                         }
                      }
		start_wan_done();

                #if 1/*Added by Mark Tien for NTP*/
		if(nvram_match("wan_ifname",wanifname)&&nvram_match("ntp_enable","1")) {
                       stop_ntpclient();
                       start_ntpclient();
                }
                #endif
	}

	/* Use enslaved WAN interface instead if PPPoE */
	strncpy(ifr.ifr_name, ifname, IFNAMSIZ);

	/* Get current WAN hardware address */
	if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0) {
		char eabuf[32];
		nvram_set("wan_hwaddr", ether_etoa(ifr.ifr_hwaddr.sa_data, eabuf));
	}

	close(s);

	dprintf("%s %s\n",
		nvram_safe_get("wan_ipaddr"),
		nvram_safe_get("wan_netmask"));
	#if 0 /*Added by Mark Tien for NTP*/
        if (strcmp(ntp_enable, "0") == 0){

            sprintf(date,"%02d%02d%02d%02d%04d.%02d",
		      atoi(nvram_safe_get("user_time_mo")),
		      atoi(nvram_safe_get("user_time_dd")),
		      atoi(nvram_safe_get("user_time_hr")),
		      atoi(nvram_safe_get("user_time_mn")),
		      atoi(nvram_safe_get("user_time_yr")),
		        0);

	    eval("/bin/busybox","date","-s",date);
        }
        #endif

}

void
stop_wan(void)
{
	char *wan_ifname = nvram_safe_get("wan_ifname");
	eval_killall("pppd");
	eval("killall", "ip-up");
	eval("killall", "ip-down");
	eval_killall("pppoecd");
	eval("killall", "set_dyndns"); // added by Jerry Lee

	if(!strcmp(nvram_safe_get("wan_proto"),"pptp") || !strcmp(nvram_safe_get("wan_proto"),"pppoe"))
	{
		int i=0;
		for(i=0; i<60000000; i++){}
	}

	dprintf("%s %s\n", wan_ifname, nvram_safe_get("wan_proto"));

   /**********************************************
   *  Gerald20030811, moved here to kill BPALogin:
   **********************************************/
   {  eval("killall", "bpalogin");  }

        unlink("/tmp/dhcp/link"); //added by Jerry Lee, 2002/07/22 for connection time
        unlink("/tmp/phase1"); //mtyan
        unlink("/tmp/phase2");
        unlink("/tmp/phase3");
        unlink("/tmp/phase4");//mtyan
        unlink(pppoe_auth_err_file);// Jerry Lee, 2004/01/28
        /* Kill any WAN client daemons or callbacks */
	eval("killall", "udhcpc");
	eval("killall", "stats");
	stop_dns();
	stop_ntpclient();
#if defined(INCLUDE_PRTSVR) || defined(INCLUDE_RTPS)
		stop_lpd();
#endif
        eval("killall", "route_check"); // added by Jerry Lee
        unlink("/tmp/wan_connect");
/*Peter S 20020723*/ eval("killall","auth");

	/* Bring down WAN interfaces */
	ifconfig(wan_ifname, 0, NULL, NULL);
	ifconfig(nvram_safe_get("pppoe_ifname"), 0, NULL, NULL);
        // Bring down multi interface, Jerry Lee
        int i;
        char  m_ifname[6];
        for (i=1; i<5; i++)
             {
              sprintf(m_ifname,"eth:%d",i);
              eval("ifconfig",m_ifname,"down");
             }
	dprintf("done\n");

	stop_firewall();

}
#if 0
static int
add_ns(char *wan_ifname)
{
	FILE *fp;
	char tmp[100], prefix[] = "wanXXXXXXXXXX_";
	char word[100], *next;
	char line[100];

	/* Figure out nvram variable name prefix for this i/f */
	if (wan_prefix(wan_ifname, prefix) < 0)
		return -1;

	/* Open resolv.conf to read */
	if (!(fp = fopen("/tmp/resolv.conf", "r+"))) {
		perror("/tmp/resolv.conf");
		return errno;
	}
	/* Append only those not in the original list */
	foreach(word, nvram_safe_get(strcat_r(prefix, "dns", tmp)), next) {
		fseek(fp, 0, SEEK_SET);
		while (fgets(line, sizeof(line), fp)) {
			char *token = strtok(line, " \t\n");

			if (!token || strcmp(token, "nameserver") != 0)
				continue;
			if (!(token = strtok(NULL, " \t\n")))
				continue;

			if (!strcmp(token, word))
				break;
		}
		if (feof(fp))
			fprintf(fp, "nameserver %s\n", word);
	}
	fclose(fp);

	/* notify dnsmasq */
	snprintf(tmp, sizeof(tmp), "-%d", SIGHUP);
	eval("killall", tmp, "dnsmasq");

	return 0;
}

static int
del_ns(char *wan_ifname)
{
	FILE *fp, *fp2;
	char tmp[100], prefix[] = "wanXXXXXXXXXX_";
	char word[100], *next;
	char line[100];

	/* Figure out nvram variable name prefix for this i/f */
	if (wan_prefix(wan_ifname, prefix) < 0)
		return -1;

	/* Open resolv.conf to read */
	if (!(fp = fopen("/tmp/resolv.conf", "r"))) {
		perror("fopen /tmp/resolv.conf");
		return errno;
	}
	/* Open resolv.tmp to save updated name server list */
	if (!(fp2 = fopen("/tmp/resolv.tmp", "w"))) {
		perror("fopen /tmp/resolv.tmp");
		fclose(fp);
		return errno;
	}
	/* Copy updated name servers */
	while (fgets(line, sizeof(line), fp)) {
		char *token = strtok(line, " \t\n");

		if (!token || strcmp(token, "nameserver") != 0)
			continue;
		if (!(token = strtok(NULL, " \t\n")))
			continue;

		foreach(word, nvram_safe_get(strcat_r(prefix, "dns", tmp)), next)
			if (!strcmp(word, token))
				break;
		if (!next)
			fprintf(fp2, "nameserver %s\n", token);
	}
	fclose(fp);
	fclose(fp2);
	/* Use updated file as resolv.conf */
	unlink("/tmp/resolv.conf");
	rename("/tmp/resolv.tmp", "/tmp/resolv.conf");

	/* notify dnsmasq */
	snprintf(tmp, sizeof(tmp), "-%d", SIGHUP);
	eval("killall", tmp, "dnsmasq");

	return 0;
}
#endif

#ifdef INCLUDE_PRTSVR
void
start_wan_done(void)
{
	char *wan_ifname = nvram_safe_get("wan_ifname");
	char *lan_dhcp_client = nvram_safe_get("lan_dhcp_client");

	printf("=====> start_wan_done...\n");
	if (nvram_match("wan_ifname","")) {
		if (strcmp(lan_dhcp_client, "1") == 0){
			//printf("=====> copy ...%s,%s\n", nvram_safe_get("wan_ipaddr"), nvram_safe_get("wan_netmask"));
			nvram_set("lan_ipaddr",nvram_safe_get("wan_ipaddr"));
			nvram_set("lan_gateway",nvram_safe_get("wan_gateway"));
			nvram_set("lan_netmask",nvram_safe_get("wan_netmask"));
			//printf("=====> after ...%s,%s\n", nvram_safe_get("lan_ipaddr"), nvram_safe_get("lan_netmask"));
		}
	}

	/*********************************************
	*  Gerald20030408, added to start IAPP Daemon:
	*********************************************/
	if (nvram_match("lan_dhcp_client", "1")) {
		eval("killall", "iappd");
		eval("iappd");
	}

	start_lpd();
	led_write("??????1???");   /* stop flashing of status led */ ///added by bin 10/15/2003

	dprintf("done\n");
}
#else /* INCLUDE_PRTSVR */
void
start_wan_done(void)
{
	char *wan_ifname = nvram_safe_get("wan_ifname");
	char *lan_ifname = nvram_safe_get("lan_ifname");
	char *lan_dhcp_client = nvram_safe_get("lan_dhcp_client");/*Added By Mark Tien for NAT/Bridge bring up*/
	char *lan_proto = nvram_safe_get("lan_proto");/*Added By Mark Tien for NAT/Bridge bring up*/
	int dhcp_option_lease_time;/*Added by Mark Tien for DHCPD lease time*/
        int pid;
        char *dns1;//mtyan
        char *svptr;
        char dnsbuf[64];
        static const char delim[]=" ";


        //char *ping_argv[] = { "ping", "-c", "1","10.0.0.1", NULL }; added by Jerry Lee.2002/06/21

#if 0 //move to start_dns
	/* Askey Rogerc 17/12/02, add for DNS resolver*/
	if(!nvram_match("wan_dns","0.0.0.0") && !nvram_match("wan_dns","")){
		FILE *fp;
		char var[256], *next;

		if(fp = fopen("/tmp/resolv.conf","w")) {
			if(!nvram_match("wan_domain",""))
			   fprintf(fp, "domain %s\n", nvram_safe_get("wan_domain"));
			foreach(var, nvram_safe_get("wan_dns"), next)
    			fprintf(fp, "nameserver %s\n", var);

    		fclose(fp);
    	}
    }
#endif
       /*Peter S 20020612*/      /*       printf("start_wan_done begin   \n");*/
	dprintf("%s %s\n", wan_ifname, nvram_safe_get("wan_proto"));
        start_phase_monitor(1);//mtyan
        #if 0 //mtyan dhcp 07/15/02 Hank 2003/8/25 mark out since we start it with rc START
        if ((nvram_match("lan_dhcp_client","0")) &&
	    (nvram_match("lan_proto", "dhcp"))&&
	    (!(nvram_match("wan_ifname","")))){
               stop_dhcpd();
	       sscanf(nvram_safe_get("dhcp_lease"),"%d", &dhcp_option_lease_time);
	       start_dhcpd(dhcp_option_lease_time*3600);
         } else {
               unlink("/tmp/udhcpd.leases");
         }
        #endif

//gmluong, 06/03/03, move start_firewall() before setting route
	if (!nvram_match("wan_ifname","")) {
printf("start_wan_done(): start_firewall\n");
                start_firewall();
	}

	if (nvram_match("wan_ifname","")) {

	   if (strcmp(lan_dhcp_client, "1") == 0){
	       nvram_set("lan_ipaddr",nvram_safe_get("wan_ipaddr"));
	       nvram_set("lan_gateway",nvram_safe_get("wan_gateway"));
	       nvram_set("lan_netmask",nvram_safe_get("wan_netmask"));
           }
        /* Delete all default routes */
	while (route_del(lan_ifname, 0, NULL, NULL, NULL) == 0);

	/* Set default route to gateway if specified */
	route_add(lan_ifname, 0, "0.0.0.0", nvram_safe_get("wan_gateway"), "0.0.0.0");

	} else {
	/* Delete all default routes */
	while (route_del(lan_ifname, 0, NULL, NULL, NULL) == 0);
	while (route_del(wan_ifname, 0, NULL, NULL, NULL) == 0);

	/* Set default route to gateway if specified */
	route_add(wan_ifname, 0, "0.0.0.0", nvram_safe_get("wan_gateway"), "0.0.0.0");

        }
	#if 0 /*Original Mark Tien for NAT/Bridge bring up*/
	/* Restart DHCP server to hand out longer leases */
	stop_dhcpd();
	start_dhcpd(atoi(nvram_safe_get("wan_lease")) ? : 864000);
        #endif
        /* Start firewall: Modified by Peter on 04/05 */

        if (!nvram_match("wan_ifname",""))
         {
        FILE *fp = fopen("/tmp/ppp/link", "r");

        if (!fp)
             {
            printf("none pppoe   \n");
             }

        else {
                  if(nvram_match("pppoe_mode","2"))
           {
           printf("set the default route\n");
        route_add(wan_ifname, 0, "0.0.0.0", nvram_safe_get("wan_gateway"), "0.0.0.0");
           }
                fclose(fp);
        }
	start_parent_control(); //gmluong, 12/21/02

//                start_firewall();
         }
        /*Peter end*/

	/* Restart DNS proxy */
	stop_dns();
	start_dns();

	/* Set additional static routes */
	set_routes();


	/* Restart UPnP server */
	/* Askey Rogerc 14/08/02, */
	//restart_upnp();


	/* Report stats */
	if (nvram_invmatch("stats_server", "")) {
		char *stats_argv[] = { "stats", nvram_safe_get("stats_server"), NULL };
		_eval(stats_argv, NULL, 5, NULL);
	}

	#if 0 /*Original Mark Tien for NTP*/
	/* Sync time */
	if (nvram_invmatch("ntp_server", "")) {
		char *ntpclient_argv[] = { "ntpclient", "-h", nvram_safe_get("ntp_server"), "-l", "-s", NULL };
		_eval(ntpclient_argv, NULL, 5, NULL);
	}
        #endif
        //_eval(ping_argv, NULL, 5, NULL);   added by Jerry Lee to triger PPPoE

        trigger_pppoe();
        //eval("killall", "-16", "udhcpd");

 // Jerry, syupport DynDNS
 if ( (pid=fork()) < 0 )
      printf("start_wan_done():  fork error!\n");
 else if ( pid == 0 ) // 1st child
                {
                if ( (pid=fork()) < 0 )
                        printf("start_wan_done():   fork error!\n");
                else if ( pid > 0 ) // 2nd parent == 1st child
                        {
                        exit(0);
                        }
                // 2nd child
                sleep(1);// wait for parent leave
                eval("set_dyndns","http://members.dyndns.org/nic/update",nvram_get("dyndns_username"),nvram_get("dyndns_password"),nvram_get("dyndns_hostname"),nvram_get("wan_ipaddr"));
                exit(0);
                }
 // we are not the parent of the 2nd child,
 if ( waitpid(pid,NULL,0) != pid)
     printf("start_wan_done():  waitpid error!\n");


#ifdef INCLUDE_RTPS
	led_write("1?????????");
#else
        led_ctl('1','1');   // added by Jerry Lee
#endif

#ifdef INCLUE_EB
#define NO_ROUTE_CHECK
#endif
#ifdef INCLUE_PRTSVR
#define NO_ROUTE_CHECK
#endif

#ifndef NO_ROUTE_CHECK

        strcpy(dnsbuf,nvram_safe_get("wan_dns"));
        dns1=strtok_r(dnsbuf,delim,&svptr);

        //char *route_check_argv[] = { "route_check",nvram_safe_get("wan_gateway"),dns1,"filter.belkin.com", NULL };  // added by Jerry Lee

        char *route_check_argv[] = { "route_check",nvram_safe_get("wan_gateway"),dns1,nvram_safe_get("route_check_host"), NULL };  // added by Jerry Lee

	/* -lg- NL */
        //if (!nvram_match("wan_ifname", "") && !nvram_match("wan_proto","pppoe") && !nvram_match("wan_proto", "telstra"))
        if (!nvram_match("wan_ifname", "") && !nvram_match("wan_proto","pppoe") && !nvram_match("wan_proto", "telstra")
			&& !nvram_match("wan_proto", "pptp"))
                _eval(route_check_argv, NULL, 0, &pid);  // added by Jerry Lee
        else
                printf("start_wan_done(): don't execute route_check on PPPoE mode\n");
#endif
        eval("touch","/tmp/wan_connect");   // added by Jerry Lee
        start_phase_monitor(3);//mtyan

   /*************************************************
   *  Gerald20030120, added to start BPALogin Daemon:
   *************************************************/
   {  //Gerald20030811, moved to stop_wan. eval("killall", "bpalogin");
      if (nvram_match("wan_proto", "telstra"))
      {  unsigned char *pc01Username, *pc01Password, *pc01Server;
         unsigned char *pc01Gateway;
         unsigned char ac01DebugLevel[8]= { 0 };

         pc01Username= nvram_safe_get("bpa_username");
         pc01Password= nvram_safe_get("bpa_passwd");
         pc01Server= nvram_safe_get("bpa_server");
         pc01Gateway= nvram_safe_get("wan_gateway");
         strncpy(ac01DebugLevel, nvram_safe_get("bpa_debug"), sizeof(ac01DebugLevel)-1);
         if (ac01DebugLevel[0]==0x00)
         {  strcpy(ac01DebugLevel, "1");  }
         if (pc01Username && pc01Password && pc01Server)
         {  eval("bpalogin", "-u", pc01Username, "-p", pc01Password,
               "-s", pc01Server, "-d", ac01DebugLevel, "-g", pc01Gateway);
         }
      }
   }

   /*********************************************
   *  Gerald20030408, added to start IAPP Daemon:
   *********************************************/
   /* -lg- Moved out to bound() to fix bugs */
   {  if (nvram_match("lan_dhcp_client", "1"))
      {  eval("killall", "iappd");
         eval("iappd");
      }
   }


	dprintf("done\n");
}
#endif /* INCLUDE_PRTSVR */

/* theis added by Jerry Lee, for triggering the PPPoE function
*/
void trigger_pppoe()
{
 int  sockfd,len;
 char buff[]={"trigger"};
 struct sockaddr_in   cli_addr,serv_addr;

 /* open a UDP socket */
 if ( (sockfd = socket(AF_INET,SOCK_DGRAM,0)) < 0)
    {
     perror("trigger_pppoe:  can't open stream socket\n");
     return;
    }
 /* Bind our local address  */
 bzero( (char *) &cli_addr,sizeof(cli_addr) );
 cli_addr.sin_family =  AF_INET;
 cli_addr.sin_addr.s_addr = htonl(INADDR_ANY);
 cli_addr.sin_port = htons(0);
 if ( bind(sockfd, (struct sockaddr *) &cli_addr,sizeof(cli_addr)) < 0 )
    {
     perror("trigger_pppoe: can't bind local address\n");
     return ;
    }
 // fill the remote address
 bzero( (char *) &serv_addr,sizeof(serv_addr) );
 serv_addr.sin_family =  AF_INET;
 serv_addr.sin_addr.s_addr = inet_addr("10.0.0.1");
 serv_addr.sin_port = htons(80);

 len = strlen(buff);
 if ( ( sendto(sockfd, buff, len, 0, (struct sockaddr *) &serv_addr, sizeof(serv_addr))) <0 ) {
     perror("trigger_pppoe:send error\n");
     /* add default entry in case the routing table has not been added successfully */
     eval("route", "add", "default", "ppp0");
     /* trigger again with the addr in routing table */
     serv_addr.sin_addr.s_addr = inet_addr("10.112.112.112");
     sendto(sockfd, buff, len, 0, (struct sockaddr *) &serv_addr, sizeof(serv_addr));


 }
}


int
set_routes(void)
{
	char word[80], *tmp;
	char *ipaddr, *netmask, *gateway, *metric, *ifname;

	foreach(word, nvram_safe_get("static_route"), tmp) {
		netmask = word;
		ipaddr = strsep(&netmask, ":");
		if (!ipaddr || !netmask)
			continue;
		gateway = netmask;
		netmask = strsep(&gateway, ":");
		if (!netmask || !gateway)
			continue;
		metric = gateway;
		gateway = strsep(&metric, ":");
		if (!gateway || !metric)
			continue;
		ifname = metric;
		metric = strsep(&ifname, ":");
		if (!metric || !ifname)
			continue;

		route_add(ifname, atoi(metric) + 1, ipaddr, gateway, netmask);
	}

	return 0;
}

static int
notify_nas(char *type, char *ifname, char *action)
{
	char *argv[] = {"nas4not", type, ifname, action,
			NULL,	/* role */
			NULL,	/* crypto */
			NULL,	/* auth */
			NULL,	/* passphrase */
			NULL,	/* ssid */
			NULL};
	char *str = NULL;
	int retries = 10;
	char tmp[100], prefix[] = "wlXXXXXXXXXX_";
	int unit;
	char remote[ETHER_ADDR_LEN];
	char ssid[48], pass[80], auth[16], crypto[16], role[8];
	int i;

	/* the wireless interface must be configured to do WPA */
	wl_ioctl(ifname, WLC_GET_INSTANCE, &unit, sizeof(unit));
	snprintf(prefix, sizeof(prefix), "wl%d_", unit);
	if (nvram_match(strcat_r(prefix, "auth_mode", tmp), "open") ||
	    nvram_match(strcat_r(prefix, "auth_mode", tmp), "shared"))
		return 0;

	/* find WDS link configuration */
	wl_ioctl(ifname, WLC_WDS_GET_REMOTE_HWADDR, remote, ETHER_ADDR_LEN);
	for (i = 0; i < MAX_NVPARSE; i ++) {
		char mac[ETHER_ADDR_STR_LEN];
		uint8 ea[ETHER_ADDR_LEN];

		if (get_wds_wsec(unit, i, mac, role, crypto, auth, ssid, pass) &&
		    ether_atoe(mac, ea) && !bcmp(ea, remote, ETHER_ADDR_LEN)) {
			argv[4] = role;
			argv[5] = crypto;
			argv[6] = auth;
			argv[7] = pass;
			argv[8] = ssid;
			break;
		}
	}

	/* did not find WDS link configuration, use wireless' */
	if (i == MAX_NVPARSE) {
		/* role */
		argv[4] = "auto";
		/* crypto */
		argv[5] = nvram_safe_get(strcat_r(prefix, "crypto", tmp));
		/* auth mode */
		argv[6] = nvram_safe_get(strcat_r(prefix, "auth_mode", tmp));
		/* passphrase */
		argv[7] = nvram_safe_get(strcat_r(prefix, "wpa_psk", tmp));
		/* ssid */
		argv[8] = nvram_safe_get(strcat_r(prefix, "ssid", tmp));
	}

	/* wait till nas is started */
	while (retries -- > 0 && !(str = file2str("/tmp/nas.lan.pid")))
		sleep(1);
	if (str) {
		int pid;
		free(str);
		return _eval(argv, ">/dev/console", 0, &pid);
	}
	return -1;
}

int
hotplug_net(void)
{
	char *lan_ifname = nvram_safe_get("lan_ifname");
	char *interface, *action;

	if (!(interface = getenv("INTERFACE")) ||
	    !(action = getenv("ACTION")))
		return EINVAL;

	if (strncmp(interface, "wds", 3))
		return 0;

	if (!strcmp(action, "register")) {
		/* Bring up the interface and add to the bridge */
		ifconfig(interface, IFUP, NULL, NULL);

		/* Bridge WDS interfaces */
		if (!strncmp(lan_ifname, "br", 2) &&
		    eval("brctl", "addif", lan_ifname, interface))
		    return 0;

		/* Notify NAS of adding the interface */
		notify_nas("lan", interface, "up");
	}

	return 0;
}

/* Askey Rogerc 14/08/02, */
void
restart_upnp(void)
{
	#if 1 //mtyan 09052002

	FILE *fp;

	stop_upnp();
	/* Askey Rogerc 26/07/02, add disabled when bridge mode*/
	if (nvram_invmatch("upnp_enable", "0")&& nvram_invmatch("BridgeFlag", "1"))
	{
		start_upnp();
		fp = fopen("/tmp/upnp_running", "w");
		if (fp)
                   fclose(fp);

	} else {
	        fp = fopen("/tmp/upnp_running", "r");
		if (fp) {
                   fclose(fp);
                   unlink("/tmp/upnp_running");
                }
	}

	#else //original

	//if(!upnp_running)
	{
	stop_upnp();
	/* Askey Rogerc 26/07/02, add disabled when bridge mode*/
	if (nvram_invmatch("upnp_enable", "0")&& nvram_invmatch("BridgeFlag", "1"))
		start_upnp();
		upnp_running =1;
	}
	#endif
}

#if defined(INCLUDE_PRTSVR) || defined(INCLUDE_RTPS)
#else
// added by Jerry Lee for LED control
void led_ctl(char power,char wan)
{
 FILE *fp_control;
 int fd_lock;
 char status[2];

 while (1)
       {
        usleep(1000);
        fd_lock = open("/tmp/led.lck",O_WRONLY | O_CREAT | O_EXCL, 0644);
        if ( fd_lock<0 && errno==EEXIST )
           {
            printf("led_ctl(): Already locked!\n");
           }
        else if ( fd_lock<0 )
                 printf("led_ctl(): Unexpected error!\n");
        else
           {
            if (!(fp_control = fopen("/tmp/led.ctl", "w+")))
                printf("led_ctl():Can not find /tmp/led.ctl\n");
            status[0]=power;
            status[1]=wan;
            fprintf(fp_control,"%s\n",status);
            fclose(fp_control);
            close(fd_lock);
            unlink("/tmp/led.lck");
            break;
           }
        }//Wait for control file

}
#endif /* NOT INCLUDE_PRTSVR || RTPS*/

//Jerry added the following
#include <ctype.h>
#include <dirent.h>

 /* find_pid_by_name()    , Jerry Lee steal from busybox
 *
 *  This finds the pid of the specified process.
 *  Currently, it's implemented by rummaging through
 *  the proc filesystem.
 *
 *  Returns a list of all matching PIDs
 */
#define READ_BUF_SIZE	50
pid_t* jerry_find_pid_by_name( char* pidName, int *count)
{
	DIR *dir;
	struct dirent *next;
	//pid_t* pidList=NULL;
        pid_t   *pidList;//Jerry
	int i=0,n=0,j=0;

	dir = opendir("/proc");
	if (!dir)
		{
                printf("find_pid_by_name: Cannot open /proc");
                exit(1);
                }
        pidList = malloc(sizeof(*pidList)*5);
	while ((next = readdir(dir)) != NULL) {
		FILE *status;
		char filename[READ_BUF_SIZE];
		char buffer[READ_BUF_SIZE];
		char name[READ_BUF_SIZE];

		/* Must skip ".." since that is outside /proc */
		if (strcmp(next->d_name, "..") == 0)
			continue;

		/* If it isn't a number, we don't want it */
		if (!isdigit(*next->d_name))
			continue;

		//sprintf(filename, "/proc/%s/status", next->d_name);
                sprintf(filename, "/proc/%s/cmdline", next->d_name);
		if (! (status = fopen(filename, "r")) ) {
			continue;
		}
		/*if (fgets(buffer, READ_BUF_SIZE-1, status) == NULL) {
			fclose(status);
			continue;
		} */
                n=fread(buffer, 1,READ_BUF_SIZE-1, status);
                if ( n <= 0)
                   {
                   fclose(status);
                   continue;
                   }
                else
                    {
                    //printf("find_pid_by_name(): read %d bytes from %s into buffer=\n",n,filename);
                    /*for (j=0; j<n; j++)
                        {
                         if ( buffer[j] )
                                printf("%c ",buffer[j]);
                         else
                                printf("0 ");
                        }
                    printf("\n");    */
                    }

		fclose(status);

		/* Buffer should contain a string like "Name:   binary_name"
		sscanf(buffer, "%*s %s", name);
		if (strcmp(name, pidName) == 0) {
			//pidList=xrealloc( pidList, sizeof(pid_t) * (i+2));
                        pidList[i]=strtol(next->d_name, NULL, 0);
                        //printf("name(%s), pidName(%s),next->d_name(%s),pid(%d)=pidList[i](%d)\n",name, pidName,next->d_name,strtol(next->d_name, NULL, 0),pidList[i]);
			i++;
		}   */
                // Buffer should contain the command  string
                if ( n>=4 )
                   {
                   if ( bstrncmp(buffer, pidName,4) == 0 )
                        {
                        pidList[i]=strtol(next->d_name, NULL, 0);
                        printf("find_pid_by_name(): PID(%d) match\n",strtol(next->d_name, NULL, 0));
                        i++;
                        }
                   }
	}
        closedir(dir) ; /*2003-12-21 alan add for GFF-234*/
        *count = i;//Jerry
        printf("find_pid_by_name(): %d\n", *count);
	return pidList;
}

int bstrncmp(char *str1, char *str2, int no)
{
 int i=0;
 //printf("bstrncmp():");
 for ( i=0; i< no ; i++)
     {
      if ( *str1 == *str2 )
         {
         //printf("(%d=%d)",*str1,*str2);
         }
      else
          {
           if ( i > 0 )
                {
                //printf("(%d != %d)",*str1,*str2);
                //printf("\n");
                return i;
                }
           else
                return -1;
          }
      str1++;
      str2++;
     }
 //printf("\n");
 return 0;
}

