/*
 * ppp scripts
 *
 * Copyright 2003, Broadcom Corporation
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior
 * written permission of Broadcom Corporation.
 * $Id: ppp.c,v 1.1.1.1 2004/06/10 10:28:50 cvsadm Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <net/route.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <time.h>/* Added by Jerry Lee -begin */
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>  /* Added by Jerry Lee - end */
#include <bcmnvram.h>
#include <netconf.h>
#include <shutils.h>
#include <rc.h>

#define IFUP (IFF_UP | IFF_RUNNING | IFF_BROADCAST | IFF_MULTICAST)

#if defined(INCLUDE_PRTSVR) || defined(INCLUDE_RTPS)
extern void led_write(char *status);
#else
extern void led_ctl(char power,char wan); // added by Jerry Lee
#endif

/*
 * Called when link comes up
 */
int
ipup_main(int argc, char **argv)
{
	FILE *fp;
	char *wan_ifname = safe_getenv("IFNAME");
	char *value;
	char buf[256];

	 time_t      t; /* Added by Jerry Lee for PPPoE connection time,2002/06/18 */
	dprintf("%s\n", argv[0]);

	/* Touch connection file */
	if (!(fp = fopen("/tmp/ppp/link", "a"))) {
		perror("/tmp/ppp/link");
		return errno;
	}
	fclose(fp);
        eval("touch","/tmp/wan_connect");   // added by Jerry Lee

        /* BEGIN == added by Jerry Lee for PPPoE connection time ,2002/06/18 */
        if (!(fp = fopen("/tmp/ppp/link", "w"))) {
                perror("/tmp/ppp/link");
                return errno;
        }
        t=time(0);
        fprintf(fp,"%d\n",t);
        fclose(fp);
        /* END ==  */

	if ((value = getenv("IPLOCAL"))) {
		ifconfig(wan_ifname, IFUP,
			 value, "255.255.255.255");
		nvram_set("wan_ipaddr", value);
		nvram_set("wan_netmask", "255.255.255.255");
	}

        if ((value = getenv("IPREMOTE")))
		nvram_set("wan_gateway", value);
	strcpy(buf, "");
	if (getenv("DNS1"))
		sprintf(buf, "%s", getenv("DNS1"));
	if (getenv("DNS2"))
		sprintf(buf + strlen(buf), "%s%s", strlen(buf) ? " " : "", getenv("DNS2"));
	if(strcmp(nvram_get("pppoe_autodns"),"1") == 0) /* Added by Richard 20040428 */
		nvram_set("wan_dns", buf);

	start_wan_done();
        start_ntpclient();/*Added by Mark Tien for NTP*/
        if ( strcmp(nvram_get("wan_proto"),"pptp")==0 )
            eval("exlog","/tmp/log_web.lck","/tmp/log_web","WAN PPTP connected");
        else
        	eval("exlog","/tmp/log_web.lck","/tmp/log_web","WAN PPPoE connected");
	dprintf("done\n");
	return 0;
}

/*
 * Called when link goes down
 */
int
ipdown_main(int argc, char **argv)
{
 int pid;
	/* Askey Rogerc 16/10/02, send disable upnp*/
#if defined(INCLUDE_PRTSVR) || defined(INCLUDE_RTPS)
	led_write("T?????????");
#else
        led_ctl('1','0');
#endif
	stop_ntpclient();
	FILE *fp = fopen("/tmp/upnp_running", "r");
	if (fp){
	         eval("killall", "-17", "upnp");
	         fclose(fp);
	}
        if ( strcmp(nvram_get("wan_proto"),"pptp")==0 )
        	eval("exlog","/tmp/log_web.lck","/tmp/log_web","WAN PPTP disconnected");
	else
        	eval("exlog","/tmp/log_web.lck","/tmp/log_web","WAN PPPoE disconnected");
        unlink("/tmp/wan_connect");
#if defined(INCLUDE_PRTSVR) || defined(INCLUDE_RTPS)
#else
        if ( (pid = fork() ) < 0 )      // Jerry Lee
                printf("set_WAN() fork eror!\n");
        else if ( pid == 0 )
                {
                if ( execle("/usr/sbin/led_mon","led_mon","/tmp/led.lck","/tmp/led.ctl",(char *) 0,NULL) < 0 )
                    printf("set_WAN(): execle(led_mon) eror!\n");
                }
      /*  if (nvram_match("wan_proto","pppoe"))
           {
           eval("nvram","set","wan_ipaddr=0.0.0.0");
           eval("nvram","set","wan_netmask=0.0.0.0");
           eval("nvram","set","wan_gateway=");
           eval("nvram","set","wan_dns=");
           printf("ipdown_main(): clear network information\n");
           }  */
#endif
        return unlink("/tmp/ppp/link");
}

