/*
 * Router rc control script
 *
 * Copyright 2003, Broadcom Corporation
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Broadcom Corporation.
 *
 * $Id: rc.h,v 1.1.1.1 2004/06/10 10:28:50 cvsadm Exp $
 */

#ifndef _rc_h_
#define _rc_h_

#include <bcmconfig.h>
#include <netinet/in.h>

#define IFUP (IFF_UP | IFF_RUNNING | IFF_BROADCAST | IFF_MULTICAST)

#define sin_addr(s) (((struct sockaddr_in *)(s))->sin_addr)

/* udhcpc scripts */
extern int udhcpc_main(int argc, char **argv);

/* ppp scripts */
extern int ipup_main(int argc, char **argv);
extern int ipdown_main(int argc, char **argv);

/* http functions */
extern int http_get(const char *server, char *buf, size_t count, off_t offset);
extern int http_post(const char *server, char *buf, size_t count);
extern int http_stats(const char *url);

/* init */
extern int console_init(void);
extern pid_t run_shell(int timeout, int nowait);
extern void signal_init(void);
extern void fatal_signal(int sig);

/* interface */
extern int ifconfig(char *ifname, int flags, char *addr, char *netmask);
extern int route_add(char *name, int metric, char *dst, char *gateway, char *genmask);
extern int route_del(char *name, int metric, char *dst, char *gateway, char *genmask);
extern void config_loopback(void);
extern int config_vlan(void);


/* network */
extern void start_lan(void);
extern void stop_lan(void);
extern void start_wan(void);
extern void start_wan_done(void);
extern void stop_wan(void);
extern int hotplug_net(void);

/* services */
extern int start_dhcpd(int lease);
extern int stop_dhcpd(void);
extern int start_dns(void);
extern int stop_dns(void);
extern int start_nas(char *type);
extern int stop_nas(void);
extern int start_services(void);
extern int stop_services(void);

extern int start_httpd(void);
extern int stop_httpd(void);
extern int start_upnp(void);
extern int stop_upnp(void);
extern int start_ntpclient(void); /*Added by Mark Tien*/
extern int stop_ntpclient(void); /*Added by Mark Tien*/
extern int start_netfilter_log(void); // gmluong, 04/10/02
extern int stop_netfilter_log(void); // gmluong, 04/10/02
extern int start_iappdaemon(void); // gmluong, 06/10/02
extern int stop_iappdaemon(void); // gmluong, 06/10/02
extern int start_parent_control(void); // gmluong, 12/06/02
extern int stop_parent_control(void); // gmluong, 12/06/02
 
/* firewall */
#ifdef NETCONF
extern int start_firewall(void);
extern int stop_firewall(void);
#else
#define start_firewall() do {} while (0)
#define stop_firewall() do {} while (0)
#endif


/* routes */
extern int set_routes(void);

/* ntp */
extern void ntpc_main(char *servers, int timeout);
extern int start_bkserver(void);
extern void set_nsswitch_conf(void);
#endif /* _rc_h_ */
